;; START Auto-generated production rules for `yaml'
(defconst combobulate-rules-yaml 
 '(("alias" (:*unnamed* ("alias_name"))) 
 ("anchor" (:*unnamed* ("anchor_name"))) 
 ("block_mapping" (:*unnamed* ("block_mapping_pair"))) 
 ("block_mapping_pair" (:key ("block_node" "flow_node") :value ("block_node" "flow_node"))) 
 ("block_node" (:*unnamed* ("block_mapping" "anchor" "block_sequence" "block_scalar" "tag"))) 
 ("block_sequence" (:*unnamed* ("block_sequence_item"))) 
 ("block_sequence_item" (:*unnamed* ("block_node" "flow_node"))) 
 ("document" (:*unnamed* ("flow_node" "yaml_directive" "reserved_directive" "block_node" "tag_directive"))) 
 ("double_quote_scalar" (:*unnamed* ("escape_sequence"))) 
 ("flow_mapping" (:*unnamed* ("flow_pair" "flow_node"))) 
 ("flow_node" (:*unnamed* ("single_quote_scalar" "double_quote_scalar" "flow_sequence" "tag" "plain_scalar" "flow_mapping" "anchor" "alias"))) 
 ("flow_pair" (:key ("flow_node") :value ("flow_node"))) 
 ("flow_sequence" (:*unnamed* ("flow_pair" "flow_node"))) 
 ("plain_scalar" (:*unnamed* ("string_scalar" "null_scalar" "boolean_scalar" "float_scalar" "integer_scalar"))) 
 ("reserved_directive" (:*unnamed* ("directive_parameter" "directive_name"))) 
 ("single_quote_scalar" (:*unnamed* ("escape_sequence"))) 
 ("stream" (:*unnamed* ("document"))) 
 ("tag_directive" (:*unnamed* ("tag_handle" "tag_prefix"))) 
 ("yaml_directive" (:*unnamed* ("yaml_version"))) 
))

(defconst combobulate-rules-yaml-inverted 
 '(("alias_name" ("alias"))
   ("anchor_name" ("anchor"))
   ("block_mapping_pair" ("block_mapping"))
   ("block_node" ("block_mapping_pair" "document" "block_sequence_item"))
   ("flow_node" ("document" "block_mapping_pair" "flow_pair" "block_sequence_item" "flow_sequence" "flow_mapping"))
   ("block_mapping" ("block_node"))
   ("anchor" ("block_node" "flow_node"))
   ("block_sequence" ("block_node"))
   ("block_scalar" ("block_node"))
   ("tag" ("block_node" "flow_node"))
   ("block_sequence_item" ("block_sequence"))
   ("yaml_directive" ("document"))
   ("reserved_directive" ("document"))
   ("tag_directive" ("document"))
   ("escape_sequence" ("double_quote_scalar" "single_quote_scalar"))
   ("flow_pair" ("flow_mapping" "flow_sequence"))
   ("single_quote_scalar" ("flow_node"))
   ("double_quote_scalar" ("flow_node"))
   ("flow_sequence" ("flow_node"))
   ("plain_scalar" ("flow_node"))
   ("flow_mapping" ("flow_node"))
   ("alias" ("flow_node"))
   ("string_scalar" ("plain_scalar"))
   ("null_scalar" ("plain_scalar"))
   ("boolean_scalar" ("plain_scalar"))
   ("float_scalar" ("plain_scalar"))
   ("integer_scalar" ("plain_scalar"))
   ("directive_parameter" ("reserved_directive"))
   ("directive_name" ("reserved_directive"))
   ("document" ("stream"))
   ("tag_handle" ("tag_directive"))
   ("tag_prefix" ("tag_directive"))
   ("yaml_version" ("yaml_directive"))
  ) 
)
;; END production rules for yaml





;; START Auto-generated production rules for `tsx'
(defconst combobulate-rules-tsx 
 '(("_primary_type" (:*unnamed* ("object_type" "index_type_query" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("declaration" (:*unnamed* ("internal_module" "lexical_declaration" "type_alias_declaration" "interface_declaration" "class_declaration" "import_alias" "function_signature" "variable_declaration" "abstract_class_declaration" "enum_declaration" "ambient_declaration" "module" "generator_function_declaration" "function_declaration"))) 
 ("expression" (:*unnamed* ("glimmer_template" "binary_expression" "assignment_expression" "augmented_assignment_expression" "ternary_expression" "new_expression" "await_expression" "internal_module" "jsx_self_closing_element" "satisfies_expression" "yield_expression" "jsx_fragment" "jsx_element" "unary_expression" "primary_expression" "as_expression" "update_expression"))) 
 ("pattern" (:*unnamed* ("object_pattern" "undefined" "non_null_expression" "member_expression" "rest_pattern" "array_pattern" "subscript_expression" "identifier"))) 
 ("primary_expression" (:*unnamed* ("undefined" "call_expression" "function" "meta_property" "parenthesized_expression" "object" "string" "template_string" "number" "subscript_expression" "identifier" "false" "class" "arrow_function" "true" "regex" "array" "null" "non_null_expression" "member_expression" "this" "import" "generator_function" "super"))) 
 ("statement" (:*unnamed* ("break_statement" "continue_statement" "try_statement" "import_statement" "debugger_statement" "for_statement" "export_statement" "while_statement" "do_statement" "declaration" "expression_statement" "labeled_statement" "for_in_statement" "throw_statement" "statement_block" "empty_statement" "if_statement" "return_statement" "switch_statement" "with_statement"))) 
 ("abstract_class_declaration" (:*unnamed* ("class_heritage") :body ("class_body") :decorator ("decorator") :name ("type_identifier") :type_parameters ("type_parameters"))) 
 ("abstract_method_signature" (:*unnamed* ("accessibility_modifier") :name ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :parameters ("formal_parameters") :return_type ("type_annotation" "asserts" "type_predicate_annotation") :type_parameters ("type_parameters"))) 
 ("ambient_declaration" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "property_identifier" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "declaration" "array_type" "predefined_type" "union_type" "parenthesized_type" "statement_block" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("arguments" (:*unnamed* ("spread_element" "expression"))) 
 ("array" (:*unnamed* ("spread_element" "expression"))) 
 ("array_pattern" (:*unnamed* ("assignment_pattern" "pattern"))) 
 ("array_type" (:*unnamed* ("object_type" "index_type_query" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("arrow_function" (:body ("statement_block" "expression") :parameter ("identifier") :parameters ("formal_parameters") :return_type ("type_annotation" "asserts" "type_predicate_annotation") :type_parameters ("type_parameters"))) 
 ("as_expression" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "expression" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("asserts" (:*unnamed* ("type_predicate" "identifier" "this"))) 
 ("assignment_expression" (:left ("object_pattern" "undefined" "non_null_expression" "member_expression" "parenthesized_expression" "array_pattern" "subscript_expression" "identifier") :right ("expression"))) 
 ("assignment_pattern" (:left ("pattern") :right ("expression"))) 
 ("augmented_assignment_expression" (:left ("subscript_expression" "identifier" "non_null_expression" "member_expression" "parenthesized_expression") :operator nil :right ("expression"))) 
 ("await_expression" (:*unnamed* ("expression"))) 
 ("binary_expression" (:left ("expression") :operator nil :right ("expression"))) 
 ("break_statement" (:label ("statement_identifier"))) 
 ("call_expression" (:arguments ("template_string" "arguments") :function ("expression") :type_arguments ("type_arguments"))) 
 ("call_signature" (:parameters ("formal_parameters") :return_type ("type_annotation" "asserts" "type_predicate_annotation") :type_parameters ("type_parameters"))) 
 ("catch_clause" (:body ("statement_block") :parameter ("object_pattern" "identifier" "array_pattern") :type ("type_annotation"))) 
 ("class" (:*unnamed* ("class_heritage") :body ("class_body") :decorator ("decorator") :name ("type_identifier") :type_parameters ("type_parameters"))) 
 ("class_body" (:*unnamed* ("method_signature" "decorator" "class_static_block" "public_field_definition" "abstract_method_signature" "method_definition" "index_signature"))) 
 ("class_declaration" (:*unnamed* ("class_heritage") :body ("class_body") :decorator ("decorator") :name ("type_identifier") :type_parameters ("type_parameters"))) 
 ("class_heritage" (:*unnamed* ("extends_clause" "implements_clause"))) 
 ("class_static_block" (:body ("statement_block"))) 
 ("computed_property_name" (:*unnamed* ("expression"))) 
 ("conditional_type" (:alternative ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type") :consequence ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type") :left ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type") :right ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("constraint" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("construct_signature" (:parameters ("formal_parameters") :type ("type_annotation") :type_parameters ("type_parameters"))) 
 ("constructor_type" (:parameters ("formal_parameters") :type ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type") :type_parameters ("type_parameters"))) 
 ("continue_statement" (:label ("statement_identifier"))) 
 ("decorator" (:*unnamed* ("identifier" "member_expression" "call_expression"))) 
 ("default_type" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("do_statement" (:body ("statement") :condition ("parenthesized_expression"))) 
 ("else_clause" (:*unnamed* ("statement"))) 
 ("enum_assignment" (:name ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :value ("expression"))) 
 ("enum_body" (:*unnamed* ("enum_assignment") :name ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier"))) 
 ("enum_declaration" (:body ("enum_body") :name ("identifier"))) 
 ("export_clause" (:*unnamed* ("export_specifier"))) 
 ("export_specifier" (:alias ("string" "identifier") :name ("string" "identifier"))) 
 ("export_statement" (:*unnamed* ("namespace_export" "export_clause" "expression" "identifier") :declaration ("declaration") :decorator ("decorator") :source ("string") :value ("expression"))) 
 ("expression_statement" (:*unnamed* ("sequence_expression" "expression"))) 
 ("extends_clause" (:type_arguments ("type_arguments") :value ("expression"))) 
 ("extends_type_clause" (:type ("nested_type_identifier" "type_identifier" "generic_type"))) 
 ("finally_clause" (:body ("statement_block"))) 
 ("flow_maybe_type" (:*unnamed* ("object_type" "index_type_query" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("for_in_statement" (:body ("statement") :kind nil :left ("object_pattern" "undefined" "non_null_expression" "member_expression" "parenthesized_expression" "array_pattern" "subscript_expression" "identifier") :operator nil :right ("sequence_expression" "expression") :value ("expression"))) 
 ("for_statement" (:body ("statement") :condition ("expression_statement" "empty_statement") :increment ("sequence_expression" "expression") :initializer ("expression_statement" "lexical_declaration" "variable_declaration" "empty_statement"))) 
 ("formal_parameters" (:*unnamed* ("required_parameter" "optional_parameter"))) 
 ("function" (:body ("statement_block") :name ("identifier") :parameters ("formal_parameters") :return_type ("type_annotation" "asserts" "type_predicate_annotation") :type_parameters ("type_parameters"))) 
 ("function_declaration" (:body ("statement_block") :name ("identifier") :parameters ("formal_parameters") :return_type ("type_annotation" "asserts" "type_predicate_annotation") :type_parameters ("type_parameters"))) 
 ("function_signature" (:name ("identifier") :parameters ("formal_parameters") :return_type ("type_annotation" "asserts" "type_predicate_annotation") :type_parameters ("type_parameters"))) 
 ("function_type" (:parameters ("formal_parameters") :return_type ("type_predicate" "object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type") :type_parameters ("type_parameters"))) 
 ("generator_function" (:body ("statement_block") :name ("identifier") :parameters ("formal_parameters") :return_type ("type_annotation" "asserts" "type_predicate_annotation") :type_parameters ("type_parameters"))) 
 ("generator_function_declaration" (:body ("statement_block") :name ("identifier") :parameters ("formal_parameters") :return_type ("type_annotation" "asserts" "type_predicate_annotation") :type_parameters ("type_parameters"))) 
 ("generic_type" (:name ("nested_type_identifier" "type_identifier") :type_arguments ("type_arguments"))) 
 ("glimmer_template" (:close_tag ("glimmer_closing_tag") :open_tag ("glimmer_opening_tag"))) 
 ("if_statement" (:alternative ("else_clause") :condition ("parenthesized_expression") :consequence ("statement"))) 
 ("implements_clause" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("import_alias" (:*unnamed* ("identifier" "nested_identifier"))) 
 ("import_clause" (:*unnamed* ("namespace_import" "identifier" "named_imports"))) 
 ("import_require_clause" (:*unnamed* ("identifier") :source ("string"))) 
 ("import_specifier" (:alias ("identifier") :name ("string" "identifier"))) 
 ("import_statement" (:*unnamed* ("import_require_clause" "import_clause") :source ("string"))) 
 ("index_signature" (:*unnamed* ("mapped_type_clause") :index_type ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type") :name ("identifier") :sign nil :type ("type_annotation" "omitting_type_annotation" "opting_type_annotation"))) 
 ("index_type_query" (:*unnamed* ("object_type" "index_type_query" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("infer_type" (:*unnamed* ("type_identifier"))) 
 ("interface_declaration" (:*unnamed* ("extends_type_clause") :body ("object_type") :name ("type_identifier") :type_parameters ("type_parameters"))) 
 ("internal_module" (:body ("statement_block") :name ("string" "identifier" "nested_identifier"))) 
 ("intersection_type" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("jsx_attribute" (:*unnamed* ("property_identifier" "string" "jsx_namespace_name" "jsx_self_closing_element" "jsx_expression" "jsx_fragment" "jsx_element"))) 
 ("jsx_closing_element" (:name ("identifier" "jsx_namespace_name" "nested_identifier"))) 
 ("jsx_element" (:*unnamed* ("jsx_self_closing_element" "jsx_expression" "jsx_text" "jsx_fragment" "jsx_element") :close_tag ("jsx_closing_element") :open_tag ("jsx_opening_element"))) 
 ("jsx_expression" (:*unnamed* ("sequence_expression" "spread_element" "expression"))) 
 ("jsx_fragment" (:*unnamed* ("jsx_self_closing_element" "jsx_expression" "jsx_text" "jsx_fragment" "jsx_element"))) 
 ("jsx_namespace_name" (:*unnamed* ("identifier"))) 
 ("jsx_opening_element" (:attribute ("jsx_attribute" "jsx_expression") :name ("identifier" "jsx_namespace_name" "nested_identifier") :type_arguments ("type_arguments"))) 
 ("jsx_self_closing_element" (:attribute ("jsx_attribute" "jsx_expression") :name ("identifier" "jsx_namespace_name" "nested_identifier") :type_arguments ("type_arguments"))) 
 ("labeled_statement" (:body ("statement") :label ("statement_identifier"))) 
 ("lexical_declaration" (:*unnamed* ("variable_declarator") :kind nil)) 
 ("literal_type" (:*unnamed* ("string" "false" "undefined" "unary_expression" "number" "null" "true"))) 
 ("lookup_type" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("mapped_type_clause" (:alias ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type") :name ("type_identifier") :type ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("member_expression" (:object ("expression") :optional_chain ("optional_chain") :property ("property_identifier" "private_property_identifier"))) 
 ("method_definition" (:*unnamed* ("override_modifier" "accessibility_modifier") :body ("statement_block") :name ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :parameters ("formal_parameters") :return_type ("type_annotation" "asserts" "type_predicate_annotation") :type_parameters ("type_parameters"))) 
 ("method_signature" (:*unnamed* ("override_modifier" "accessibility_modifier") :name ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :parameters ("formal_parameters") :return_type ("type_annotation" "asserts" "type_predicate_annotation") :type_parameters ("type_parameters"))) 
 ("module" (:body ("statement_block") :name ("string" "identifier" "nested_identifier"))) 
 ("named_imports" (:*unnamed* ("import_specifier"))) 
 ("namespace_export" (:*unnamed* ("string" "identifier"))) 
 ("namespace_import" (:*unnamed* ("identifier"))) 
 ("nested_identifier" (:*unnamed* ("identifier" "nested_identifier"))) 
 ("nested_type_identifier" (:module ("identifier" "nested_identifier") :name ("type_identifier"))) 
 ("new_expression" (:arguments ("arguments") :constructor ("primary_expression") :type_arguments ("type_arguments"))) 
 ("non_null_expression" (:*unnamed* ("expression"))) 
 ("object" (:*unnamed* ("spread_element" "method_definition" "shorthand_property_identifier" "pair"))) 
 ("object_assignment_pattern" (:left ("object_pattern" "shorthand_property_identifier_pattern" "array_pattern") :right ("expression"))) 
 ("object_pattern" (:*unnamed* ("object_assignment_pattern" "pair_pattern" "shorthand_property_identifier_pattern" "rest_pattern"))) 
 ("object_type" (:*unnamed* ("call_signature" "method_signature" "construct_signature" "property_signature" "export_statement" "index_signature"))) 
 ("omitting_type_annotation" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("opting_type_annotation" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("optional_parameter" (:*unnamed* ("override_modifier" "accessibility_modifier") :decorator ("decorator") :name ("identifier") :pattern ("this" "pattern") :type ("type_annotation") :value ("expression"))) 
 ("optional_type" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("pair" (:key ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :value ("expression"))) 
 ("pair_pattern" (:key ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :value ("assignment_pattern" "pattern"))) 
 ("parenthesized_expression" (:*unnamed* ("sequence_expression" "expression") :type ("type_annotation"))) 
 ("parenthesized_type" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("program" (:*unnamed* ("statement" "hash_bang_line"))) 
 ("property_signature" (:*unnamed* ("override_modifier" "accessibility_modifier") :name ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :type ("type_annotation"))) 
 ("public_field_definition" (:*unnamed* ("override_modifier" "accessibility_modifier") :name ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :type ("type_annotation") :value ("expression"))) 
 ("readonly_type" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("regex" (:flags ("regex_flags") :pattern ("regex_pattern"))) 
 ("required_parameter" (:*unnamed* ("override_modifier" "accessibility_modifier") :decorator ("decorator") :name ("identifier" "rest_pattern") :pattern ("this" "pattern") :type ("type_annotation") :value ("expression"))) 
 ("rest_pattern" (:*unnamed* ("object_pattern" "undefined" "array_pattern" "subscript_expression" "identifier" "non_null_expression" "member_expression"))) 
 ("rest_type" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("return_statement" (:*unnamed* ("sequence_expression" "expression"))) 
 ("satisfies_expression" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "expression" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("sequence_expression" (:left ("expression") :right ("sequence_expression" "expression"))) 
 ("spread_element" (:*unnamed* ("expression"))) 
 ("statement_block" (:*unnamed* ("statement"))) 
 ("string" (:*unnamed* ("escape_sequence" "string_fragment"))) 
 ("subscript_expression" (:index ("string" "number" "sequence_expression" "predefined_type" "expression") :object ("expression") :optional_chain ("optional_chain"))) 
 ("switch_body" (:*unnamed* ("switch_default" "switch_case"))) 
 ("switch_case" (:body ("statement") :value ("sequence_expression" "expression"))) 
 ("switch_default" (:body ("statement"))) 
 ("switch_statement" (:body ("switch_body") :value ("parenthesized_expression"))) 
 ("template_literal_type" (:*unnamed* ("template_type"))) 
 ("template_string" (:*unnamed* ("escape_sequence" "template_substitution"))) 
 ("template_substitution" (:*unnamed* ("sequence_expression" "expression"))) 
 ("template_type" (:*unnamed* ("object_type" "index_type_query" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("ternary_expression" (:alternative ("expression") :condition ("expression") :consequence ("expression"))) 
 ("throw_statement" (:*unnamed* ("sequence_expression" "expression"))) 
 ("try_statement" (:body ("statement_block") :finalizer ("finally_clause") :handler ("catch_clause"))) 
 ("tuple_type" (:*unnamed* ("optional_parameter" "required_parameter" "object_type" "index_type_query" "constructor_type" "optional_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "rest_type" "intersection_type" "template_literal_type"))) 
 ("type_alias_declaration" (:name ("type_identifier") :type_parameters ("type_parameters") :value ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("type_annotation" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("type_arguments" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("type_parameter" (:constraint ("constraint") :name ("type_identifier") :value ("default_type"))) 
 ("type_parameters" (:*unnamed* ("type_parameter"))) 
 ("type_predicate" (:name ("identifier" "this") :type ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("type_predicate_annotation" (:*unnamed* ("type_predicate"))) 
 ("type_query" (:*unnamed* ("subscript_expression" "identifier" "member_expression" "call_expression"))) 
 ("unary_expression" (:argument ("expression" "number") :operator nil)) 
 ("union_type" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("update_expression" (:argument ("expression") :operator nil)) 
 ("variable_declaration" (:*unnamed* ("variable_declarator"))) 
 ("variable_declarator" (:name ("object_pattern" "identifier" "array_pattern") :type ("type_annotation") :value ("expression"))) 
 ("while_statement" (:body ("statement") :condition ("parenthesized_expression"))) 
 ("with_statement" (:body ("statement") :object ("parenthesized_expression"))) 
 ("yield_expression" (:*unnamed* ("expression"))) 
))

(defconst combobulate-rules-tsx-inverted 
 '(("object_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "interface_declaration" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("index_type_query" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("this_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("existential_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("conditional_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("generic_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "extends_type_clause" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("lookup_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("literal_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("type_identifier" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "type_parameter" "default_type" "lookup_type" "ambient_declaration" "class" "_primary_type" "extends_type_clause" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "class_declaration" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "interface_declaration" "mapped_type_clause" "constraint" "conditional_type" "generic_type" "abstract_class_declaration" "type_alias_declaration" "parenthesized_type" "nested_type_identifier" "infer_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("array_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("predefined_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "subscript_expression" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("union_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("parenthesized_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("type_query" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("nested_type_identifier" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "extends_type_clause" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "generic_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("tuple_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("flow_maybe_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("intersection_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("template_literal_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("internal_module" ("expression" "declaration"))
   ("lexical_declaration" ("for_statement" "declaration"))
   ("type_alias_declaration" ("declaration"))
   ("interface_declaration" ("declaration"))
   ("class_declaration" ("declaration"))
   ("import_alias" ("declaration"))
   ("function_signature" ("declaration"))
   ("variable_declaration" ("for_statement" "declaration"))
   ("abstract_class_declaration" ("declaration"))
   ("enum_declaration" ("declaration"))
   ("ambient_declaration" ("declaration"))
   ("module" ("declaration"))
   ("generator_function_declaration" ("declaration"))
   ("function_declaration" ("declaration"))
   ("glimmer_template" ("expression"))
   ("binary_expression" ("expression"))
   ("assignment_expression" ("expression"))
   ("augmented_assignment_expression" ("expression"))
   ("ternary_expression" ("expression"))
   ("new_expression" ("expression"))
   ("await_expression" ("expression"))
   ("jsx_self_closing_element" ("jsx_fragment" "jsx_element" "jsx_attribute" "expression"))
   ("satisfies_expression" ("expression"))
   ("yield_expression" ("expression"))
   ("jsx_fragment" ("jsx_fragment" "jsx_element" "jsx_attribute" "expression"))
   ("jsx_element" ("jsx_fragment" "jsx_element" "jsx_attribute" "expression"))
   ("unary_expression" ("expression" "literal_type"))
   ("primary_expression" ("expression" "new_expression"))
   ("as_expression" ("expression"))
   ("update_expression" ("expression"))
   ("object_pattern" ("assignment_expression" "object_assignment_pattern" "for_in_statement" "variable_declarator" "rest_pattern" "catch_clause" "pattern"))
   ("undefined" ("assignment_expression" "for_in_statement" "rest_pattern" "primary_expression" "literal_type" "pattern"))
   ("non_null_expression" ("assignment_expression" "for_in_statement" "augmented_assignment_expression" "rest_pattern" "primary_expression" "pattern"))
   ("member_expression" ("assignment_expression" "decorator" "for_in_statement" "type_query" "augmented_assignment_expression" "rest_pattern" "primary_expression" "pattern"))
   ("rest_pattern" ("object_pattern" "required_parameter" "pattern"))
   ("array_pattern" ("assignment_expression" "object_assignment_pattern" "for_in_statement" "variable_declarator" "rest_pattern" "catch_clause" "pattern"))
   ("subscript_expression" ("assignment_expression" "for_in_statement" "type_query" "augmented_assignment_expression" "rest_pattern" "primary_expression" "pattern"))
   ("identifier" ("required_parameter" "type_predicate" "assignment_expression" "jsx_opening_element" "function" "import_specifier" "function_signature" "jsx_closing_element" "import_require_clause" "export_statement" "export_specifier" "function_declaration" "arrow_function" "internal_module" "jsx_self_closing_element" "decorator" "for_in_statement" "generator_function" "asserts" "optional_parameter" "generator_function_declaration" "import_clause" "augmented_assignment_expression" "jsx_namespace_name" "module" "namespace_export" "import_alias" "variable_declarator" "type_query" "nested_type_identifier" "rest_pattern" "primary_expression" "nested_identifier" "enum_declaration" "namespace_import" "index_signature" "catch_clause" "pattern"))
   ("call_expression" ("primary_expression" "decorator" "type_query"))
   ("function" ("primary_expression"))
   ("meta_property" ("primary_expression"))
   ("parenthesized_expression" ("do_statement" "assignment_expression" "for_in_statement" "augmented_assignment_expression" "if_statement" "primary_expression" "switch_statement" "with_statement" "while_statement"))
   ("object" ("primary_expression"))
   ("string" ("import_specifier" "import_statement" "pair_pattern" "import_require_clause" "public_field_definition" "literal_type" "export_statement" "export_specifier" "internal_module" "method_signature" "method_definition" "property_signature" "jsx_attribute" "subscript_expression" "module" "namespace_export" "enum_body" "pair" "enum_assignment" "primary_expression" "abstract_method_signature"))
   ("template_string" ("primary_expression" "call_expression"))
   ("number" ("enum_body" "method_signature" "method_definition" "pair" "enum_assignment" "pair_pattern" "unary_expression" "primary_expression" "public_field_definition" "literal_type" "subscript_expression" "abstract_method_signature" "property_signature"))
   ("false" ("primary_expression" "literal_type"))
   ("class" ("primary_expression"))
   ("arrow_function" ("primary_expression"))
   ("true" ("primary_expression" "literal_type"))
   ("regex" ("primary_expression"))
   ("array" ("primary_expression"))
   ("null" ("primary_expression" "literal_type"))
   ("this" ("required_parameter" "type_predicate" "asserts" "primary_expression" "optional_parameter"))
   ("import" ("primary_expression"))
   ("generator_function" ("primary_expression"))
   ("super" ("primary_expression"))
   ("break_statement" ("statement"))
   ("continue_statement" ("statement"))
   ("try_statement" ("statement"))
   ("import_statement" ("statement"))
   ("debugger_statement" ("statement"))
   ("for_statement" ("statement"))
   ("export_statement" ("statement" "object_type"))
   ("while_statement" ("statement"))
   ("do_statement" ("statement"))
   ("declaration" ("ambient_declaration" "statement" "export_statement"))
   ("expression_statement" ("statement" "for_statement"))
   ("labeled_statement" ("statement"))
   ("for_in_statement" ("statement"))
   ("throw_statement" ("statement"))
   ("statement_block" ("internal_module" "class_static_block" "function" "method_definition" "try_statement" "finally_clause" "statement" "generator_function" "generator_function_declaration" "ambient_declaration" "module" "catch_clause" "arrow_function" "function_declaration"))
   ("empty_statement" ("statement" "for_statement"))
   ("if_statement" ("statement"))
   ("return_statement" ("statement"))
   ("switch_statement" ("statement"))
   ("with_statement" ("statement"))
   ("class_heritage" ("class_declaration" "class" "abstract_class_declaration"))
   ("class_body" ("class_declaration" "class" "abstract_class_declaration"))
   ("decorator" ("optional_parameter" "required_parameter" "class_declaration" "abstract_class_declaration" "class_body" "export_statement" "class"))
   ("type_parameters" ("call_signature" "constructor_type" "method_signature" "function" "construct_signature" "interface_declaration" "method_definition" "class_declaration" "type_alias_declaration" "function_signature" "generator_function" "abstract_class_declaration" "generator_function_declaration" "abstract_method_signature" "function_type" "class" "arrow_function" "function_declaration"))
   ("accessibility_modifier" ("required_parameter" "method_signature" "method_definition" "public_field_definition" "optional_parameter" "abstract_method_signature" "property_signature"))
   ("private_property_identifier" ("enum_body" "method_signature" "method_definition" "member_expression" "enum_assignment" "pair" "pair_pattern" "public_field_definition" "abstract_method_signature" "property_signature"))
   ("computed_property_name" ("enum_body" "method_signature" "method_definition" "pair" "enum_assignment" "pair_pattern" "public_field_definition" "abstract_method_signature" "property_signature"))
   ("property_identifier" ("ambient_declaration" "jsx_attribute" "enum_body" "method_signature" "method_definition" "member_expression" "enum_assignment" "pair" "pair_pattern" "public_field_definition" "abstract_method_signature" "property_signature"))
   ("formal_parameters" ("call_signature" "constructor_type" "method_signature" "function" "construct_signature" "method_definition" "function_signature" "generator_function" "generator_function_declaration" "abstract_method_signature" "function_type" "arrow_function" "function_declaration"))
   ("type_annotation" ("required_parameter" "function" "function_signature" "parenthesized_expression" "public_field_definition" "arrow_function" "function_declaration" "method_signature" "catch_clause" "construct_signature" "method_definition" "generator_function" "optional_parameter" "generator_function_declaration" "property_signature" "call_signature" "abstract_method_signature" "index_signature" "variable_declarator"))
   ("asserts" ("call_signature" "method_signature" "function" "method_definition" "arrow_function" "function_signature" "generator_function" "generator_function_declaration" "abstract_method_signature" "function_declaration"))
   ("type_predicate_annotation" ("call_signature" "method_signature" "function" "method_definition" "arrow_function" "function_signature" "generator_function" "generator_function_declaration" "abstract_method_signature" "function_declaration"))
   ("constructor_type" ("type_predicate" "optional_type" "constructor_type" "default_type" "lookup_type" "ambient_declaration" "satisfies_expression" "implements_clause" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "function_type" "index_signature" "intersection_type"))
   ("readonly_type" ("type_predicate" "optional_type" "constructor_type" "default_type" "lookup_type" "ambient_declaration" "satisfies_expression" "implements_clause" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "function_type" "index_signature" "intersection_type"))
   ("function_type" ("type_predicate" "optional_type" "constructor_type" "default_type" "lookup_type" "ambient_declaration" "satisfies_expression" "implements_clause" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "function_type" "index_signature" "intersection_type"))
   ("infer_type" ("type_predicate" "optional_type" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "satisfies_expression" "implements_clause" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "function_type" "index_signature" "intersection_type"))
   ("spread_element" ("array" "object" "jsx_expression" "arguments"))
   ("expression" ("required_parameter" "binary_expression" "assignment_expression" "arguments" "spread_element" "assignment_pattern" "parenthesized_expression" "public_field_definition" "for_statement" "export_statement" "ternary_expression" "arrow_function" "await_expression" "satisfies_expression" "yield_expression" "array" "expression_statement" "for_in_statement" "non_null_expression" "member_expression" "throw_statement" "jsx_expression" "as_expression" "optional_parameter" "return_statement" "update_expression" "call_expression" "template_substitution" "augmented_assignment_expression" "switch_case" "subscript_expression" "sequence_expression" "extends_clause" "object_assignment_pattern" "pair" "enum_assignment" "unary_expression" "computed_property_name" "variable_declarator"))
   ("assignment_pattern" ("pair_pattern" "array_pattern"))
   ("pattern" ("required_parameter" "assignment_pattern" "pair_pattern" "array_pattern" "optional_parameter"))
   ("type_predicate" ("function_type" "asserts" "type_predicate_annotation"))
   ("statement_identifier" ("labeled_statement" "break_statement" "continue_statement"))
   ("arguments" ("new_expression" "call_expression"))
   ("type_arguments" ("extends_clause" "jsx_self_closing_element" "call_expression" "jsx_opening_element" "generic_type" "new_expression"))
   ("method_signature" ("class_body" "object_type"))
   ("class_static_block" ("class_body"))
   ("public_field_definition" ("class_body"))
   ("abstract_method_signature" ("class_body"))
   ("method_definition" ("class_body" "object"))
   ("index_signature" ("class_body" "object_type"))
   ("extends_clause" ("class_heritage"))
   ("implements_clause" ("class_heritage"))
   ("statement" ("do_statement" "labeled_statement" "for_in_statement" "statement_block" "switch_default" "if_statement" "else_clause" "while_statement" "switch_case" "for_statement" "with_statement" "program"))
   ("enum_assignment" ("enum_body"))
   ("enum_body" ("enum_declaration"))
   ("export_specifier" ("export_clause"))
   ("namespace_export" ("export_statement"))
   ("export_clause" ("export_statement"))
   ("sequence_expression" ("expression_statement" "for_in_statement" "throw_statement" "template_substitution" "parenthesized_expression" "jsx_expression" "return_statement" "switch_case" "subscript_expression" "sequence_expression" "for_statement"))
   ("required_parameter" ("formal_parameters" "tuple_type"))
   ("optional_parameter" ("formal_parameters" "tuple_type"))
   ("glimmer_closing_tag" ("glimmer_template"))
   ("glimmer_opening_tag" ("glimmer_template"))
   ("else_clause" ("if_statement"))
   ("nested_identifier" ("internal_module" "jsx_self_closing_element" "jsx_opening_element" "import_alias" "nested_type_identifier" "jsx_closing_element" "nested_identifier" "module"))
   ("namespace_import" ("import_clause"))
   ("named_imports" ("import_clause"))
   ("import_require_clause" ("import_statement"))
   ("import_clause" ("import_statement"))
   ("mapped_type_clause" ("index_signature"))
   ("omitting_type_annotation" ("index_signature"))
   ("opting_type_annotation" ("index_signature"))
   ("extends_type_clause" ("interface_declaration"))
   ("jsx_namespace_name" ("jsx_self_closing_element" "jsx_attribute" "jsx_closing_element" "jsx_opening_element"))
   ("jsx_expression" ("jsx_attribute" "jsx_self_closing_element" "jsx_opening_element" "jsx_fragment" "jsx_element"))
   ("jsx_text" ("jsx_fragment" "jsx_element"))
   ("jsx_closing_element" ("jsx_element"))
   ("jsx_opening_element" ("jsx_element"))
   ("jsx_attribute" ("jsx_self_closing_element" "jsx_opening_element"))
   ("variable_declarator" ("variable_declaration" "lexical_declaration"))
   ("optional_chain" ("subscript_expression" "member_expression"))
   ("override_modifier" ("required_parameter" "method_signature" "method_definition" "public_field_definition" "optional_parameter" "property_signature"))
   ("import_specifier" ("named_imports"))
   ("shorthand_property_identifier" ("object"))
   ("pair" ("object"))
   ("shorthand_property_identifier_pattern" ("object_pattern" "object_assignment_pattern"))
   ("object_assignment_pattern" ("object_pattern"))
   ("pair_pattern" ("object_pattern"))
   ("call_signature" ("object_type"))
   ("construct_signature" ("object_type"))
   ("property_signature" ("object_type"))
   ("hash_bang_line" ("program"))
   ("regex_flags" ("regex"))
   ("regex_pattern" ("regex"))
   ("escape_sequence" ("string" "template_string"))
   ("string_fragment" ("string"))
   ("switch_default" ("switch_body"))
   ("switch_case" ("switch_body"))
   ("switch_body" ("switch_statement"))
   ("template_type" ("template_literal_type"))
   ("template_substitution" ("template_string"))
   ("finally_clause" ("try_statement"))
   ("catch_clause" ("try_statement"))
   ("optional_type" ("tuple_type"))
   ("rest_type" ("tuple_type"))
   ("constraint" ("type_parameter"))
   ("default_type" ("type_parameter"))
   ("type_parameter" ("type_parameters"))
  ) 
)
;; END production rules for tsx





;; START Auto-generated production rules for `css'
(defconst combobulate-rules-css 
 '(("adjacent_sibling_selector" (:*unnamed* ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "sibling_selector" "pseudo_element_selector" "universal_selector" "adjacent_sibling_selector" "tag_name" "class_selector" "string_value" "nesting_selector"))) 
 ("arguments" (:*unnamed* ("pseudo_class_selector" "float_value" "binary_expression" "descendant_selector" "call_expression" "parenthesized_value" "pseudo_element_selector" "color_value" "universal_selector" "plain_value" "integer_value" "child_selector" "attribute_selector" "id_selector" "sibling_selector" "adjacent_sibling_selector" "tag_name" "class_selector" "string_value" "nesting_selector"))) 
 ("at_rule" (:*unnamed* ("feature_query" "keyword_query" "at_keyword" "binary_query" "unary_query" "selector_query" "parenthesized_query" "block"))) 
 ("attribute_selector" (:*unnamed* ("pseudo_class_selector" "float_value" "binary_expression" "descendant_selector" "call_expression" "parenthesized_value" "pseudo_element_selector" "color_value" "universal_selector" "plain_value" "integer_value" "child_selector" "attribute_selector" "id_selector" "sibling_selector" "attribute_name" "adjacent_sibling_selector" "tag_name" "class_selector" "string_value" "nesting_selector"))) 
 ("binary_expression" (:*unnamed* ("float_value" "integer_value" "binary_expression" "call_expression" "parenthesized_value" "color_value" "plain_value" "string_value"))) 
 ("binary_query" (:*unnamed* ("unary_query" "feature_query" "binary_query" "keyword_query" "selector_query" "parenthesized_query"))) 
 ("block" (:*unnamed* ("declaration" "at_rule" "charset_statement" "rule_set" "import_statement" "media_statement" "namespace_statement" "keyframes_statement" "supports_statement"))) 
 ("call_expression" (:*unnamed* ("function_name" "arguments"))) 
 ("charset_statement" (:*unnamed* ("float_value" "integer_value" "binary_expression" "call_expression" "parenthesized_value" "color_value" "plain_value" "string_value"))) 
 ("child_selector" (:*unnamed* ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "sibling_selector" "pseudo_element_selector" "universal_selector" "adjacent_sibling_selector" "tag_name" "class_selector" "string_value" "nesting_selector"))) 
 ("class_selector" (:*unnamed* ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "sibling_selector" "pseudo_element_selector" "universal_selector" "class_name" "adjacent_sibling_selector" "tag_name" "class_selector" "string_value" "nesting_selector"))) 
 ("declaration" (:*unnamed* ("float_value" "integer_value" "binary_expression" "call_expression" "important" "parenthesized_value" "property_name" "color_value" "plain_value" "string_value"))) 
 ("descendant_selector" (:*unnamed* ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "sibling_selector" "pseudo_element_selector" "universal_selector" "adjacent_sibling_selector" "tag_name" "class_selector" "string_value" "nesting_selector"))) 
 ("feature_query" (:*unnamed* ("float_value" "integer_value" "binary_expression" "call_expression" "parenthesized_value" "feature_name" "color_value" "plain_value" "string_value"))) 
 ("float_value" (:*unnamed* ("unit"))) 
 ("id_selector" (:*unnamed* ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "sibling_selector" "pseudo_element_selector" "universal_selector" "adjacent_sibling_selector" "tag_name" "class_selector" "id_name" "string_value" "nesting_selector"))) 
 ("import_statement" (:*unnamed* ("float_value" "integer_value" "binary_expression" "string_value" "call_expression" "feature_query" "keyword_query" "parenthesized_value" "color_value" "binary_query" "plain_value" "unary_query" "selector_query" "parenthesized_query"))) 
 ("integer_value" (:*unnamed* ("unit"))) 
 ("keyframe_block" (:*unnamed* ("integer_value" "block" "to" "from"))) 
 ("keyframe_block_list" (:*unnamed* ("keyframe_block"))) 
 ("keyframes_statement" (:*unnamed* ("keyframe_block_list" "keyframes_name" "at_keyword"))) 
 ("media_statement" (:*unnamed* ("unary_query" "feature_query" "binary_query" "keyword_query" "selector_query" "parenthesized_query" "block"))) 
 ("namespace_statement" (:*unnamed* ("namespace_name" "call_expression" "string_value"))) 
 ("parenthesized_query" (:*unnamed* ("unary_query" "feature_query" "binary_query" "keyword_query" "selector_query" "parenthesized_query"))) 
 ("parenthesized_value" (:*unnamed* ("float_value" "integer_value" "binary_expression" "call_expression" "parenthesized_value" "color_value" "plain_value" "string_value"))) 
 ("pseudo_class_selector" (:*unnamed* ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "arguments" "sibling_selector" "pseudo_element_selector" "universal_selector" "class_name" "adjacent_sibling_selector" "tag_name" "class_selector" "string_value" "nesting_selector"))) 
 ("pseudo_element_selector" (:*unnamed* ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "sibling_selector" "pseudo_element_selector" "universal_selector" "adjacent_sibling_selector" "tag_name" "class_selector" "string_value" "nesting_selector"))) 
 ("rule_set" (:*unnamed* ("block" "selectors"))) 
 ("selector_query" (:*unnamed* ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "sibling_selector" "pseudo_element_selector" "universal_selector" "adjacent_sibling_selector" "tag_name" "class_selector" "string_value" "nesting_selector"))) 
 ("selectors" (:*unnamed* ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "sibling_selector" "pseudo_element_selector" "universal_selector" "adjacent_sibling_selector" "tag_name" "class_selector" "string_value" "nesting_selector"))) 
 ("sibling_selector" (:*unnamed* ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "sibling_selector" "pseudo_element_selector" "universal_selector" "adjacent_sibling_selector" "tag_name" "class_selector" "string_value" "nesting_selector"))) 
 ("stylesheet" (:*unnamed* ("declaration" "at_rule" "charset_statement" "rule_set" "import_statement" "media_statement" "namespace_statement" "keyframes_statement" "supports_statement"))) 
 ("supports_statement" (:*unnamed* ("unary_query" "feature_query" "binary_query" "keyword_query" "selector_query" "parenthesized_query" "block"))) 
 ("unary_query" (:*unnamed* ("unary_query" "feature_query" "binary_query" "keyword_query" "selector_query" "parenthesized_query"))) 
))

(defconst combobulate-rules-css-inverted 
 '(("pseudo_class_selector" ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "arguments" "sibling_selector" "pseudo_element_selector" "selectors" "adjacent_sibling_selector" "class_selector" "selector_query"))
   ("child_selector" ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "arguments" "sibling_selector" "pseudo_element_selector" "selectors" "adjacent_sibling_selector" "class_selector" "selector_query"))
   ("attribute_selector" ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "arguments" "sibling_selector" "pseudo_element_selector" "selectors" "adjacent_sibling_selector" "class_selector" "selector_query"))
   ("id_selector" ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "arguments" "sibling_selector" "pseudo_element_selector" "selectors" "adjacent_sibling_selector" "class_selector" "selector_query"))
   ("descendant_selector" ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "arguments" "sibling_selector" "pseudo_element_selector" "selectors" "adjacent_sibling_selector" "class_selector" "selector_query"))
   ("sibling_selector" ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "arguments" "sibling_selector" "pseudo_element_selector" "selectors" "adjacent_sibling_selector" "class_selector" "selector_query"))
   ("pseudo_element_selector" ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "arguments" "sibling_selector" "pseudo_element_selector" "selectors" "adjacent_sibling_selector" "class_selector" "selector_query"))
   ("universal_selector" ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "arguments" "sibling_selector" "pseudo_element_selector" "selectors" "adjacent_sibling_selector" "class_selector" "selector_query"))
   ("adjacent_sibling_selector" ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "arguments" "sibling_selector" "pseudo_element_selector" "selectors" "adjacent_sibling_selector" "class_selector" "selector_query"))
   ("tag_name" ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "arguments" "sibling_selector" "pseudo_element_selector" "selectors" "adjacent_sibling_selector" "class_selector" "selector_query"))
   ("class_selector" ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "arguments" "sibling_selector" "pseudo_element_selector" "selectors" "adjacent_sibling_selector" "class_selector" "selector_query"))
   ("string_value" ("binary_expression" "descendant_selector" "arguments" "feature_query" "pseudo_element_selector" "import_statement" "namespace_statement" "selector_query" "child_selector" "attribute_selector" "id_selector" "declaration" "class_selector" "pseudo_class_selector" "parenthesized_value" "charset_statement" "sibling_selector" "selectors" "adjacent_sibling_selector"))
   ("nesting_selector" ("pseudo_class_selector" "child_selector" "attribute_selector" "id_selector" "descendant_selector" "arguments" "sibling_selector" "pseudo_element_selector" "selectors" "adjacent_sibling_selector" "class_selector" "selector_query"))
   ("float_value" ("attribute_selector" "binary_expression" "feature_query" "declaration" "arguments" "parenthesized_value" "charset_statement" "import_statement"))
   ("binary_expression" ("attribute_selector" "binary_expression" "feature_query" "declaration" "arguments" "parenthesized_value" "charset_statement" "import_statement"))
   ("call_expression" ("attribute_selector" "binary_expression" "feature_query" "declaration" "arguments" "parenthesized_value" "charset_statement" "import_statement" "namespace_statement"))
   ("parenthesized_value" ("attribute_selector" "binary_expression" "feature_query" "declaration" "arguments" "parenthesized_value" "charset_statement" "import_statement"))
   ("color_value" ("attribute_selector" "binary_expression" "feature_query" "declaration" "arguments" "parenthesized_value" "charset_statement" "import_statement"))
   ("plain_value" ("attribute_selector" "binary_expression" "feature_query" "declaration" "arguments" "parenthesized_value" "charset_statement" "import_statement"))
   ("integer_value" ("attribute_selector" "binary_expression" "feature_query" "declaration" "arguments" "keyframe_block" "parenthesized_value" "charset_statement" "import_statement"))
   ("feature_query" ("at_rule" "import_statement" "media_statement" "binary_query" "unary_query" "parenthesized_query" "supports_statement"))
   ("keyword_query" ("at_rule" "import_statement" "media_statement" "binary_query" "unary_query" "parenthesized_query" "supports_statement"))
   ("at_keyword" ("keyframes_statement" "at_rule"))
   ("binary_query" ("at_rule" "import_statement" "media_statement" "binary_query" "unary_query" "parenthesized_query" "supports_statement"))
   ("unary_query" ("at_rule" "import_statement" "media_statement" "binary_query" "unary_query" "parenthesized_query" "supports_statement"))
   ("selector_query" ("at_rule" "import_statement" "media_statement" "binary_query" "unary_query" "parenthesized_query" "supports_statement"))
   ("parenthesized_query" ("at_rule" "import_statement" "media_statement" "binary_query" "unary_query" "parenthesized_query" "supports_statement"))
   ("block" ("keyframe_block" "at_rule" "rule_set" "media_statement" "supports_statement"))
   ("attribute_name" ("attribute_selector"))
   ("declaration" ("block" "stylesheet"))
   ("at_rule" ("block" "stylesheet"))
   ("charset_statement" ("block" "stylesheet"))
   ("rule_set" ("block" "stylesheet"))
   ("import_statement" ("block" "stylesheet"))
   ("media_statement" ("block" "stylesheet"))
   ("namespace_statement" ("block" "stylesheet"))
   ("keyframes_statement" ("block" "stylesheet"))
   ("supports_statement" ("block" "stylesheet"))
   ("function_name" ("call_expression"))
   ("arguments" ("pseudo_class_selector" "call_expression"))
   ("class_name" ("pseudo_class_selector" "class_selector"))
   ("important" ("declaration"))
   ("property_name" ("declaration"))
   ("feature_name" ("feature_query"))
   ("unit" ("float_value" "integer_value"))
   ("id_name" ("id_selector"))
   ("to" ("keyframe_block"))
   ("from" ("keyframe_block"))
   ("keyframe_block" ("keyframe_block_list"))
   ("keyframe_block_list" ("keyframes_statement"))
   ("keyframes_name" ("keyframes_statement"))
   ("namespace_name" ("namespace_statement"))
   ("selectors" ("rule_set"))
  ) 
)
;; END production rules for css





;; START Auto-generated production rules for `typescript'
(defconst combobulate-rules-typescript 
 '(("_primary_type" (:*unnamed* ("object_type" "index_type_query" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("declaration" (:*unnamed* ("internal_module" "lexical_declaration" "type_alias_declaration" "interface_declaration" "class_declaration" "import_alias" "function_signature" "variable_declaration" "abstract_class_declaration" "enum_declaration" "ambient_declaration" "module" "generator_function_declaration" "function_declaration"))) 
 ("expression" (:*unnamed* ("type_assertion" "glimmer_template" "internal_module" "binary_expression" "assignment_expression" "satisfies_expression" "yield_expression" "augmented_assignment_expression" "unary_expression" "primary_expression" "as_expression" "ternary_expression" "new_expression" "update_expression" "await_expression"))) 
 ("pattern" (:*unnamed* ("object_pattern" "undefined" "non_null_expression" "member_expression" "rest_pattern" "array_pattern" "subscript_expression" "identifier"))) 
 ("primary_expression" (:*unnamed* ("undefined" "call_expression" "function" "meta_property" "parenthesized_expression" "object" "string" "template_string" "number" "subscript_expression" "identifier" "false" "class" "arrow_function" "true" "regex" "array" "null" "non_null_expression" "member_expression" "this" "import" "generator_function" "super"))) 
 ("statement" (:*unnamed* ("break_statement" "continue_statement" "try_statement" "import_statement" "debugger_statement" "for_statement" "export_statement" "while_statement" "do_statement" "declaration" "expression_statement" "labeled_statement" "for_in_statement" "throw_statement" "statement_block" "empty_statement" "if_statement" "return_statement" "switch_statement" "with_statement"))) 
 ("abstract_class_declaration" (:*unnamed* ("class_heritage") :body ("class_body") :decorator ("decorator") :name ("type_identifier") :type_parameters ("type_parameters"))) 
 ("abstract_method_signature" (:*unnamed* ("accessibility_modifier") :name ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :parameters ("formal_parameters") :return_type ("type_annotation" "asserts" "type_predicate_annotation") :type_parameters ("type_parameters"))) 
 ("ambient_declaration" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "property_identifier" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "declaration" "array_type" "predefined_type" "union_type" "parenthesized_type" "statement_block" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("arguments" (:*unnamed* ("spread_element" "expression"))) 
 ("array" (:*unnamed* ("spread_element" "expression"))) 
 ("array_pattern" (:*unnamed* ("assignment_pattern" "pattern"))) 
 ("array_type" (:*unnamed* ("object_type" "index_type_query" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("arrow_function" (:body ("statement_block" "expression") :parameter ("identifier") :parameters ("formal_parameters") :return_type ("type_annotation" "asserts" "type_predicate_annotation") :type_parameters ("type_parameters"))) 
 ("as_expression" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "expression" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("asserts" (:*unnamed* ("type_predicate" "identifier" "this"))) 
 ("assignment_expression" (:left ("object_pattern" "undefined" "non_null_expression" "member_expression" "parenthesized_expression" "array_pattern" "subscript_expression" "identifier") :right ("expression"))) 
 ("assignment_pattern" (:left ("pattern") :right ("expression"))) 
 ("augmented_assignment_expression" (:left ("subscript_expression" "identifier" "non_null_expression" "member_expression" "parenthesized_expression") :operator nil :right ("expression"))) 
 ("await_expression" (:*unnamed* ("expression"))) 
 ("binary_expression" (:left ("expression") :operator nil :right ("expression"))) 
 ("break_statement" (:label ("statement_identifier"))) 
 ("call_expression" (:arguments ("template_string" "arguments") :function ("expression") :type_arguments ("type_arguments"))) 
 ("call_signature" (:parameters ("formal_parameters") :return_type ("type_annotation" "asserts" "type_predicate_annotation") :type_parameters ("type_parameters"))) 
 ("catch_clause" (:body ("statement_block") :parameter ("object_pattern" "identifier" "array_pattern") :type ("type_annotation"))) 
 ("class" (:*unnamed* ("class_heritage") :body ("class_body") :decorator ("decorator") :name ("type_identifier") :type_parameters ("type_parameters"))) 
 ("class_body" (:*unnamed* ("method_signature" "decorator" "class_static_block" "public_field_definition" "abstract_method_signature" "method_definition" "index_signature"))) 
 ("class_declaration" (:*unnamed* ("class_heritage") :body ("class_body") :decorator ("decorator") :name ("type_identifier") :type_parameters ("type_parameters"))) 
 ("class_heritage" (:*unnamed* ("extends_clause" "implements_clause"))) 
 ("class_static_block" (:body ("statement_block"))) 
 ("computed_property_name" (:*unnamed* ("expression"))) 
 ("conditional_type" (:alternative ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type") :consequence ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type") :left ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type") :right ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("constraint" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("construct_signature" (:parameters ("formal_parameters") :type ("type_annotation") :type_parameters ("type_parameters"))) 
 ("constructor_type" (:parameters ("formal_parameters") :type ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type") :type_parameters ("type_parameters"))) 
 ("continue_statement" (:label ("statement_identifier"))) 
 ("decorator" (:*unnamed* ("identifier" "member_expression" "call_expression"))) 
 ("default_type" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("do_statement" (:body ("statement") :condition ("parenthesized_expression"))) 
 ("else_clause" (:*unnamed* ("statement"))) 
 ("enum_assignment" (:name ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :value ("expression"))) 
 ("enum_body" (:*unnamed* ("enum_assignment") :name ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier"))) 
 ("enum_declaration" (:body ("enum_body") :name ("identifier"))) 
 ("export_clause" (:*unnamed* ("export_specifier"))) 
 ("export_specifier" (:alias ("string" "identifier") :name ("string" "identifier"))) 
 ("export_statement" (:*unnamed* ("namespace_export" "export_clause" "expression" "identifier") :declaration ("declaration") :decorator ("decorator") :source ("string") :value ("expression"))) 
 ("expression_statement" (:*unnamed* ("sequence_expression" "expression"))) 
 ("extends_clause" (:type_arguments ("type_arguments") :value ("expression"))) 
 ("extends_type_clause" (:type ("nested_type_identifier" "type_identifier" "generic_type"))) 
 ("finally_clause" (:body ("statement_block"))) 
 ("flow_maybe_type" (:*unnamed* ("object_type" "index_type_query" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("for_in_statement" (:body ("statement") :kind nil :left ("object_pattern" "undefined" "non_null_expression" "member_expression" "parenthesized_expression" "array_pattern" "subscript_expression" "identifier") :operator nil :right ("sequence_expression" "expression") :value ("expression"))) 
 ("for_statement" (:body ("statement") :condition ("expression_statement" "empty_statement") :increment ("sequence_expression" "expression") :initializer ("expression_statement" "lexical_declaration" "variable_declaration" "empty_statement"))) 
 ("formal_parameters" (:*unnamed* ("required_parameter" "optional_parameter"))) 
 ("function" (:body ("statement_block") :name ("identifier") :parameters ("formal_parameters") :return_type ("type_annotation" "asserts" "type_predicate_annotation") :type_parameters ("type_parameters"))) 
 ("function_declaration" (:body ("statement_block") :name ("identifier") :parameters ("formal_parameters") :return_type ("type_annotation" "asserts" "type_predicate_annotation") :type_parameters ("type_parameters"))) 
 ("function_signature" (:name ("identifier") :parameters ("formal_parameters") :return_type ("type_annotation" "asserts" "type_predicate_annotation") :type_parameters ("type_parameters"))) 
 ("function_type" (:parameters ("formal_parameters") :return_type ("type_predicate" "object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type") :type_parameters ("type_parameters"))) 
 ("generator_function" (:body ("statement_block") :name ("identifier") :parameters ("formal_parameters") :return_type ("type_annotation" "asserts" "type_predicate_annotation") :type_parameters ("type_parameters"))) 
 ("generator_function_declaration" (:body ("statement_block") :name ("identifier") :parameters ("formal_parameters") :return_type ("type_annotation" "asserts" "type_predicate_annotation") :type_parameters ("type_parameters"))) 
 ("generic_type" (:name ("nested_type_identifier" "type_identifier") :type_arguments ("type_arguments"))) 
 ("glimmer_template" (:close_tag ("glimmer_closing_tag") :open_tag ("glimmer_opening_tag"))) 
 ("if_statement" (:alternative ("else_clause") :condition ("parenthesized_expression") :consequence ("statement"))) 
 ("implements_clause" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("import_alias" (:*unnamed* ("identifier" "nested_identifier"))) 
 ("import_clause" (:*unnamed* ("namespace_import" "identifier" "named_imports"))) 
 ("import_require_clause" (:*unnamed* ("identifier") :source ("string"))) 
 ("import_specifier" (:alias ("identifier") :name ("string" "identifier"))) 
 ("import_statement" (:*unnamed* ("import_require_clause" "import_clause") :source ("string"))) 
 ("index_signature" (:*unnamed* ("mapped_type_clause") :index_type ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type") :name ("identifier") :sign nil :type ("type_annotation" "omitting_type_annotation" "opting_type_annotation"))) 
 ("index_type_query" (:*unnamed* ("object_type" "index_type_query" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("infer_type" (:*unnamed* ("type_identifier"))) 
 ("interface_declaration" (:*unnamed* ("extends_type_clause") :body ("object_type") :name ("type_identifier") :type_parameters ("type_parameters"))) 
 ("internal_module" (:body ("statement_block") :name ("string" "identifier" "nested_identifier"))) 
 ("intersection_type" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("jsx_attribute" (:*unnamed* ("property_identifier" "string" "jsx_namespace_name" "jsx_self_closing_element" "jsx_expression" "jsx_fragment" "jsx_element"))) 
 ("jsx_closing_element" (:name ("identifier" "jsx_namespace_name" "nested_identifier"))) 
 ("jsx_element" (:*unnamed* ("jsx_self_closing_element" "jsx_expression" "jsx_text" "jsx_fragment" "jsx_element") :close_tag ("jsx_closing_element") :open_tag ("jsx_opening_element"))) 
 ("jsx_expression" (:*unnamed* ("sequence_expression" "spread_element" "expression"))) 
 ("jsx_fragment" (:*unnamed* ("jsx_self_closing_element" "jsx_expression" "jsx_text" "jsx_fragment" "jsx_element"))) 
 ("jsx_namespace_name" (:*unnamed* ("identifier"))) 
 ("jsx_opening_element" (:attribute ("jsx_attribute" "jsx_expression") :name ("identifier" "jsx_namespace_name" "nested_identifier") :type_arguments ("type_arguments"))) 
 ("jsx_self_closing_element" (:attribute ("jsx_attribute" "jsx_expression") :name ("identifier" "jsx_namespace_name" "nested_identifier") :type_arguments ("type_arguments"))) 
 ("labeled_statement" (:body ("statement") :label ("statement_identifier"))) 
 ("lexical_declaration" (:*unnamed* ("variable_declarator") :kind nil)) 
 ("literal_type" (:*unnamed* ("string" "false" "undefined" "unary_expression" "number" "null" "true"))) 
 ("lookup_type" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("mapped_type_clause" (:alias ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type") :name ("type_identifier") :type ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("member_expression" (:object ("expression") :optional_chain ("optional_chain") :property ("property_identifier" "private_property_identifier"))) 
 ("method_definition" (:*unnamed* ("override_modifier" "accessibility_modifier") :body ("statement_block") :name ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :parameters ("formal_parameters") :return_type ("type_annotation" "asserts" "type_predicate_annotation") :type_parameters ("type_parameters"))) 
 ("method_signature" (:*unnamed* ("override_modifier" "accessibility_modifier") :name ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :parameters ("formal_parameters") :return_type ("type_annotation" "asserts" "type_predicate_annotation") :type_parameters ("type_parameters"))) 
 ("module" (:body ("statement_block") :name ("string" "identifier" "nested_identifier"))) 
 ("named_imports" (:*unnamed* ("import_specifier"))) 
 ("namespace_export" (:*unnamed* ("string" "identifier"))) 
 ("namespace_import" (:*unnamed* ("identifier"))) 
 ("nested_identifier" (:*unnamed* ("identifier" "nested_identifier"))) 
 ("nested_type_identifier" (:module ("identifier" "nested_identifier") :name ("type_identifier"))) 
 ("new_expression" (:arguments ("arguments") :constructor ("primary_expression") :type_arguments ("type_arguments"))) 
 ("non_null_expression" (:*unnamed* ("expression"))) 
 ("object" (:*unnamed* ("spread_element" "method_definition" "shorthand_property_identifier" "pair"))) 
 ("object_assignment_pattern" (:left ("object_pattern" "shorthand_property_identifier_pattern" "array_pattern") :right ("expression"))) 
 ("object_pattern" (:*unnamed* ("object_assignment_pattern" "pair_pattern" "shorthand_property_identifier_pattern" "rest_pattern"))) 
 ("object_type" (:*unnamed* ("call_signature" "method_signature" "construct_signature" "property_signature" "export_statement" "index_signature"))) 
 ("omitting_type_annotation" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("opting_type_annotation" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("optional_parameter" (:*unnamed* ("override_modifier" "accessibility_modifier") :decorator ("decorator") :name ("identifier") :pattern ("this" "pattern") :type ("type_annotation") :value ("expression"))) 
 ("optional_type" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("pair" (:key ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :value ("expression"))) 
 ("pair_pattern" (:key ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :value ("assignment_pattern" "pattern"))) 
 ("parenthesized_expression" (:*unnamed* ("sequence_expression" "expression") :type ("type_annotation"))) 
 ("parenthesized_type" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("program" (:*unnamed* ("statement" "hash_bang_line"))) 
 ("property_signature" (:*unnamed* ("override_modifier" "accessibility_modifier") :name ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :type ("type_annotation"))) 
 ("public_field_definition" (:*unnamed* ("override_modifier" "accessibility_modifier") :name ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :type ("type_annotation") :value ("expression"))) 
 ("readonly_type" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("regex" (:flags ("regex_flags") :pattern ("regex_pattern"))) 
 ("required_parameter" (:*unnamed* ("override_modifier" "accessibility_modifier") :decorator ("decorator") :name ("identifier" "rest_pattern") :pattern ("this" "pattern") :type ("type_annotation") :value ("expression"))) 
 ("rest_pattern" (:*unnamed* ("object_pattern" "undefined" "array_pattern" "subscript_expression" "identifier" "non_null_expression" "member_expression"))) 
 ("rest_type" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("return_statement" (:*unnamed* ("sequence_expression" "expression"))) 
 ("satisfies_expression" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "expression" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("sequence_expression" (:left ("expression") :right ("sequence_expression" "expression"))) 
 ("spread_element" (:*unnamed* ("expression"))) 
 ("statement_block" (:*unnamed* ("statement"))) 
 ("string" (:*unnamed* ("escape_sequence" "string_fragment"))) 
 ("subscript_expression" (:index ("string" "number" "sequence_expression" "predefined_type" "expression") :object ("expression") :optional_chain ("optional_chain"))) 
 ("switch_body" (:*unnamed* ("switch_default" "switch_case"))) 
 ("switch_case" (:body ("statement") :value ("sequence_expression" "expression"))) 
 ("switch_default" (:body ("statement"))) 
 ("switch_statement" (:body ("switch_body") :value ("parenthesized_expression"))) 
 ("template_literal_type" (:*unnamed* ("template_type"))) 
 ("template_string" (:*unnamed* ("escape_sequence" "template_substitution"))) 
 ("template_substitution" (:*unnamed* ("sequence_expression" "expression"))) 
 ("template_type" (:*unnamed* ("object_type" "index_type_query" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("ternary_expression" (:alternative ("expression") :condition ("expression") :consequence ("expression"))) 
 ("throw_statement" (:*unnamed* ("sequence_expression" "expression"))) 
 ("try_statement" (:body ("statement_block") :finalizer ("finally_clause") :handler ("catch_clause"))) 
 ("tuple_type" (:*unnamed* ("optional_parameter" "required_parameter" "object_type" "index_type_query" "constructor_type" "optional_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "rest_type" "intersection_type" "template_literal_type"))) 
 ("type_alias_declaration" (:name ("type_identifier") :type_parameters ("type_parameters") :value ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("type_annotation" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("type_arguments" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("type_assertion" (:*unnamed* ("type_arguments" "expression"))) 
 ("type_parameter" (:constraint ("constraint") :name ("type_identifier") :value ("default_type"))) 
 ("type_parameters" (:*unnamed* ("type_parameter"))) 
 ("type_predicate" (:name ("identifier" "this") :type ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("type_predicate_annotation" (:*unnamed* ("type_predicate"))) 
 ("type_query" (:*unnamed* ("subscript_expression" "identifier" "member_expression" "call_expression"))) 
 ("unary_expression" (:argument ("expression" "number") :operator nil)) 
 ("union_type" (:*unnamed* ("object_type" "index_type_query" "constructor_type" "readonly_type" "this_type" "existential_type" "conditional_type" "generic_type" "lookup_type" "literal_type" "type_identifier" "function_type" "array_type" "predefined_type" "union_type" "parenthesized_type" "type_query" "nested_type_identifier" "tuple_type" "infer_type" "flow_maybe_type" "intersection_type" "template_literal_type"))) 
 ("update_expression" (:argument ("expression") :operator nil)) 
 ("variable_declaration" (:*unnamed* ("variable_declarator"))) 
 ("variable_declarator" (:name ("object_pattern" "identifier" "array_pattern") :type ("type_annotation") :value ("expression"))) 
 ("while_statement" (:body ("statement") :condition ("parenthesized_expression"))) 
 ("with_statement" (:body ("statement") :object ("parenthesized_expression"))) 
 ("yield_expression" (:*unnamed* ("expression"))) 
))

(defconst combobulate-rules-typescript-inverted 
 '(("object_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "interface_declaration" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("index_type_query" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("this_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("existential_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("conditional_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("generic_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "extends_type_clause" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("lookup_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("literal_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("type_identifier" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "type_parameter" "default_type" "lookup_type" "ambient_declaration" "class" "_primary_type" "extends_type_clause" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "class_declaration" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "interface_declaration" "mapped_type_clause" "constraint" "conditional_type" "generic_type" "abstract_class_declaration" "type_alias_declaration" "parenthesized_type" "nested_type_identifier" "infer_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("array_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("predefined_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "subscript_expression" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("union_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("parenthesized_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("type_query" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("nested_type_identifier" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "extends_type_clause" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "generic_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("tuple_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("flow_maybe_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("intersection_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("template_literal_type" ("type_predicate" "optional_type" "index_type_query" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "_primary_type" "satisfies_expression" "implements_clause" "array_type" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "flow_maybe_type" "function_type" "index_signature" "intersection_type"))
   ("internal_module" ("expression" "declaration"))
   ("lexical_declaration" ("for_statement" "declaration"))
   ("type_alias_declaration" ("declaration"))
   ("interface_declaration" ("declaration"))
   ("class_declaration" ("declaration"))
   ("import_alias" ("declaration"))
   ("function_signature" ("declaration"))
   ("variable_declaration" ("for_statement" "declaration"))
   ("abstract_class_declaration" ("declaration"))
   ("enum_declaration" ("declaration"))
   ("ambient_declaration" ("declaration"))
   ("module" ("declaration"))
   ("generator_function_declaration" ("declaration"))
   ("function_declaration" ("declaration"))
   ("type_assertion" ("expression"))
   ("glimmer_template" ("expression"))
   ("binary_expression" ("expression"))
   ("assignment_expression" ("expression"))
   ("satisfies_expression" ("expression"))
   ("yield_expression" ("expression"))
   ("augmented_assignment_expression" ("expression"))
   ("unary_expression" ("expression" "literal_type"))
   ("primary_expression" ("expression" "new_expression"))
   ("as_expression" ("expression"))
   ("ternary_expression" ("expression"))
   ("new_expression" ("expression"))
   ("update_expression" ("expression"))
   ("await_expression" ("expression"))
   ("object_pattern" ("assignment_expression" "object_assignment_pattern" "for_in_statement" "variable_declarator" "rest_pattern" "catch_clause" "pattern"))
   ("undefined" ("assignment_expression" "for_in_statement" "rest_pattern" "primary_expression" "literal_type" "pattern"))
   ("non_null_expression" ("assignment_expression" "for_in_statement" "augmented_assignment_expression" "rest_pattern" "primary_expression" "pattern"))
   ("member_expression" ("assignment_expression" "decorator" "for_in_statement" "type_query" "augmented_assignment_expression" "rest_pattern" "primary_expression" "pattern"))
   ("rest_pattern" ("object_pattern" "required_parameter" "pattern"))
   ("array_pattern" ("assignment_expression" "object_assignment_pattern" "for_in_statement" "variable_declarator" "rest_pattern" "catch_clause" "pattern"))
   ("subscript_expression" ("assignment_expression" "for_in_statement" "type_query" "augmented_assignment_expression" "rest_pattern" "primary_expression" "pattern"))
   ("identifier" ("required_parameter" "type_predicate" "assignment_expression" "jsx_opening_element" "function" "import_specifier" "function_signature" "jsx_closing_element" "import_require_clause" "export_statement" "export_specifier" "function_declaration" "arrow_function" "internal_module" "jsx_self_closing_element" "decorator" "for_in_statement" "generator_function" "asserts" "optional_parameter" "generator_function_declaration" "import_clause" "augmented_assignment_expression" "jsx_namespace_name" "module" "namespace_export" "import_alias" "variable_declarator" "type_query" "nested_type_identifier" "rest_pattern" "primary_expression" "nested_identifier" "enum_declaration" "namespace_import" "index_signature" "catch_clause" "pattern"))
   ("call_expression" ("primary_expression" "decorator" "type_query"))
   ("function" ("primary_expression"))
   ("meta_property" ("primary_expression"))
   ("parenthesized_expression" ("do_statement" "assignment_expression" "for_in_statement" "augmented_assignment_expression" "if_statement" "primary_expression" "switch_statement" "with_statement" "while_statement"))
   ("object" ("primary_expression"))
   ("string" ("import_specifier" "import_statement" "pair_pattern" "import_require_clause" "public_field_definition" "literal_type" "export_statement" "export_specifier" "internal_module" "method_signature" "method_definition" "property_signature" "jsx_attribute" "subscript_expression" "module" "namespace_export" "enum_body" "pair" "enum_assignment" "primary_expression" "abstract_method_signature"))
   ("template_string" ("primary_expression" "call_expression"))
   ("number" ("enum_body" "method_signature" "method_definition" "pair" "enum_assignment" "pair_pattern" "unary_expression" "primary_expression" "public_field_definition" "literal_type" "subscript_expression" "abstract_method_signature" "property_signature"))
   ("false" ("primary_expression" "literal_type"))
   ("class" ("primary_expression"))
   ("arrow_function" ("primary_expression"))
   ("true" ("primary_expression" "literal_type"))
   ("regex" ("primary_expression"))
   ("array" ("primary_expression"))
   ("null" ("primary_expression" "literal_type"))
   ("this" ("required_parameter" "type_predicate" "asserts" "primary_expression" "optional_parameter"))
   ("import" ("primary_expression"))
   ("generator_function" ("primary_expression"))
   ("super" ("primary_expression"))
   ("break_statement" ("statement"))
   ("continue_statement" ("statement"))
   ("try_statement" ("statement"))
   ("import_statement" ("statement"))
   ("debugger_statement" ("statement"))
   ("for_statement" ("statement"))
   ("export_statement" ("statement" "object_type"))
   ("while_statement" ("statement"))
   ("do_statement" ("statement"))
   ("declaration" ("ambient_declaration" "statement" "export_statement"))
   ("expression_statement" ("statement" "for_statement"))
   ("labeled_statement" ("statement"))
   ("for_in_statement" ("statement"))
   ("throw_statement" ("statement"))
   ("statement_block" ("internal_module" "class_static_block" "function" "method_definition" "try_statement" "finally_clause" "statement" "generator_function" "generator_function_declaration" "ambient_declaration" "module" "catch_clause" "arrow_function" "function_declaration"))
   ("empty_statement" ("statement" "for_statement"))
   ("if_statement" ("statement"))
   ("return_statement" ("statement"))
   ("switch_statement" ("statement"))
   ("with_statement" ("statement"))
   ("class_heritage" ("class_declaration" "class" "abstract_class_declaration"))
   ("class_body" ("class_declaration" "class" "abstract_class_declaration"))
   ("decorator" ("optional_parameter" "required_parameter" "class_declaration" "abstract_class_declaration" "class_body" "export_statement" "class"))
   ("type_parameters" ("call_signature" "constructor_type" "method_signature" "function" "construct_signature" "interface_declaration" "method_definition" "class_declaration" "type_alias_declaration" "function_signature" "generator_function" "abstract_class_declaration" "generator_function_declaration" "abstract_method_signature" "function_type" "class" "arrow_function" "function_declaration"))
   ("accessibility_modifier" ("required_parameter" "method_signature" "method_definition" "public_field_definition" "optional_parameter" "abstract_method_signature" "property_signature"))
   ("private_property_identifier" ("enum_body" "method_signature" "method_definition" "member_expression" "enum_assignment" "pair" "pair_pattern" "public_field_definition" "abstract_method_signature" "property_signature"))
   ("computed_property_name" ("enum_body" "method_signature" "method_definition" "pair" "enum_assignment" "pair_pattern" "public_field_definition" "abstract_method_signature" "property_signature"))
   ("property_identifier" ("ambient_declaration" "jsx_attribute" "enum_body" "method_signature" "method_definition" "member_expression" "enum_assignment" "pair" "pair_pattern" "public_field_definition" "abstract_method_signature" "property_signature"))
   ("formal_parameters" ("call_signature" "constructor_type" "method_signature" "function" "construct_signature" "method_definition" "function_signature" "generator_function" "generator_function_declaration" "abstract_method_signature" "function_type" "arrow_function" "function_declaration"))
   ("type_annotation" ("required_parameter" "function" "function_signature" "parenthesized_expression" "public_field_definition" "arrow_function" "function_declaration" "method_signature" "catch_clause" "construct_signature" "method_definition" "generator_function" "optional_parameter" "generator_function_declaration" "property_signature" "call_signature" "abstract_method_signature" "index_signature" "variable_declarator"))
   ("asserts" ("call_signature" "method_signature" "function" "method_definition" "arrow_function" "function_signature" "generator_function" "generator_function_declaration" "abstract_method_signature" "function_declaration"))
   ("type_predicate_annotation" ("call_signature" "method_signature" "function" "method_definition" "arrow_function" "function_signature" "generator_function" "generator_function_declaration" "abstract_method_signature" "function_declaration"))
   ("constructor_type" ("type_predicate" "optional_type" "constructor_type" "default_type" "lookup_type" "ambient_declaration" "satisfies_expression" "implements_clause" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "function_type" "index_signature" "intersection_type"))
   ("readonly_type" ("type_predicate" "optional_type" "constructor_type" "default_type" "lookup_type" "ambient_declaration" "satisfies_expression" "implements_clause" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "function_type" "index_signature" "intersection_type"))
   ("function_type" ("type_predicate" "optional_type" "constructor_type" "default_type" "lookup_type" "ambient_declaration" "satisfies_expression" "implements_clause" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "function_type" "index_signature" "intersection_type"))
   ("infer_type" ("type_predicate" "optional_type" "constructor_type" "template_type" "default_type" "lookup_type" "ambient_declaration" "satisfies_expression" "implements_clause" "union_type" "tuple_type" "type_arguments" "as_expression" "rest_type" "type_annotation" "omitting_type_annotation" "opting_type_annotation" "readonly_type" "mapped_type_clause" "constraint" "conditional_type" "type_alias_declaration" "parenthesized_type" "function_type" "index_signature" "intersection_type"))
   ("spread_element" ("array" "object" "jsx_expression" "arguments"))
   ("expression" ("required_parameter" "binary_expression" "assignment_expression" "arguments" "spread_element" "assignment_pattern" "parenthesized_expression" "public_field_definition" "for_statement" "export_statement" "ternary_expression" "arrow_function" "await_expression" "type_assertion" "satisfies_expression" "yield_expression" "array" "expression_statement" "for_in_statement" "non_null_expression" "member_expression" "throw_statement" "jsx_expression" "as_expression" "optional_parameter" "return_statement" "update_expression" "call_expression" "template_substitution" "augmented_assignment_expression" "switch_case" "subscript_expression" "sequence_expression" "extends_clause" "object_assignment_pattern" "pair" "enum_assignment" "unary_expression" "computed_property_name" "variable_declarator"))
   ("assignment_pattern" ("pair_pattern" "array_pattern"))
   ("pattern" ("required_parameter" "assignment_pattern" "pair_pattern" "array_pattern" "optional_parameter"))
   ("type_predicate" ("function_type" "asserts" "type_predicate_annotation"))
   ("statement_identifier" ("labeled_statement" "break_statement" "continue_statement"))
   ("arguments" ("new_expression" "call_expression"))
   ("type_arguments" ("extends_clause" "jsx_self_closing_element" "call_expression" "jsx_opening_element" "generic_type" "new_expression" "type_assertion"))
   ("method_signature" ("class_body" "object_type"))
   ("class_static_block" ("class_body"))
   ("public_field_definition" ("class_body"))
   ("abstract_method_signature" ("class_body"))
   ("method_definition" ("class_body" "object"))
   ("index_signature" ("class_body" "object_type"))
   ("extends_clause" ("class_heritage"))
   ("implements_clause" ("class_heritage"))
   ("statement" ("do_statement" "labeled_statement" "for_in_statement" "statement_block" "switch_default" "if_statement" "else_clause" "while_statement" "switch_case" "for_statement" "with_statement" "program"))
   ("enum_assignment" ("enum_body"))
   ("enum_body" ("enum_declaration"))
   ("export_specifier" ("export_clause"))
   ("namespace_export" ("export_statement"))
   ("export_clause" ("export_statement"))
   ("sequence_expression" ("expression_statement" "for_in_statement" "throw_statement" "template_substitution" "parenthesized_expression" "jsx_expression" "return_statement" "switch_case" "subscript_expression" "sequence_expression" "for_statement"))
   ("required_parameter" ("formal_parameters" "tuple_type"))
   ("optional_parameter" ("formal_parameters" "tuple_type"))
   ("glimmer_closing_tag" ("glimmer_template"))
   ("glimmer_opening_tag" ("glimmer_template"))
   ("else_clause" ("if_statement"))
   ("nested_identifier" ("internal_module" "jsx_self_closing_element" "jsx_opening_element" "import_alias" "nested_type_identifier" "jsx_closing_element" "nested_identifier" "module"))
   ("namespace_import" ("import_clause"))
   ("named_imports" ("import_clause"))
   ("import_require_clause" ("import_statement"))
   ("import_clause" ("import_statement"))
   ("mapped_type_clause" ("index_signature"))
   ("omitting_type_annotation" ("index_signature"))
   ("opting_type_annotation" ("index_signature"))
   ("extends_type_clause" ("interface_declaration"))
   ("jsx_namespace_name" ("jsx_self_closing_element" "jsx_attribute" "jsx_closing_element" "jsx_opening_element"))
   ("jsx_self_closing_element" ("jsx_fragment" "jsx_element" "jsx_attribute"))
   ("jsx_expression" ("jsx_attribute" "jsx_self_closing_element" "jsx_opening_element" "jsx_fragment" "jsx_element"))
   ("jsx_fragment" ("jsx_fragment" "jsx_element" "jsx_attribute"))
   ("jsx_element" ("jsx_fragment" "jsx_element" "jsx_attribute"))
   ("jsx_text" ("jsx_fragment" "jsx_element"))
   ("jsx_closing_element" ("jsx_element"))
   ("jsx_opening_element" ("jsx_element"))
   ("jsx_attribute" ("jsx_self_closing_element" "jsx_opening_element"))
   ("variable_declarator" ("variable_declaration" "lexical_declaration"))
   ("optional_chain" ("subscript_expression" "member_expression"))
   ("override_modifier" ("required_parameter" "method_signature" "method_definition" "public_field_definition" "optional_parameter" "property_signature"))
   ("import_specifier" ("named_imports"))
   ("shorthand_property_identifier" ("object"))
   ("pair" ("object"))
   ("shorthand_property_identifier_pattern" ("object_pattern" "object_assignment_pattern"))
   ("object_assignment_pattern" ("object_pattern"))
   ("pair_pattern" ("object_pattern"))
   ("call_signature" ("object_type"))
   ("construct_signature" ("object_type"))
   ("property_signature" ("object_type"))
   ("hash_bang_line" ("program"))
   ("regex_flags" ("regex"))
   ("regex_pattern" ("regex"))
   ("escape_sequence" ("string" "template_string"))
   ("string_fragment" ("string"))
   ("switch_default" ("switch_body"))
   ("switch_case" ("switch_body"))
   ("switch_body" ("switch_statement"))
   ("template_type" ("template_literal_type"))
   ("template_substitution" ("template_string"))
   ("finally_clause" ("try_statement"))
   ("catch_clause" ("try_statement"))
   ("optional_type" ("tuple_type"))
   ("rest_type" ("tuple_type"))
   ("constraint" ("type_parameter"))
   ("default_type" ("type_parameter"))
   ("type_parameter" ("type_parameters"))
  ) 
)
;; END production rules for typescript





;; START Auto-generated production rules for `javascript'
(defconst combobulate-rules-javascript 
 '(("declaration" (:*unnamed* ("lexical_declaration" "generator_function_declaration" "class_declaration" "function_declaration" "variable_declaration"))) 
 ("expression" (:*unnamed* ("glimmer_template" "binary_expression" "assignment_expression" "jsx_self_closing_element" "yield_expression" "jsx_fragment" "jsx_element" "augmented_assignment_expression" "unary_expression" "primary_expression" "ternary_expression" "new_expression" "update_expression" "await_expression"))) 
 ("pattern" (:*unnamed* ("object_pattern" "rest_pattern" "undefined" "array_pattern" "subscript_expression" "identifier" "member_expression"))) 
 ("primary_expression" (:*unnamed* ("undefined" "call_expression" "function" "meta_property" "parenthesized_expression" "object" "string" "template_string" "number" "subscript_expression" "identifier" "false" "class" "arrow_function" "true" "regex" "array" "null" "this" "member_expression" "import" "generator_function" "super"))) 
 ("statement" (:*unnamed* ("break_statement" "continue_statement" "try_statement" "import_statement" "debugger_statement" "for_statement" "export_statement" "while_statement" "do_statement" "declaration" "expression_statement" "labeled_statement" "for_in_statement" "throw_statement" "statement_block" "empty_statement" "if_statement" "return_statement" "switch_statement" "with_statement"))) 
 ("arguments" (:*unnamed* ("spread_element" "expression"))) 
 ("array" (:*unnamed* ("spread_element" "expression"))) 
 ("array_pattern" (:*unnamed* ("assignment_pattern" "pattern"))) 
 ("arrow_function" (:body ("statement_block" "expression") :parameter ("identifier") :parameters ("formal_parameters"))) 
 ("assignment_expression" (:left ("object_pattern" "undefined" "array_pattern" "subscript_expression" "identifier" "member_expression" "parenthesized_expression") :right ("expression"))) 
 ("assignment_pattern" (:left ("pattern") :right ("expression"))) 
 ("augmented_assignment_expression" (:left ("subscript_expression" "identifier" "member_expression" "parenthesized_expression") :operator nil :right ("expression"))) 
 ("await_expression" (:*unnamed* ("expression"))) 
 ("binary_expression" (:left ("expression") :operator nil :right ("expression"))) 
 ("break_statement" (:label ("statement_identifier"))) 
 ("call_expression" (:arguments ("template_string" "arguments") :function ("expression") :optional_chain ("optional_chain"))) 
 ("catch_clause" (:body ("statement_block") :parameter ("object_pattern" "identifier" "array_pattern"))) 
 ("class" (:*unnamed* ("class_heritage") :body ("class_body") :decorator ("decorator") :name ("identifier"))) 
 ("class_body" (:member ("field_definition" "method_definition" "class_static_block") :template ("glimmer_template"))) 
 ("class_declaration" (:*unnamed* ("class_heritage") :body ("class_body") :decorator ("decorator") :name ("identifier"))) 
 ("class_heritage" (:*unnamed* ("expression"))) 
 ("class_static_block" (:body ("statement_block"))) 
 ("computed_property_name" (:*unnamed* ("expression"))) 
 ("continue_statement" (:label ("statement_identifier"))) 
 ("decorator" (:*unnamed* ("identifier" "member_expression" "call_expression"))) 
 ("do_statement" (:body ("statement") :condition ("parenthesized_expression"))) 
 ("else_clause" (:*unnamed* ("statement"))) 
 ("export_clause" (:*unnamed* ("export_specifier"))) 
 ("export_specifier" (:alias ("string" "identifier") :name ("string" "identifier"))) 
 ("export_statement" (:*unnamed* ("namespace_export" "export_clause") :declaration ("declaration") :decorator ("decorator") :source ("string") :value ("expression"))) 
 ("expression_statement" (:*unnamed* ("sequence_expression" "expression"))) 
 ("field_definition" (:decorator ("decorator") :property ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :value ("expression"))) 
 ("finally_clause" (:body ("statement_block"))) 
 ("for_in_statement" (:body ("statement") :kind nil :left ("object_pattern" "undefined" "array_pattern" "subscript_expression" "identifier" "member_expression" "parenthesized_expression") :operator nil :right ("sequence_expression" "expression") :value ("expression"))) 
 ("for_statement" (:body ("statement") :condition ("expression_statement" "empty_statement") :increment ("sequence_expression" "expression") :initializer ("expression_statement" "lexical_declaration" "variable_declaration" "empty_statement"))) 
 ("formal_parameters" (:*unnamed* ("assignment_pattern" "pattern"))) 
 ("function" (:body ("statement_block") :name ("identifier") :parameters ("formal_parameters"))) 
 ("function_declaration" (:body ("statement_block") :name ("identifier") :parameters ("formal_parameters"))) 
 ("generator_function" (:body ("statement_block") :name ("identifier") :parameters ("formal_parameters"))) 
 ("generator_function_declaration" (:body ("statement_block") :name ("identifier") :parameters ("formal_parameters"))) 
 ("glimmer_template" (:close_tag ("glimmer_closing_tag") :open_tag ("glimmer_opening_tag"))) 
 ("if_statement" (:alternative ("else_clause") :condition ("parenthesized_expression") :consequence ("statement"))) 
 ("import_clause" (:*unnamed* ("namespace_import" "identifier" "named_imports"))) 
 ("import_specifier" (:alias ("identifier") :name ("string" "identifier"))) 
 ("import_statement" (:*unnamed* ("import_clause") :source ("string"))) 
 ("jsx_attribute" (:*unnamed* ("property_identifier" "string" "jsx_namespace_name" "jsx_self_closing_element" "jsx_expression" "jsx_fragment" "jsx_element"))) 
 ("jsx_closing_element" (:name ("identifier" "jsx_namespace_name" "nested_identifier"))) 
 ("jsx_element" (:*unnamed* ("jsx_self_closing_element" "jsx_expression" "jsx_text" "jsx_fragment" "jsx_element") :close_tag ("jsx_closing_element") :open_tag ("jsx_opening_element"))) 
 ("jsx_expression" (:*unnamed* ("sequence_expression" "spread_element" "expression"))) 
 ("jsx_fragment" (:*unnamed* ("jsx_self_closing_element" "jsx_expression" "jsx_text" "jsx_fragment" "jsx_element"))) 
 ("jsx_namespace_name" (:*unnamed* ("identifier"))) 
 ("jsx_opening_element" (:attribute ("jsx_attribute" "jsx_expression") :name ("identifier" "jsx_namespace_name" "nested_identifier"))) 
 ("jsx_self_closing_element" (:attribute ("jsx_attribute" "jsx_expression") :name ("identifier" "jsx_namespace_name" "nested_identifier"))) 
 ("labeled_statement" (:body ("statement") :label ("statement_identifier"))) 
 ("lexical_declaration" (:*unnamed* ("variable_declarator") :kind nil)) 
 ("member_expression" (:object ("expression") :optional_chain ("optional_chain") :property ("property_identifier" "private_property_identifier"))) 
 ("method_definition" (:body ("statement_block") :decorator ("decorator") :name ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :parameters ("formal_parameters"))) 
 ("named_imports" (:*unnamed* ("import_specifier"))) 
 ("namespace_export" (:*unnamed* ("string" "identifier"))) 
 ("namespace_import" (:*unnamed* ("identifier"))) 
 ("nested_identifier" (:*unnamed* ("identifier" "nested_identifier"))) 
 ("new_expression" (:arguments ("arguments") :constructor ("primary_expression" "new_expression"))) 
 ("object" (:*unnamed* ("spread_element" "method_definition" "shorthand_property_identifier" "pair"))) 
 ("object_assignment_pattern" (:left ("object_pattern" "shorthand_property_identifier_pattern" "array_pattern") :right ("expression"))) 
 ("object_pattern" (:*unnamed* ("object_assignment_pattern" "pair_pattern" "shorthand_property_identifier_pattern" "rest_pattern"))) 
 ("pair" (:key ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :value ("expression"))) 
 ("pair_pattern" (:key ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :value ("assignment_pattern" "pattern"))) 
 ("parenthesized_expression" (:*unnamed* ("sequence_expression" "expression"))) 
 ("program" (:*unnamed* ("statement" "hash_bang_line"))) 
 ("regex" (:flags ("regex_flags") :pattern ("regex_pattern"))) 
 ("rest_pattern" (:*unnamed* ("object_pattern" "undefined" "array_pattern" "subscript_expression" "identifier" "member_expression"))) 
 ("return_statement" (:*unnamed* ("sequence_expression" "expression"))) 
 ("sequence_expression" (:left ("expression") :right ("sequence_expression" "expression"))) 
 ("spread_element" (:*unnamed* ("expression"))) 
 ("statement_block" (:*unnamed* ("statement"))) 
 ("string" (:*unnamed* ("escape_sequence" "string_fragment"))) 
 ("subscript_expression" (:index ("sequence_expression" "expression") :object ("expression") :optional_chain ("optional_chain"))) 
 ("switch_body" (:*unnamed* ("switch_default" "switch_case"))) 
 ("switch_case" (:body ("statement") :value ("sequence_expression" "expression"))) 
 ("switch_default" (:body ("statement"))) 
 ("switch_statement" (:body ("switch_body") :value ("parenthesized_expression"))) 
 ("template_string" (:*unnamed* ("escape_sequence" "template_substitution"))) 
 ("template_substitution" (:*unnamed* ("sequence_expression" "expression"))) 
 ("ternary_expression" (:alternative ("expression") :condition ("expression") :consequence ("expression"))) 
 ("throw_statement" (:*unnamed* ("sequence_expression" "expression"))) 
 ("try_statement" (:body ("statement_block") :finalizer ("finally_clause") :handler ("catch_clause"))) 
 ("unary_expression" (:argument ("expression") :operator nil)) 
 ("update_expression" (:argument ("expression") :operator nil)) 
 ("variable_declaration" (:*unnamed* ("variable_declarator"))) 
 ("variable_declarator" (:name ("object_pattern" "identifier" "array_pattern") :value ("expression"))) 
 ("while_statement" (:body ("statement") :condition ("parenthesized_expression"))) 
 ("with_statement" (:body ("statement") :object ("parenthesized_expression"))) 
 ("yield_expression" (:*unnamed* ("expression"))) 
))

(defconst combobulate-rules-javascript-inverted 
 '(("lexical_declaration" ("for_statement" "declaration"))
   ("generator_function_declaration" ("declaration"))
   ("class_declaration" ("declaration"))
   ("function_declaration" ("declaration"))
   ("variable_declaration" ("for_statement" "declaration"))
   ("glimmer_template" ("class_body" "expression"))
   ("binary_expression" ("expression"))
   ("assignment_expression" ("expression"))
   ("jsx_self_closing_element" ("jsx_fragment" "jsx_element" "jsx_attribute" "expression"))
   ("yield_expression" ("expression"))
   ("jsx_fragment" ("jsx_fragment" "jsx_element" "jsx_attribute" "expression"))
   ("jsx_element" ("jsx_fragment" "jsx_element" "jsx_attribute" "expression"))
   ("augmented_assignment_expression" ("expression"))
   ("unary_expression" ("expression"))
   ("primary_expression" ("expression" "new_expression"))
   ("ternary_expression" ("expression"))
   ("new_expression" ("expression" "new_expression"))
   ("update_expression" ("expression"))
   ("await_expression" ("expression"))
   ("object_pattern" ("assignment_expression" "object_assignment_pattern" "for_in_statement" "variable_declarator" "rest_pattern" "catch_clause" "pattern"))
   ("rest_pattern" ("object_pattern" "pattern"))
   ("undefined" ("assignment_expression" "for_in_statement" "rest_pattern" "primary_expression" "pattern"))
   ("array_pattern" ("assignment_expression" "object_assignment_pattern" "for_in_statement" "variable_declarator" "rest_pattern" "catch_clause" "pattern"))
   ("subscript_expression" ("assignment_expression" "for_in_statement" "augmented_assignment_expression" "rest_pattern" "primary_expression" "pattern"))
   ("identifier" ("assignment_expression" "jsx_opening_element" "function" "import_specifier" "jsx_closing_element" "export_specifier" "class" "function_declaration" "arrow_function" "jsx_self_closing_element" "decorator" "for_in_statement" "generator_function" "generator_function_declaration" "class_declaration" "import_clause" "augmented_assignment_expression" "jsx_namespace_name" "namespace_export" "variable_declarator" "rest_pattern" "primary_expression" "nested_identifier" "namespace_import" "catch_clause" "pattern"))
   ("member_expression" ("assignment_expression" "decorator" "for_in_statement" "augmented_assignment_expression" "rest_pattern" "primary_expression" "pattern"))
   ("call_expression" ("primary_expression" "decorator"))
   ("function" ("primary_expression"))
   ("meta_property" ("primary_expression"))
   ("parenthesized_expression" ("do_statement" "assignment_expression" "for_in_statement" "augmented_assignment_expression" "if_statement" "primary_expression" "switch_statement" "with_statement" "while_statement"))
   ("object" ("primary_expression"))
   ("string" ("namespace_export" "jsx_attribute" "export_statement" "import_specifier" "method_definition" "pair" "field_definition" "import_statement" "pair_pattern" "primary_expression" "export_specifier"))
   ("template_string" ("primary_expression" "call_expression"))
   ("number" ("method_definition" "pair" "field_definition" "pair_pattern" "primary_expression"))
   ("false" ("primary_expression"))
   ("class" ("primary_expression"))
   ("arrow_function" ("primary_expression"))
   ("true" ("primary_expression"))
   ("regex" ("primary_expression"))
   ("array" ("primary_expression"))
   ("null" ("primary_expression"))
   ("this" ("primary_expression"))
   ("import" ("primary_expression"))
   ("generator_function" ("primary_expression"))
   ("super" ("primary_expression"))
   ("break_statement" ("statement"))
   ("continue_statement" ("statement"))
   ("try_statement" ("statement"))
   ("import_statement" ("statement"))
   ("debugger_statement" ("statement"))
   ("for_statement" ("statement"))
   ("export_statement" ("statement"))
   ("while_statement" ("statement"))
   ("do_statement" ("statement"))
   ("declaration" ("statement" "export_statement"))
   ("expression_statement" ("statement" "for_statement"))
   ("labeled_statement" ("statement"))
   ("for_in_statement" ("statement"))
   ("throw_statement" ("statement"))
   ("statement_block" ("class_static_block" "function" "method_definition" "try_statement" "finally_clause" "statement" "generator_function" "generator_function_declaration" "catch_clause" "arrow_function" "function_declaration"))
   ("empty_statement" ("statement" "for_statement"))
   ("if_statement" ("statement"))
   ("return_statement" ("statement"))
   ("switch_statement" ("statement"))
   ("with_statement" ("statement"))
   ("spread_element" ("array" "object" "jsx_expression" "arguments"))
   ("expression" ("binary_expression" "assignment_expression" "arguments" "spread_element" "assignment_pattern" "parenthesized_expression" "class_heritage" "for_statement" "export_statement" "ternary_expression" "arrow_function" "await_expression" "yield_expression" "array" "expression_statement" "for_in_statement" "throw_statement" "member_expression" "field_definition" "jsx_expression" "return_statement" "update_expression" "call_expression" "template_substitution" "augmented_assignment_expression" "switch_case" "subscript_expression" "sequence_expression" "object_assignment_pattern" "pair" "unary_expression" "computed_property_name" "variable_declarator"))
   ("assignment_pattern" ("formal_parameters" "pair_pattern" "array_pattern"))
   ("pattern" ("formal_parameters" "pair_pattern" "array_pattern" "assignment_pattern"))
   ("formal_parameters" ("function" "method_definition" "arrow_function" "generator_function" "generator_function_declaration" "function_declaration"))
   ("statement_identifier" ("labeled_statement" "break_statement" "continue_statement"))
   ("arguments" ("new_expression" "call_expression"))
   ("optional_chain" ("subscript_expression" "member_expression" "call_expression"))
   ("class_heritage" ("class_declaration" "class"))
   ("class_body" ("class_declaration" "class"))
   ("decorator" ("method_definition" "field_definition" "class_declaration" "export_statement" "class"))
   ("field_definition" ("class_body"))
   ("method_definition" ("class_body" "object"))
   ("class_static_block" ("class_body"))
   ("statement" ("do_statement" "labeled_statement" "for_in_statement" "statement_block" "switch_default" "if_statement" "else_clause" "while_statement" "switch_case" "for_statement" "with_statement" "program"))
   ("export_specifier" ("export_clause"))
   ("namespace_export" ("export_statement"))
   ("export_clause" ("export_statement"))
   ("sequence_expression" ("expression_statement" "for_in_statement" "throw_statement" "template_substitution" "parenthesized_expression" "jsx_expression" "return_statement" "switch_case" "subscript_expression" "sequence_expression" "for_statement"))
   ("private_property_identifier" ("method_definition" "member_expression" "pair" "field_definition" "pair_pattern"))
   ("computed_property_name" ("field_definition" "pair_pattern" "method_definition" "pair"))
   ("property_identifier" ("jsx_attribute" "method_definition" "member_expression" "pair" "field_definition" "pair_pattern"))
   ("glimmer_closing_tag" ("glimmer_template"))
   ("glimmer_opening_tag" ("glimmer_template"))
   ("else_clause" ("if_statement"))
   ("namespace_import" ("import_clause"))
   ("named_imports" ("import_clause"))
   ("import_clause" ("import_statement"))
   ("jsx_namespace_name" ("jsx_self_closing_element" "jsx_attribute" "jsx_closing_element" "jsx_opening_element"))
   ("jsx_expression" ("jsx_attribute" "jsx_self_closing_element" "jsx_opening_element" "jsx_fragment" "jsx_element"))
   ("nested_identifier" ("jsx_self_closing_element" "jsx_closing_element" "jsx_opening_element" "nested_identifier"))
   ("jsx_text" ("jsx_fragment" "jsx_element"))
   ("jsx_closing_element" ("jsx_element"))
   ("jsx_opening_element" ("jsx_element"))
   ("jsx_attribute" ("jsx_self_closing_element" "jsx_opening_element"))
   ("variable_declarator" ("variable_declaration" "lexical_declaration"))
   ("import_specifier" ("named_imports"))
   ("shorthand_property_identifier" ("object"))
   ("pair" ("object"))
   ("shorthand_property_identifier_pattern" ("object_pattern" "object_assignment_pattern"))
   ("object_assignment_pattern" ("object_pattern"))
   ("pair_pattern" ("object_pattern"))
   ("hash_bang_line" ("program"))
   ("regex_flags" ("regex"))
   ("regex_pattern" ("regex"))
   ("escape_sequence" ("string" "template_string"))
   ("string_fragment" ("string"))
   ("switch_default" ("switch_body"))
   ("switch_case" ("switch_body"))
   ("switch_body" ("switch_statement"))
   ("template_substitution" ("template_string"))
   ("finally_clause" ("try_statement"))
   ("catch_clause" ("try_statement"))
  ) 
)
;; END production rules for javascript





;; START Auto-generated production rules for `jsx'
(defconst combobulate-rules-jsx 
 '(("declaration" (:*unnamed* ("lexical_declaration" "generator_function_declaration" "class_declaration" "function_declaration" "variable_declaration"))) 
 ("expression" (:*unnamed* ("glimmer_template" "binary_expression" "assignment_expression" "jsx_self_closing_element" "yield_expression" "jsx_fragment" "jsx_element" "augmented_assignment_expression" "unary_expression" "primary_expression" "ternary_expression" "new_expression" "update_expression" "await_expression"))) 
 ("pattern" (:*unnamed* ("object_pattern" "rest_pattern" "undefined" "array_pattern" "subscript_expression" "identifier" "member_expression"))) 
 ("primary_expression" (:*unnamed* ("undefined" "call_expression" "function" "meta_property" "parenthesized_expression" "object" "string" "template_string" "number" "subscript_expression" "identifier" "false" "class" "arrow_function" "true" "regex" "array" "null" "this" "member_expression" "import" "generator_function" "super"))) 
 ("statement" (:*unnamed* ("break_statement" "continue_statement" "try_statement" "import_statement" "debugger_statement" "for_statement" "export_statement" "while_statement" "do_statement" "declaration" "expression_statement" "labeled_statement" "for_in_statement" "throw_statement" "statement_block" "empty_statement" "if_statement" "return_statement" "switch_statement" "with_statement"))) 
 ("arguments" (:*unnamed* ("spread_element" "expression"))) 
 ("array" (:*unnamed* ("spread_element" "expression"))) 
 ("array_pattern" (:*unnamed* ("assignment_pattern" "pattern"))) 
 ("arrow_function" (:body ("statement_block" "expression") :parameter ("identifier") :parameters ("formal_parameters"))) 
 ("assignment_expression" (:left ("object_pattern" "undefined" "array_pattern" "subscript_expression" "identifier" "member_expression" "parenthesized_expression") :right ("expression"))) 
 ("assignment_pattern" (:left ("pattern") :right ("expression"))) 
 ("augmented_assignment_expression" (:left ("subscript_expression" "identifier" "member_expression" "parenthesized_expression") :operator nil :right ("expression"))) 
 ("await_expression" (:*unnamed* ("expression"))) 
 ("binary_expression" (:left ("expression") :operator nil :right ("expression"))) 
 ("break_statement" (:label ("statement_identifier"))) 
 ("call_expression" (:arguments ("template_string" "arguments") :function ("expression") :optional_chain ("optional_chain"))) 
 ("catch_clause" (:body ("statement_block") :parameter ("object_pattern" "identifier" "array_pattern"))) 
 ("class" (:*unnamed* ("class_heritage") :body ("class_body") :decorator ("decorator") :name ("identifier"))) 
 ("class_body" (:member ("field_definition" "method_definition" "class_static_block") :template ("glimmer_template"))) 
 ("class_declaration" (:*unnamed* ("class_heritage") :body ("class_body") :decorator ("decorator") :name ("identifier"))) 
 ("class_heritage" (:*unnamed* ("expression"))) 
 ("class_static_block" (:body ("statement_block"))) 
 ("computed_property_name" (:*unnamed* ("expression"))) 
 ("continue_statement" (:label ("statement_identifier"))) 
 ("decorator" (:*unnamed* ("identifier" "member_expression" "call_expression"))) 
 ("do_statement" (:body ("statement") :condition ("parenthesized_expression"))) 
 ("else_clause" (:*unnamed* ("statement"))) 
 ("export_clause" (:*unnamed* ("export_specifier"))) 
 ("export_specifier" (:alias ("string" "identifier") :name ("string" "identifier"))) 
 ("export_statement" (:*unnamed* ("namespace_export" "export_clause") :declaration ("declaration") :decorator ("decorator") :source ("string") :value ("expression"))) 
 ("expression_statement" (:*unnamed* ("sequence_expression" "expression"))) 
 ("field_definition" (:decorator ("decorator") :property ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :value ("expression"))) 
 ("finally_clause" (:body ("statement_block"))) 
 ("for_in_statement" (:body ("statement") :kind nil :left ("object_pattern" "undefined" "array_pattern" "subscript_expression" "identifier" "member_expression" "parenthesized_expression") :operator nil :right ("sequence_expression" "expression") :value ("expression"))) 
 ("for_statement" (:body ("statement") :condition ("expression_statement" "empty_statement") :increment ("sequence_expression" "expression") :initializer ("expression_statement" "lexical_declaration" "variable_declaration" "empty_statement"))) 
 ("formal_parameters" (:*unnamed* ("assignment_pattern" "pattern"))) 
 ("function" (:body ("statement_block") :name ("identifier") :parameters ("formal_parameters"))) 
 ("function_declaration" (:body ("statement_block") :name ("identifier") :parameters ("formal_parameters"))) 
 ("generator_function" (:body ("statement_block") :name ("identifier") :parameters ("formal_parameters"))) 
 ("generator_function_declaration" (:body ("statement_block") :name ("identifier") :parameters ("formal_parameters"))) 
 ("glimmer_template" (:close_tag ("glimmer_closing_tag") :open_tag ("glimmer_opening_tag"))) 
 ("if_statement" (:alternative ("else_clause") :condition ("parenthesized_expression") :consequence ("statement"))) 
 ("import_clause" (:*unnamed* ("namespace_import" "identifier" "named_imports"))) 
 ("import_specifier" (:alias ("identifier") :name ("string" "identifier"))) 
 ("import_statement" (:*unnamed* ("import_clause") :source ("string"))) 
 ("jsx_attribute" (:*unnamed* ("property_identifier" "string" "jsx_namespace_name" "jsx_self_closing_element" "jsx_expression" "jsx_fragment" "jsx_element"))) 
 ("jsx_closing_element" (:name ("identifier" "jsx_namespace_name" "nested_identifier"))) 
 ("jsx_element" (:*unnamed* ("jsx_self_closing_element" "jsx_expression" "jsx_text" "jsx_fragment" "jsx_element") :close_tag ("jsx_closing_element") :open_tag ("jsx_opening_element"))) 
 ("jsx_expression" (:*unnamed* ("sequence_expression" "spread_element" "expression"))) 
 ("jsx_fragment" (:*unnamed* ("jsx_self_closing_element" "jsx_expression" "jsx_text" "jsx_fragment" "jsx_element"))) 
 ("jsx_namespace_name" (:*unnamed* ("identifier"))) 
 ("jsx_opening_element" (:attribute ("jsx_attribute" "jsx_expression") :name ("identifier" "jsx_namespace_name" "nested_identifier"))) 
 ("jsx_self_closing_element" (:attribute ("jsx_attribute" "jsx_expression") :name ("identifier" "jsx_namespace_name" "nested_identifier"))) 
 ("labeled_statement" (:body ("statement") :label ("statement_identifier"))) 
 ("lexical_declaration" (:*unnamed* ("variable_declarator") :kind nil)) 
 ("member_expression" (:object ("expression") :optional_chain ("optional_chain") :property ("property_identifier" "private_property_identifier"))) 
 ("method_definition" (:body ("statement_block") :decorator ("decorator") :name ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :parameters ("formal_parameters"))) 
 ("named_imports" (:*unnamed* ("import_specifier"))) 
 ("namespace_export" (:*unnamed* ("string" "identifier"))) 
 ("namespace_import" (:*unnamed* ("identifier"))) 
 ("nested_identifier" (:*unnamed* ("identifier" "nested_identifier"))) 
 ("new_expression" (:arguments ("arguments") :constructor ("primary_expression" "new_expression"))) 
 ("object" (:*unnamed* ("spread_element" "method_definition" "shorthand_property_identifier" "pair"))) 
 ("object_assignment_pattern" (:left ("object_pattern" "shorthand_property_identifier_pattern" "array_pattern") :right ("expression"))) 
 ("object_pattern" (:*unnamed* ("object_assignment_pattern" "pair_pattern" "shorthand_property_identifier_pattern" "rest_pattern"))) 
 ("pair" (:key ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :value ("expression"))) 
 ("pair_pattern" (:key ("private_property_identifier" "string" "computed_property_name" "number" "property_identifier") :value ("assignment_pattern" "pattern"))) 
 ("parenthesized_expression" (:*unnamed* ("sequence_expression" "expression"))) 
 ("program" (:*unnamed* ("statement" "hash_bang_line"))) 
 ("regex" (:flags ("regex_flags") :pattern ("regex_pattern"))) 
 ("rest_pattern" (:*unnamed* ("object_pattern" "undefined" "array_pattern" "subscript_expression" "identifier" "member_expression"))) 
 ("return_statement" (:*unnamed* ("sequence_expression" "expression"))) 
 ("sequence_expression" (:left ("expression") :right ("sequence_expression" "expression"))) 
 ("spread_element" (:*unnamed* ("expression"))) 
 ("statement_block" (:*unnamed* ("statement"))) 
 ("string" (:*unnamed* ("escape_sequence" "string_fragment"))) 
 ("subscript_expression" (:index ("sequence_expression" "expression") :object ("expression") :optional_chain ("optional_chain"))) 
 ("switch_body" (:*unnamed* ("switch_default" "switch_case"))) 
 ("switch_case" (:body ("statement") :value ("sequence_expression" "expression"))) 
 ("switch_default" (:body ("statement"))) 
 ("switch_statement" (:body ("switch_body") :value ("parenthesized_expression"))) 
 ("template_string" (:*unnamed* ("escape_sequence" "template_substitution"))) 
 ("template_substitution" (:*unnamed* ("sequence_expression" "expression"))) 
 ("ternary_expression" (:alternative ("expression") :condition ("expression") :consequence ("expression"))) 
 ("throw_statement" (:*unnamed* ("sequence_expression" "expression"))) 
 ("try_statement" (:body ("statement_block") :finalizer ("finally_clause") :handler ("catch_clause"))) 
 ("unary_expression" (:argument ("expression") :operator nil)) 
 ("update_expression" (:argument ("expression") :operator nil)) 
 ("variable_declaration" (:*unnamed* ("variable_declarator"))) 
 ("variable_declarator" (:name ("object_pattern" "identifier" "array_pattern") :value ("expression"))) 
 ("while_statement" (:body ("statement") :condition ("parenthesized_expression"))) 
 ("with_statement" (:body ("statement") :object ("parenthesized_expression"))) 
 ("yield_expression" (:*unnamed* ("expression"))) 
))

(defconst combobulate-rules-jsx-inverted 
 '(("lexical_declaration" ("for_statement" "declaration"))
   ("generator_function_declaration" ("declaration"))
   ("class_declaration" ("declaration"))
   ("function_declaration" ("declaration"))
   ("variable_declaration" ("for_statement" "declaration"))
   ("glimmer_template" ("class_body" "expression"))
   ("binary_expression" ("expression"))
   ("assignment_expression" ("expression"))
   ("jsx_self_closing_element" ("jsx_fragment" "jsx_element" "jsx_attribute" "expression"))
   ("yield_expression" ("expression"))
   ("jsx_fragment" ("jsx_fragment" "jsx_element" "jsx_attribute" "expression"))
   ("jsx_element" ("jsx_fragment" "jsx_element" "jsx_attribute" "expression"))
   ("augmented_assignment_expression" ("expression"))
   ("unary_expression" ("expression"))
   ("primary_expression" ("expression" "new_expression"))
   ("ternary_expression" ("expression"))
   ("new_expression" ("expression" "new_expression"))
   ("update_expression" ("expression"))
   ("await_expression" ("expression"))
   ("object_pattern" ("assignment_expression" "object_assignment_pattern" "for_in_statement" "variable_declarator" "rest_pattern" "catch_clause" "pattern"))
   ("rest_pattern" ("object_pattern" "pattern"))
   ("undefined" ("assignment_expression" "for_in_statement" "rest_pattern" "primary_expression" "pattern"))
   ("array_pattern" ("assignment_expression" "object_assignment_pattern" "for_in_statement" "variable_declarator" "rest_pattern" "catch_clause" "pattern"))
   ("subscript_expression" ("assignment_expression" "for_in_statement" "augmented_assignment_expression" "rest_pattern" "primary_expression" "pattern"))
   ("identifier" ("assignment_expression" "jsx_opening_element" "function" "import_specifier" "jsx_closing_element" "export_specifier" "class" "function_declaration" "arrow_function" "jsx_self_closing_element" "decorator" "for_in_statement" "generator_function" "generator_function_declaration" "class_declaration" "import_clause" "augmented_assignment_expression" "jsx_namespace_name" "namespace_export" "variable_declarator" "rest_pattern" "primary_expression" "nested_identifier" "namespace_import" "catch_clause" "pattern"))
   ("member_expression" ("assignment_expression" "decorator" "for_in_statement" "augmented_assignment_expression" "rest_pattern" "primary_expression" "pattern"))
   ("call_expression" ("primary_expression" "decorator"))
   ("function" ("primary_expression"))
   ("meta_property" ("primary_expression"))
   ("parenthesized_expression" ("do_statement" "assignment_expression" "for_in_statement" "augmented_assignment_expression" "if_statement" "primary_expression" "switch_statement" "with_statement" "while_statement"))
   ("object" ("primary_expression"))
   ("string" ("namespace_export" "jsx_attribute" "export_statement" "import_specifier" "method_definition" "pair" "field_definition" "import_statement" "pair_pattern" "primary_expression" "export_specifier"))
   ("template_string" ("primary_expression" "call_expression"))
   ("number" ("method_definition" "pair" "field_definition" "pair_pattern" "primary_expression"))
   ("false" ("primary_expression"))
   ("class" ("primary_expression"))
   ("arrow_function" ("primary_expression"))
   ("true" ("primary_expression"))
   ("regex" ("primary_expression"))
   ("array" ("primary_expression"))
   ("null" ("primary_expression"))
   ("this" ("primary_expression"))
   ("import" ("primary_expression"))
   ("generator_function" ("primary_expression"))
   ("super" ("primary_expression"))
   ("break_statement" ("statement"))
   ("continue_statement" ("statement"))
   ("try_statement" ("statement"))
   ("import_statement" ("statement"))
   ("debugger_statement" ("statement"))
   ("for_statement" ("statement"))
   ("export_statement" ("statement"))
   ("while_statement" ("statement"))
   ("do_statement" ("statement"))
   ("declaration" ("statement" "export_statement"))
   ("expression_statement" ("statement" "for_statement"))
   ("labeled_statement" ("statement"))
   ("for_in_statement" ("statement"))
   ("throw_statement" ("statement"))
   ("statement_block" ("class_static_block" "function" "method_definition" "try_statement" "finally_clause" "statement" "generator_function" "generator_function_declaration" "catch_clause" "arrow_function" "function_declaration"))
   ("empty_statement" ("statement" "for_statement"))
   ("if_statement" ("statement"))
   ("return_statement" ("statement"))
   ("switch_statement" ("statement"))
   ("with_statement" ("statement"))
   ("spread_element" ("array" "object" "jsx_expression" "arguments"))
   ("expression" ("binary_expression" "assignment_expression" "arguments" "spread_element" "assignment_pattern" "parenthesized_expression" "class_heritage" "for_statement" "export_statement" "ternary_expression" "arrow_function" "await_expression" "yield_expression" "array" "expression_statement" "for_in_statement" "throw_statement" "member_expression" "field_definition" "jsx_expression" "return_statement" "update_expression" "call_expression" "template_substitution" "augmented_assignment_expression" "switch_case" "subscript_expression" "sequence_expression" "object_assignment_pattern" "pair" "unary_expression" "computed_property_name" "variable_declarator"))
   ("assignment_pattern" ("formal_parameters" "pair_pattern" "array_pattern"))
   ("pattern" ("formal_parameters" "pair_pattern" "array_pattern" "assignment_pattern"))
   ("formal_parameters" ("function" "method_definition" "arrow_function" "generator_function" "generator_function_declaration" "function_declaration"))
   ("statement_identifier" ("labeled_statement" "break_statement" "continue_statement"))
   ("arguments" ("new_expression" "call_expression"))
   ("optional_chain" ("subscript_expression" "member_expression" "call_expression"))
   ("class_heritage" ("class_declaration" "class"))
   ("class_body" ("class_declaration" "class"))
   ("decorator" ("method_definition" "field_definition" "class_declaration" "export_statement" "class"))
   ("field_definition" ("class_body"))
   ("method_definition" ("class_body" "object"))
   ("class_static_block" ("class_body"))
   ("statement" ("do_statement" "labeled_statement" "for_in_statement" "statement_block" "switch_default" "if_statement" "else_clause" "while_statement" "switch_case" "for_statement" "with_statement" "program"))
   ("export_specifier" ("export_clause"))
   ("namespace_export" ("export_statement"))
   ("export_clause" ("export_statement"))
   ("sequence_expression" ("expression_statement" "for_in_statement" "throw_statement" "template_substitution" "parenthesized_expression" "jsx_expression" "return_statement" "switch_case" "subscript_expression" "sequence_expression" "for_statement"))
   ("private_property_identifier" ("method_definition" "member_expression" "pair" "field_definition" "pair_pattern"))
   ("computed_property_name" ("field_definition" "pair_pattern" "method_definition" "pair"))
   ("property_identifier" ("jsx_attribute" "method_definition" "member_expression" "pair" "field_definition" "pair_pattern"))
   ("glimmer_closing_tag" ("glimmer_template"))
   ("glimmer_opening_tag" ("glimmer_template"))
   ("else_clause" ("if_statement"))
   ("namespace_import" ("import_clause"))
   ("named_imports" ("import_clause"))
   ("import_clause" ("import_statement"))
   ("jsx_namespace_name" ("jsx_self_closing_element" "jsx_attribute" "jsx_closing_element" "jsx_opening_element"))
   ("jsx_expression" ("jsx_attribute" "jsx_self_closing_element" "jsx_opening_element" "jsx_fragment" "jsx_element"))
   ("nested_identifier" ("jsx_self_closing_element" "jsx_closing_element" "jsx_opening_element" "nested_identifier"))
   ("jsx_text" ("jsx_fragment" "jsx_element"))
   ("jsx_closing_element" ("jsx_element"))
   ("jsx_opening_element" ("jsx_element"))
   ("jsx_attribute" ("jsx_self_closing_element" "jsx_opening_element"))
   ("variable_declarator" ("variable_declaration" "lexical_declaration"))
   ("import_specifier" ("named_imports"))
   ("shorthand_property_identifier" ("object"))
   ("pair" ("object"))
   ("shorthand_property_identifier_pattern" ("object_pattern" "object_assignment_pattern"))
   ("object_assignment_pattern" ("object_pattern"))
   ("pair_pattern" ("object_pattern"))
   ("hash_bang_line" ("program"))
   ("regex_flags" ("regex"))
   ("regex_pattern" ("regex"))
   ("escape_sequence" ("string" "template_string"))
   ("string_fragment" ("string"))
   ("switch_default" ("switch_body"))
   ("switch_case" ("switch_body"))
   ("switch_body" ("switch_statement"))
   ("template_substitution" ("template_string"))
   ("finally_clause" ("try_statement"))
   ("catch_clause" ("try_statement"))
  ) 
)
;; END production rules for jsx





;; START Auto-generated production rules for `go'
(defconst combobulate-rules-go 
 '(("_expression" (:*unnamed* ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal"))) 
 ("_simple_statement" (:*unnamed* ("send_statement" "binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "short_var_declaration" "selector_expression" "false" "rune_literal" "identifier" "inc_statement" "true" "index_expression" "dec_statement" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "assignment_statement" "imaginary_literal"))) 
 ("_simple_type" (:*unnamed* ("interface_type" "array_type" "channel_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "qualified_type" "function_type" "pointer_type"))) 
 ("_statement" (:*unnamed* ("send_statement" "type_declaration" "binary_expression" "continue_statement" "parenthesized_expression" "type_assertion_expression" "interpreted_string_literal" "selector_expression" "const_declaration" "identifier" "block" "for_statement" "true" "index_expression" "dec_statement" "goto_statement" "nil" "defer_statement" "float_literal" "type_switch_statement" "int_literal" "var_declaration" "if_statement" "return_statement" "slice_expression" "raw_string_literal" "assignment_statement" "imaginary_literal" "break_statement" "expression_switch_statement" "call_expression" "type_conversion_expression" "iota" "composite_literal" "func_literal" "short_var_declaration" "inc_statement" "false" "rune_literal" "labeled_statement" "go_statement" "select_statement" "fallthrough_statement" "empty_statement" "unary_expression"))) 
 ("_type" (:*unnamed* ("interface_type" "array_type" "channel_type" "parenthesized_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "qualified_type" "function_type" "pointer_type"))) 
 ("argument_list" (:*unnamed* ("binary_expression" "parenthesized_expression" "type_assertion_expression" "struct_type" "interpreted_string_literal" "slice_type" "selector_expression" "type_identifier" "identifier" "true" "index_expression" "nil" "array_type" "float_literal" "int_literal" "map_type" "slice_expression" "raw_string_literal" "imaginary_literal" "call_expression" "type_conversion_expression" "interface_type" "iota" "channel_type" "composite_literal" "func_literal" "generic_type" "variadic_argument" "false" "rune_literal" "qualified_type" "parenthesized_type" "unary_expression" "function_type" "pointer_type"))) 
 ("array_type" (:element ("interface_type" "array_type" "channel_type" "parenthesized_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "qualified_type" "function_type" "pointer_type") :length ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal"))) 
 ("assignment_statement" (:left ("expression_list") :operator nil :right ("expression_list"))) 
 ("binary_expression" (:left ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal") :operator nil :right ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal"))) 
 ("block" (:*unnamed* ("send_statement" "type_declaration" "binary_expression" "continue_statement" "parenthesized_expression" "type_assertion_expression" "interpreted_string_literal" "selector_expression" "const_declaration" "identifier" "block" "for_statement" "true" "index_expression" "dec_statement" "goto_statement" "nil" "defer_statement" "float_literal" "type_switch_statement" "int_literal" "var_declaration" "if_statement" "return_statement" "slice_expression" "raw_string_literal" "assignment_statement" "imaginary_literal" "break_statement" "expression_switch_statement" "call_expression" "type_conversion_expression" "iota" "composite_literal" "func_literal" "short_var_declaration" "inc_statement" "false" "rune_literal" "labeled_statement" "go_statement" "select_statement" "fallthrough_statement" "empty_statement" "unary_expression"))) 
 ("break_statement" (:*unnamed* ("label_name"))) 
 ("call_expression" (:arguments ("argument_list") :function ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal") :type_arguments ("type_arguments"))) 
 ("channel_type" (:value ("interface_type" "array_type" "channel_type" "parenthesized_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "qualified_type" "function_type" "pointer_type"))) 
 ("communication_case" (:*unnamed* ("send_statement" "type_declaration" "binary_expression" "continue_statement" "parenthesized_expression" "type_assertion_expression" "interpreted_string_literal" "selector_expression" "const_declaration" "identifier" "block" "for_statement" "true" "index_expression" "dec_statement" "goto_statement" "nil" "defer_statement" "float_literal" "type_switch_statement" "int_literal" "var_declaration" "if_statement" "return_statement" "slice_expression" "raw_string_literal" "assignment_statement" "imaginary_literal" "break_statement" "expression_switch_statement" "call_expression" "type_conversion_expression" "iota" "composite_literal" "func_literal" "short_var_declaration" "inc_statement" "false" "rune_literal" "labeled_statement" "go_statement" "select_statement" "fallthrough_statement" "empty_statement" "unary_expression") :communication ("send_statement" "receive_statement"))) 
 ("composite_literal" (:body ("literal_value") :type ("array_type" "map_type" "struct_type" "generic_type" "slice_type" "implicit_length_array_type" "qualified_type" "type_identifier"))) 
 ("const_declaration" (:*unnamed* ("const_spec"))) 
 ("const_spec" (:name ("identifier") :type ("interface_type" "array_type" "channel_type" "parenthesized_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "qualified_type" "function_type" "pointer_type") :value ("expression_list"))) 
 ("constraint_elem" (:*unnamed* ("constraint_term"))) 
 ("constraint_term" (:*unnamed* ("type_identifier"))) 
 ("continue_statement" (:*unnamed* ("label_name"))) 
 ("dec_statement" (:*unnamed* ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal"))) 
 ("default_case" (:*unnamed* ("send_statement" "type_declaration" "binary_expression" "continue_statement" "parenthesized_expression" "type_assertion_expression" "interpreted_string_literal" "selector_expression" "const_declaration" "identifier" "block" "for_statement" "true" "index_expression" "dec_statement" "goto_statement" "nil" "defer_statement" "float_literal" "type_switch_statement" "int_literal" "var_declaration" "if_statement" "return_statement" "slice_expression" "raw_string_literal" "assignment_statement" "imaginary_literal" "break_statement" "expression_switch_statement" "call_expression" "type_conversion_expression" "iota" "composite_literal" "func_literal" "short_var_declaration" "inc_statement" "false" "rune_literal" "labeled_statement" "go_statement" "select_statement" "fallthrough_statement" "empty_statement" "unary_expression"))) 
 ("defer_statement" (:*unnamed* ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal"))) 
 ("expression_case" (:*unnamed* ("send_statement" "type_declaration" "binary_expression" "continue_statement" "parenthesized_expression" "type_assertion_expression" "interpreted_string_literal" "selector_expression" "const_declaration" "identifier" "block" "for_statement" "true" "index_expression" "dec_statement" "goto_statement" "nil" "defer_statement" "float_literal" "type_switch_statement" "int_literal" "var_declaration" "if_statement" "return_statement" "slice_expression" "raw_string_literal" "assignment_statement" "imaginary_literal" "break_statement" "expression_switch_statement" "call_expression" "type_conversion_expression" "iota" "composite_literal" "func_literal" "short_var_declaration" "inc_statement" "false" "rune_literal" "labeled_statement" "go_statement" "select_statement" "fallthrough_statement" "empty_statement" "unary_expression") :value ("expression_list"))) 
 ("expression_list" (:*unnamed* ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal"))) 
 ("expression_switch_statement" (:*unnamed* ("default_case" "expression_case") :initializer ("send_statement" "binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "short_var_declaration" "selector_expression" "false" "rune_literal" "identifier" "inc_statement" "true" "index_expression" "dec_statement" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "assignment_statement" "imaginary_literal") :value ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal"))) 
 ("field_declaration" (:name ("field_identifier") :tag ("interpreted_string_literal" "raw_string_literal") :type ("interface_type" "array_type" "channel_type" "parenthesized_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "qualified_type" "function_type" "pointer_type"))) 
 ("field_declaration_list" (:*unnamed* ("field_declaration"))) 
 ("for_clause" (:condition ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal") :initializer ("send_statement" "binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "short_var_declaration" "selector_expression" "false" "rune_literal" "identifier" "inc_statement" "true" "index_expression" "dec_statement" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "assignment_statement" "imaginary_literal") :update ("send_statement" "binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "short_var_declaration" "selector_expression" "false" "rune_literal" "identifier" "inc_statement" "true" "index_expression" "dec_statement" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "assignment_statement" "imaginary_literal"))) 
 ("for_statement" (:*unnamed* ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "range_clause" "true" "for_clause" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal") :body ("block"))) 
 ("func_literal" (:body ("block") :parameters ("parameter_list") :result ("interface_type" "array_type" "channel_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "parameter_list" "qualified_type" "function_type" "pointer_type"))) 
 ("function_declaration" (:body ("block") :name ("identifier") :parameters ("parameter_list") :result ("interface_type" "array_type" "channel_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "parameter_list" "qualified_type" "function_type" "pointer_type") :type_parameters ("type_parameter_list"))) 
 ("function_type" (:parameters ("parameter_list") :result ("interface_type" "array_type" "channel_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "parameter_list" "qualified_type" "function_type" "pointer_type"))) 
 ("generic_type" (:type ("qualified_type" "type_identifier") :type_arguments ("type_arguments"))) 
 ("go_statement" (:*unnamed* ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal"))) 
 ("goto_statement" (:*unnamed* ("label_name"))) 
 ("if_statement" (:alternative ("if_statement" "block") :condition ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal") :consequence ("block") :initializer ("send_statement" "binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "short_var_declaration" "selector_expression" "false" "rune_literal" "identifier" "inc_statement" "true" "index_expression" "dec_statement" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "assignment_statement" "imaginary_literal"))) 
 ("implicit_length_array_type" (:element ("interface_type" "array_type" "channel_type" "parenthesized_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "qualified_type" "function_type" "pointer_type"))) 
 ("import_declaration" (:*unnamed* ("import_spec" "import_spec_list"))) 
 ("import_spec" (:name ("dot" "blank_identifier" "package_identifier") :path ("interpreted_string_literal" "raw_string_literal"))) 
 ("import_spec_list" (:*unnamed* ("import_spec"))) 
 ("inc_statement" (:*unnamed* ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal"))) 
 ("index_expression" (:index ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal") :operand ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal"))) 
 ("interface_type" (:*unnamed* ("method_spec" "struct_elem" "constraint_elem" "interface_type_name"))) 
 ("interface_type_name" (:*unnamed* ("qualified_type" "type_identifier"))) 
 ("interpreted_string_literal" (:*unnamed* ("escape_sequence"))) 
 ("keyed_element" (:*unnamed* ("literal_element"))) 
 ("labeled_statement" (:*unnamed* ("send_statement" "type_declaration" "binary_expression" "continue_statement" "parenthesized_expression" "type_assertion_expression" "interpreted_string_literal" "selector_expression" "const_declaration" "identifier" "block" "for_statement" "true" "index_expression" "dec_statement" "goto_statement" "nil" "defer_statement" "float_literal" "type_switch_statement" "int_literal" "var_declaration" "if_statement" "return_statement" "slice_expression" "raw_string_literal" "assignment_statement" "imaginary_literal" "break_statement" "expression_switch_statement" "call_expression" "type_conversion_expression" "iota" "composite_literal" "func_literal" "short_var_declaration" "inc_statement" "false" "rune_literal" "labeled_statement" "go_statement" "select_statement" "fallthrough_statement" "empty_statement" "unary_expression") :label ("label_name"))) 
 ("literal_element" (:*unnamed* ("literal_value" "binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal"))) 
 ("literal_value" (:*unnamed* ("literal_element" "keyed_element"))) 
 ("map_type" (:key ("interface_type" "array_type" "channel_type" "parenthesized_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "qualified_type" "function_type" "pointer_type") :value ("interface_type" "array_type" "channel_type" "parenthesized_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "qualified_type" "function_type" "pointer_type"))) 
 ("method_declaration" (:body ("block") :name ("field_identifier") :parameters ("parameter_list") :receiver ("parameter_list") :result ("interface_type" "array_type" "channel_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "parameter_list" "qualified_type" "function_type" "pointer_type"))) 
 ("method_spec" (:name ("field_identifier") :parameters ("parameter_list") :result ("interface_type" "array_type" "channel_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "parameter_list" "qualified_type" "function_type" "pointer_type"))) 
 ("package_clause" (:*unnamed* ("package_identifier"))) 
 ("parameter_declaration" (:name ("identifier") :type ("interface_type" "array_type" "channel_type" "parenthesized_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "qualified_type" "function_type" "pointer_type"))) 
 ("parameter_list" (:*unnamed* ("variadic_parameter_declaration" "parameter_declaration"))) 
 ("parenthesized_expression" (:*unnamed* ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal"))) 
 ("parenthesized_type" (:*unnamed* ("interface_type" "array_type" "channel_type" "parenthesized_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "qualified_type" "function_type" "pointer_type"))) 
 ("pointer_type" (:*unnamed* ("interface_type" "array_type" "channel_type" "parenthesized_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "qualified_type" "function_type" "pointer_type"))) 
 ("qualified_type" (:name ("type_identifier") :package ("package_identifier"))) 
 ("range_clause" (:left ("expression_list") :right ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal"))) 
 ("receive_statement" (:left ("expression_list") :right ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal"))) 
 ("return_statement" (:*unnamed* ("expression_list"))) 
 ("select_statement" (:*unnamed* ("communication_case" "default_case"))) 
 ("selector_expression" (:field ("field_identifier") :operand ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal"))) 
 ("send_statement" (:channel ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal") :value ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal"))) 
 ("short_var_declaration" (:left ("expression_list") :right ("expression_list"))) 
 ("slice_expression" (:capacity ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal") :end ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal") :operand ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal") :start ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal"))) 
 ("slice_type" (:element ("interface_type" "array_type" "channel_type" "parenthesized_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "qualified_type" "function_type" "pointer_type"))) 
 ("source_file" (:*unnamed* ("send_statement" "type_declaration" "binary_expression" "continue_statement" "parenthesized_expression" "type_assertion_expression" "interpreted_string_literal" "selector_expression" "const_declaration" "identifier" "block" "for_statement" "function_declaration" "true" "index_expression" "dec_statement" "goto_statement" "nil" "defer_statement" "float_literal" "type_switch_statement" "int_literal" "var_declaration" "if_statement" "package_clause" "return_statement" "slice_expression" "import_declaration" "raw_string_literal" "assignment_statement" "imaginary_literal" "break_statement" "expression_switch_statement" "call_expression" "type_conversion_expression" "iota" "composite_literal" "func_literal" "short_var_declaration" "inc_statement" "false" "rune_literal" "labeled_statement" "go_statement" "select_statement" "fallthrough_statement" "empty_statement" "unary_expression" "method_declaration"))) 
 ("struct_elem" (:*unnamed* ("struct_term"))) 
 ("struct_term" (:*unnamed* ("struct_type"))) 
 ("struct_type" (:*unnamed* ("field_declaration_list"))) 
 ("type_alias" (:name ("type_identifier") :type ("interface_type" "array_type" "channel_type" "parenthesized_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "qualified_type" "function_type" "pointer_type"))) 
 ("type_arguments" (:*unnamed* ("interface_type" "array_type" "channel_type" "parenthesized_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "qualified_type" "function_type" "pointer_type"))) 
 ("type_assertion_expression" (:operand ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal") :type ("interface_type" "array_type" "channel_type" "parenthesized_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "qualified_type" "function_type" "pointer_type"))) 
 ("type_case" (:*unnamed* ("send_statement" "type_declaration" "binary_expression" "continue_statement" "parenthesized_expression" "type_assertion_expression" "interpreted_string_literal" "selector_expression" "const_declaration" "identifier" "block" "for_statement" "true" "index_expression" "dec_statement" "goto_statement" "nil" "defer_statement" "float_literal" "type_switch_statement" "int_literal" "var_declaration" "if_statement" "return_statement" "slice_expression" "raw_string_literal" "assignment_statement" "imaginary_literal" "break_statement" "expression_switch_statement" "call_expression" "type_conversion_expression" "iota" "composite_literal" "func_literal" "short_var_declaration" "inc_statement" "false" "rune_literal" "labeled_statement" "go_statement" "select_statement" "fallthrough_statement" "empty_statement" "unary_expression") :type ("interface_type" "array_type" "channel_type" "parenthesized_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "qualified_type" "function_type" "pointer_type"))) 
 ("type_conversion_expression" (:operand ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal") :type ("interface_type" "array_type" "channel_type" "parenthesized_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "qualified_type" "function_type" "pointer_type"))) 
 ("type_declaration" (:*unnamed* ("type_alias" "type_spec"))) 
 ("type_parameter_list" (:*unnamed* ("parameter_declaration"))) 
 ("type_spec" (:name ("type_identifier") :type ("interface_type" "array_type" "channel_type" "parenthesized_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "qualified_type" "function_type" "pointer_type") :type_parameters ("type_parameter_list"))) 
 ("type_switch_statement" (:*unnamed* ("default_case" "type_case") :alias ("expression_list") :initializer ("send_statement" "binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "short_var_declaration" "selector_expression" "false" "rune_literal" "identifier" "inc_statement" "true" "index_expression" "dec_statement" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "assignment_statement" "imaginary_literal") :value ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal"))) 
 ("unary_expression" (:operand ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal") :operator nil)) 
 ("var_declaration" (:*unnamed* ("var_spec"))) 
 ("var_spec" (:name ("identifier") :type ("interface_type" "array_type" "channel_type" "parenthesized_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "qualified_type" "function_type" "pointer_type") :value ("expression_list"))) 
 ("variadic_argument" (:*unnamed* ("binary_expression" "call_expression" "type_conversion_expression" "iota" "composite_literal" "parenthesized_expression" "type_assertion_expression" "func_literal" "interpreted_string_literal" "selector_expression" "false" "rune_literal" "identifier" "true" "index_expression" "nil" "float_literal" "int_literal" "unary_expression" "slice_expression" "raw_string_literal" "imaginary_literal"))) 
 ("variadic_parameter_declaration" (:name ("identifier") :type ("interface_type" "array_type" "channel_type" "parenthesized_type" "map_type" "struct_type" "generic_type" "slice_type" "type_identifier" "qualified_type" "function_type" "pointer_type"))) 
))

(defconst combobulate-rules-go-inverted 
 '(("binary_expression" ("send_statement" "binary_expression" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "selector_expression" "for_statement" "block" "range_clause" "index_expression" "type_case" "dec_statement" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "source_file" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("call_expression" ("send_statement" "binary_expression" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "selector_expression" "for_statement" "block" "range_clause" "index_expression" "type_case" "dec_statement" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "source_file" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("type_conversion_expression" ("send_statement" "binary_expression" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "selector_expression" "for_statement" "block" "range_clause" "index_expression" "type_case" "dec_statement" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "source_file" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("iota" ("send_statement" "binary_expression" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "selector_expression" "for_statement" "block" "range_clause" "index_expression" "type_case" "dec_statement" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "source_file" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("composite_literal" ("send_statement" "binary_expression" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "selector_expression" "for_statement" "block" "range_clause" "index_expression" "type_case" "dec_statement" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "source_file" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("parenthesized_expression" ("send_statement" "binary_expression" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "selector_expression" "for_statement" "block" "range_clause" "index_expression" "type_case" "dec_statement" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "source_file" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("type_assertion_expression" ("send_statement" "binary_expression" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "selector_expression" "for_statement" "block" "range_clause" "index_expression" "type_case" "dec_statement" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "source_file" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("func_literal" ("send_statement" "binary_expression" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "selector_expression" "for_statement" "block" "range_clause" "index_expression" "type_case" "dec_statement" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "source_file" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("interpreted_string_literal" ("send_statement" "binary_expression" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "field_declaration" "selector_expression" "for_statement" "block" "range_clause" "index_expression" "type_case" "dec_statement" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "source_file" "import_spec" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("selector_expression" ("send_statement" "binary_expression" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "selector_expression" "for_statement" "block" "range_clause" "index_expression" "type_case" "dec_statement" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "source_file" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("false" ("send_statement" "binary_expression" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "selector_expression" "for_statement" "block" "range_clause" "index_expression" "type_case" "dec_statement" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "source_file" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("rune_literal" ("send_statement" "binary_expression" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "selector_expression" "for_statement" "block" "range_clause" "index_expression" "type_case" "dec_statement" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "source_file" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("identifier" ("send_statement" "binary_expression" "parameter_declaration" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "variadic_parameter_declaration" "selector_expression" "for_statement" "block" "range_clause" "function_declaration" "index_expression" "type_case" "dec_statement" "var_spec" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "const_spec" "source_file" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("true" ("send_statement" "binary_expression" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "selector_expression" "for_statement" "block" "range_clause" "index_expression" "type_case" "dec_statement" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "source_file" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("index_expression" ("send_statement" "binary_expression" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "selector_expression" "for_statement" "block" "range_clause" "index_expression" "type_case" "dec_statement" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "source_file" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("nil" ("send_statement" "binary_expression" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "selector_expression" "for_statement" "block" "range_clause" "index_expression" "type_case" "dec_statement" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "source_file" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("float_literal" ("send_statement" "binary_expression" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "selector_expression" "for_statement" "block" "range_clause" "index_expression" "type_case" "dec_statement" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "source_file" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("int_literal" ("send_statement" "binary_expression" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "selector_expression" "for_statement" "block" "range_clause" "index_expression" "type_case" "dec_statement" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "source_file" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("unary_expression" ("send_statement" "binary_expression" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "selector_expression" "for_statement" "block" "range_clause" "index_expression" "type_case" "dec_statement" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "source_file" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("slice_expression" ("send_statement" "binary_expression" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "selector_expression" "for_statement" "block" "range_clause" "index_expression" "type_case" "dec_statement" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "source_file" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("raw_string_literal" ("send_statement" "binary_expression" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "field_declaration" "selector_expression" "for_statement" "block" "range_clause" "index_expression" "type_case" "dec_statement" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "source_file" "import_spec" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("imaginary_literal" ("send_statement" "binary_expression" "receive_statement" "literal_element" "parenthesized_expression" "type_assertion_expression" "expression_list" "selector_expression" "for_statement" "block" "range_clause" "index_expression" "type_case" "dec_statement" "_statement" "array_type" "defer_statement" "type_switch_statement" "if_statement" "argument_list" "_simple_statement" "communication_case" "slice_expression" "expression_switch_statement" "call_expression" "type_conversion_expression" "source_file" "variadic_argument" "inc_statement" "expression_case" "for_clause" "default_case" "labeled_statement" "go_statement" "unary_expression" "_expression"))
   ("send_statement" ("expression_switch_statement" "for_clause" "type_case" "default_case" "_statement" "labeled_statement" "source_file" "type_switch_statement" "if_statement" "_simple_statement" "communication_case" "expression_case" "block"))
   ("short_var_declaration" ("expression_switch_statement" "for_clause" "type_case" "default_case" "_statement" "labeled_statement" "source_file" "type_switch_statement" "if_statement" "_simple_statement" "communication_case" "expression_case" "block"))
   ("inc_statement" ("expression_switch_statement" "for_clause" "type_case" "default_case" "_statement" "labeled_statement" "source_file" "type_switch_statement" "if_statement" "_simple_statement" "communication_case" "expression_case" "block"))
   ("dec_statement" ("expression_switch_statement" "for_clause" "type_case" "default_case" "_statement" "labeled_statement" "source_file" "type_switch_statement" "if_statement" "_simple_statement" "communication_case" "expression_case" "block"))
   ("assignment_statement" ("expression_switch_statement" "for_clause" "type_case" "default_case" "_statement" "labeled_statement" "source_file" "type_switch_statement" "if_statement" "_simple_statement" "communication_case" "expression_case" "block"))
   ("interface_type" ("parameter_declaration" "type_assertion_expression" "variadic_parameter_declaration" "_type" "slice_type" "field_declaration" "_simple_type" "function_declaration" "type_case" "var_spec" "array_type" "map_type" "type_arguments" "argument_list" "type_alias" "type_conversion_expression" "const_spec" "channel_type" "func_literal" "method_spec" "parenthesized_type" "implicit_length_array_type" "function_type" "pointer_type" "method_declaration" "type_spec"))
   ("array_type" ("parameter_declaration" "type_assertion_expression" "variadic_parameter_declaration" "_type" "slice_type" "field_declaration" "_simple_type" "function_declaration" "type_case" "var_spec" "array_type" "map_type" "type_arguments" "argument_list" "type_alias" "type_conversion_expression" "const_spec" "channel_type" "composite_literal" "func_literal" "method_spec" "parenthesized_type" "implicit_length_array_type" "function_type" "pointer_type" "method_declaration" "type_spec"))
   ("channel_type" ("parameter_declaration" "type_assertion_expression" "variadic_parameter_declaration" "_type" "slice_type" "field_declaration" "_simple_type" "function_declaration" "type_case" "var_spec" "array_type" "map_type" "type_arguments" "argument_list" "type_alias" "type_conversion_expression" "const_spec" "channel_type" "func_literal" "method_spec" "parenthesized_type" "implicit_length_array_type" "function_type" "pointer_type" "method_declaration" "type_spec"))
   ("map_type" ("parameter_declaration" "type_assertion_expression" "variadic_parameter_declaration" "_type" "slice_type" "field_declaration" "_simple_type" "function_declaration" "type_case" "var_spec" "array_type" "map_type" "type_arguments" "argument_list" "type_alias" "type_conversion_expression" "const_spec" "channel_type" "composite_literal" "func_literal" "method_spec" "parenthesized_type" "implicit_length_array_type" "function_type" "pointer_type" "method_declaration" "type_spec"))
   ("struct_type" ("parameter_declaration" "type_assertion_expression" "variadic_parameter_declaration" "_type" "slice_type" "field_declaration" "_simple_type" "function_declaration" "type_case" "var_spec" "array_type" "map_type" "type_arguments" "argument_list" "type_alias" "type_conversion_expression" "const_spec" "channel_type" "composite_literal" "func_literal" "struct_term" "method_spec" "parenthesized_type" "implicit_length_array_type" "function_type" "pointer_type" "method_declaration" "type_spec"))
   ("generic_type" ("parameter_declaration" "type_assertion_expression" "variadic_parameter_declaration" "_type" "slice_type" "field_declaration" "_simple_type" "function_declaration" "type_case" "var_spec" "array_type" "map_type" "type_arguments" "argument_list" "type_alias" "type_conversion_expression" "const_spec" "channel_type" "composite_literal" "func_literal" "method_spec" "parenthesized_type" "implicit_length_array_type" "function_type" "pointer_type" "method_declaration" "type_spec"))
   ("slice_type" ("parameter_declaration" "type_assertion_expression" "variadic_parameter_declaration" "_type" "slice_type" "field_declaration" "_simple_type" "function_declaration" "type_case" "var_spec" "array_type" "map_type" "type_arguments" "argument_list" "type_alias" "type_conversion_expression" "const_spec" "channel_type" "composite_literal" "func_literal" "method_spec" "parenthesized_type" "implicit_length_array_type" "function_type" "pointer_type" "method_declaration" "type_spec"))
   ("type_identifier" ("parameter_declaration" "type_assertion_expression" "variadic_parameter_declaration" "_type" "slice_type" "field_declaration" "_simple_type" "function_declaration" "type_case" "var_spec" "array_type" "map_type" "type_arguments" "argument_list" "constraint_term" "type_alias" "type_conversion_expression" "const_spec" "channel_type" "composite_literal" "func_literal" "generic_type" "interface_type_name" "qualified_type" "method_spec" "parenthesized_type" "implicit_length_array_type" "function_type" "pointer_type" "method_declaration" "type_spec"))
   ("qualified_type" ("parameter_declaration" "type_assertion_expression" "variadic_parameter_declaration" "_type" "slice_type" "field_declaration" "_simple_type" "function_declaration" "type_case" "var_spec" "array_type" "map_type" "type_arguments" "argument_list" "type_alias" "type_conversion_expression" "const_spec" "channel_type" "composite_literal" "func_literal" "generic_type" "interface_type_name" "method_spec" "parenthesized_type" "implicit_length_array_type" "function_type" "pointer_type" "method_declaration" "type_spec"))
   ("function_type" ("parameter_declaration" "type_assertion_expression" "variadic_parameter_declaration" "_type" "slice_type" "field_declaration" "_simple_type" "function_declaration" "type_case" "var_spec" "array_type" "map_type" "type_arguments" "argument_list" "type_alias" "type_conversion_expression" "const_spec" "channel_type" "func_literal" "method_spec" "parenthesized_type" "implicit_length_array_type" "function_type" "pointer_type" "method_declaration" "type_spec"))
   ("pointer_type" ("parameter_declaration" "type_assertion_expression" "variadic_parameter_declaration" "_type" "slice_type" "field_declaration" "_simple_type" "function_declaration" "type_case" "var_spec" "array_type" "map_type" "type_arguments" "argument_list" "type_alias" "type_conversion_expression" "const_spec" "channel_type" "func_literal" "method_spec" "parenthesized_type" "implicit_length_array_type" "function_type" "pointer_type" "method_declaration" "type_spec"))
   ("type_declaration" ("type_case" "default_case" "_statement" "labeled_statement" "source_file" "communication_case" "expression_case" "block"))
   ("continue_statement" ("type_case" "default_case" "_statement" "labeled_statement" "source_file" "communication_case" "expression_case" "block"))
   ("const_declaration" ("type_case" "default_case" "_statement" "labeled_statement" "source_file" "communication_case" "expression_case" "block"))
   ("block" ("type_case" "default_case" "_statement" "labeled_statement" "source_file" "func_literal" "if_statement" "communication_case" "expression_case" "block" "method_declaration" "function_declaration" "for_statement"))
   ("for_statement" ("type_case" "default_case" "_statement" "labeled_statement" "source_file" "communication_case" "expression_case" "block"))
   ("goto_statement" ("type_case" "default_case" "_statement" "labeled_statement" "source_file" "communication_case" "expression_case" "block"))
   ("defer_statement" ("type_case" "default_case" "_statement" "labeled_statement" "source_file" "communication_case" "expression_case" "block"))
   ("type_switch_statement" ("type_case" "default_case" "_statement" "labeled_statement" "source_file" "communication_case" "expression_case" "block"))
   ("var_declaration" ("type_case" "default_case" "_statement" "labeled_statement" "source_file" "communication_case" "expression_case" "block"))
   ("if_statement" ("type_case" "default_case" "_statement" "labeled_statement" "source_file" "if_statement" "communication_case" "expression_case" "block"))
   ("return_statement" ("type_case" "default_case" "_statement" "labeled_statement" "source_file" "communication_case" "expression_case" "block"))
   ("break_statement" ("type_case" "default_case" "_statement" "labeled_statement" "source_file" "communication_case" "expression_case" "block"))
   ("expression_switch_statement" ("type_case" "default_case" "_statement" "labeled_statement" "source_file" "communication_case" "expression_case" "block"))
   ("labeled_statement" ("type_case" "default_case" "_statement" "labeled_statement" "source_file" "communication_case" "expression_case" "block"))
   ("go_statement" ("type_case" "default_case" "_statement" "labeled_statement" "source_file" "communication_case" "expression_case" "block"))
   ("select_statement" ("type_case" "default_case" "_statement" "labeled_statement" "source_file" "communication_case" "expression_case" "block"))
   ("fallthrough_statement" ("type_case" "default_case" "_statement" "labeled_statement" "source_file" "communication_case" "expression_case" "block"))
   ("empty_statement" ("type_case" "default_case" "_statement" "labeled_statement" "source_file" "communication_case" "expression_case" "block"))
   ("parenthesized_type" ("parameter_declaration" "type_assertion_expression" "variadic_parameter_declaration" "_type" "slice_type" "field_declaration" "type_case" "var_spec" "array_type" "map_type" "type_arguments" "argument_list" "type_alias" "type_conversion_expression" "const_spec" "channel_type" "parenthesized_type" "implicit_length_array_type" "pointer_type" "type_spec"))
   ("variadic_argument" ("argument_list"))
   ("expression_list" ("var_spec" "const_spec" "receive_statement" "type_switch_statement" "short_var_declaration" "return_statement" "expression_case" "range_clause" "assignment_statement"))
   ("label_name" ("goto_statement" "labeled_statement" "break_statement" "continue_statement"))
   ("argument_list" ("call_expression"))
   ("type_arguments" ("generic_type" "call_expression"))
   ("receive_statement" ("communication_case"))
   ("literal_value" ("composite_literal" "literal_element"))
   ("implicit_length_array_type" ("composite_literal"))
   ("const_spec" ("const_declaration"))
   ("constraint_term" ("constraint_elem"))
   ("default_case" ("expression_switch_statement" "type_switch_statement" "select_statement"))
   ("expression_case" ("expression_switch_statement"))
   ("field_identifier" ("method_spec" "method_declaration" "field_declaration" "selector_expression"))
   ("field_declaration" ("field_declaration_list"))
   ("range_clause" ("for_statement"))
   ("for_clause" ("for_statement"))
   ("parameter_list" ("method_spec" "func_literal" "function_type" "method_declaration" "function_declaration"))
   ("type_parameter_list" ("function_declaration" "type_spec"))
   ("import_spec" ("import_declaration" "import_spec_list"))
   ("import_spec_list" ("import_declaration"))
   ("dot" ("import_spec"))
   ("blank_identifier" ("import_spec"))
   ("package_identifier" ("qualified_type" "import_spec" "package_clause"))
   ("method_spec" ("interface_type"))
   ("struct_elem" ("interface_type"))
   ("constraint_elem" ("interface_type"))
   ("interface_type_name" ("interface_type"))
   ("escape_sequence" ("interpreted_string_literal"))
   ("literal_element" ("literal_value" "keyed_element"))
   ("keyed_element" ("literal_value"))
   ("variadic_parameter_declaration" ("parameter_list"))
   ("parameter_declaration" ("parameter_list" "type_parameter_list"))
   ("communication_case" ("select_statement"))
   ("function_declaration" ("source_file"))
   ("package_clause" ("source_file"))
   ("import_declaration" ("source_file"))
   ("method_declaration" ("source_file"))
   ("struct_term" ("struct_elem"))
   ("field_declaration_list" ("struct_type"))
   ("type_alias" ("type_declaration"))
   ("type_spec" ("type_declaration"))
   ("type_case" ("type_switch_statement"))
   ("var_spec" ("var_declaration"))
  ) 
)
;; END production rules for go





;; START Auto-generated production rules for `python'
(defconst combobulate-rules-python 
 '(("_compound_statement" (:*unnamed* ("with_statement" "match_statement" "function_definition" "try_statement" "class_definition" "if_statement" "for_statement" "decorated_definition" "while_statement"))) 
 ("_simple_statement" (:*unnamed* ("break_statement" "future_import_statement" "expression_statement" "continue_statement" "global_statement" "pass_statement" "assert_statement" "delete_statement" "import_statement" "print_statement" "return_statement" "exec_statement" "raise_statement" "import_from_statement" "nonlocal_statement"))) 
 ("expression" (:*unnamed* ("not_operator" "boolean_operator" "as_pattern" "await" "lambda" "comparison_operator" "primary_expression" "conditional_expression" "named_expression"))) 
 ("parameter" (:*unnamed* ("list_splat_pattern" "typed_default_parameter" "typed_parameter" "dictionary_splat_pattern" "default_parameter" "tuple_pattern" "positional_separator" "identifier" "keyword_separator"))) 
 ("pattern" (:*unnamed* ("list_splat_pattern" "tuple_pattern" "attribute" "subscript" "identifier" "list_pattern"))) 
 ("primary_expression" (:*unnamed* ("tuple" "list" "attribute" "integer" "binary_operator" "parenthesized_expression" "dictionary_comprehension" "string" "set_comprehension" "false" "subscript" "identifier" "dictionary" "ellipsis" "true" "set" "call" "list_comprehension" "float" "unary_operator" "generator_expression" "none" "concatenated_string"))) 
 ("aliased_import" (:alias ("identifier") :name ("dotted_name"))) 
 ("argument_list" (:*unnamed* ("keyword_argument" "dictionary_splat" "expression" "list_splat" "parenthesized_expression"))) 
 ("as_pattern" (:*unnamed* ("expression") :alias ("as_pattern_target"))) 
 ("assert_statement" (:*unnamed* ("expression"))) 
 ("assignment" (:left ("pattern_list" "pattern") :right ("yield" "expression_list" "assignment" "augmented_assignment" "expression") :type ("type"))) 
 ("attribute" (:attribute ("identifier") :object ("primary_expression"))) 
 ("augmented_assignment" (:left ("pattern_list" "pattern") :operator nil :right ("yield" "expression_list" "assignment" "augmented_assignment" "expression"))) 
 ("await" (:*unnamed* ("expression"))) 
 ("binary_operator" (:left ("primary_expression") :operator nil :right ("primary_expression"))) 
 ("block" (:*unnamed* ("break_statement" "continue_statement" "function_definition" "try_statement" "class_definition" "delete_statement" "import_statement" "print_statement" "import_from_statement" "exec_statement" "for_statement" "decorated_definition" "while_statement" "match_statement" "future_import_statement" "expression_statement" "global_statement" "assert_statement" "if_statement" "return_statement" "raise_statement" "pass_statement" "nonlocal_statement" "with_statement"))) 
 ("boolean_operator" (:left ("expression") :operator nil :right ("expression"))) 
 ("call" (:arguments ("generator_expression" "argument_list") :function ("primary_expression"))) 
 ("case_clause" (:consequence ("block") :guard ("if_clause") :pattern ("case_pattern"))) 
 ("case_pattern" (:*unnamed* ("subscript" "identifier" "attribute"))) 
 ("chevron" (:*unnamed* ("expression"))) 
 ("class_definition" (:body ("block") :name ("identifier") :superclasses ("argument_list"))) 
 ("comparison_operator" (:*unnamed* ("primary_expression") :operators nil)) 
 ("concatenated_string" (:*unnamed* ("string"))) 
 ("conditional_expression" (:*unnamed* ("expression"))) 
 ("decorated_definition" (:*unnamed* ("decorator") :definition ("class_definition" "function_definition"))) 
 ("decorator" (:*unnamed* ("expression"))) 
 ("default_parameter" (:name ("identifier") :value ("expression"))) 
 ("delete_statement" (:*unnamed* ("expression_list" "expression"))) 
 ("dictionary" (:*unnamed* ("pair" "dictionary_splat"))) 
 ("dictionary_comprehension" (:*unnamed* ("if_clause" "for_in_clause") :body ("pair"))) 
 ("dictionary_splat" (:*unnamed* ("expression"))) 
 ("dictionary_splat_pattern" (:*unnamed* ("subscript" "identifier" "attribute"))) 
 ("dotted_name" (:*unnamed* ("identifier"))) 
 ("elif_clause" (:condition ("expression") :consequence ("block"))) 
 ("else_clause" (:body ("block"))) 
 ("except_clause" (:*unnamed* ("block" "expression"))) 
 ("except_group_clause" (:*unnamed* ("block" "expression"))) 
 ("exec_statement" (:*unnamed* ("expression") :code ("string"))) 
 ("expression_list" (:*unnamed* ("expression"))) 
 ("expression_statement" (:*unnamed* ("assignment" "yield" "augmented_assignment" "expression"))) 
 ("finally_clause" (:*unnamed* ("block"))) 
 ("for_in_clause" (:left ("pattern_list" "pattern") :right ("expression"))) 
 ("for_statement" (:alternative ("else_clause") :body ("block") :left ("pattern_list" "pattern") :right ("expression_list" "expression"))) 
 ("format_expression" (:expression ("yield" "expression_list" "expression") :format_specifier ("format_specifier") :type_conversion ("type_conversion"))) 
 ("format_specifier" (:*unnamed* ("format_expression"))) 
 ("function_definition" (:body ("block") :name ("identifier") :parameters ("parameters") :return_type ("type"))) 
 ("future_import_statement" (:name ("aliased_import" "dotted_name"))) 
 ("generator_expression" (:*unnamed* ("if_clause" "for_in_clause") :body ("expression"))) 
 ("global_statement" (:*unnamed* ("identifier"))) 
 ("if_clause" (:*unnamed* ("expression"))) 
 ("if_statement" (:alternative ("elif_clause" "else_clause") :condition ("expression") :consequence ("block"))) 
 ("import_from_statement" (:*unnamed* ("wildcard_import") :module_name ("relative_import" "dotted_name") :name ("aliased_import" "dotted_name"))) 
 ("import_statement" (:name ("aliased_import" "dotted_name"))) 
 ("interpolation" (:expression ("yield" "expression_list" "expression") :format_specifier ("format_specifier") :type_conversion ("type_conversion"))) 
 ("keyword_argument" (:name ("identifier") :value ("expression"))) 
 ("lambda" (:body ("expression") :parameters ("lambda_parameters"))) 
 ("lambda_parameters" (:*unnamed* ("parameter"))) 
 ("list" (:*unnamed* ("yield" "parenthesized_list_splat" "expression" "list_splat"))) 
 ("list_comprehension" (:*unnamed* ("if_clause" "for_in_clause") :body ("expression"))) 
 ("list_pattern" (:*unnamed* ("pattern"))) 
 ("list_splat" (:*unnamed* ("expression"))) 
 ("list_splat_pattern" (:*unnamed* ("subscript" "identifier" "attribute"))) 
 ("match_statement" (:alternative ("case_clause") :subject ("expression"))) 
 ("module" (:*unnamed* ("break_statement" "continue_statement" "function_definition" "try_statement" "class_definition" "delete_statement" "import_statement" "print_statement" "import_from_statement" "exec_statement" "for_statement" "decorated_definition" "while_statement" "match_statement" "future_import_statement" "expression_statement" "global_statement" "assert_statement" "if_statement" "return_statement" "raise_statement" "pass_statement" "nonlocal_statement" "with_statement"))) 
 ("named_expression" (:name ("identifier") :value ("expression"))) 
 ("nonlocal_statement" (:*unnamed* ("identifier"))) 
 ("not_operator" (:argument ("expression"))) 
 ("pair" (:key ("expression") :value ("expression"))) 
 ("parameters" (:*unnamed* ("parameter"))) 
 ("parenthesized_expression" (:*unnamed* ("yield" "expression" "list_splat" "parenthesized_expression"))) 
 ("parenthesized_list_splat" (:*unnamed* ("list_splat" "parenthesized_expression"))) 
 ("pattern_list" (:*unnamed* ("pattern"))) 
 ("print_statement" (:*unnamed* ("chevron") :argument ("expression"))) 
 ("raise_statement" (:*unnamed* ("expression_list" "expression") :cause ("expression"))) 
 ("relative_import" (:*unnamed* ("import_prefix" "dotted_name"))) 
 ("return_statement" (:*unnamed* ("expression_list" "expression"))) 
 ("set" (:*unnamed* ("yield" "parenthesized_list_splat" "expression" "list_splat"))) 
 ("set_comprehension" (:*unnamed* ("if_clause" "for_in_clause") :body ("expression"))) 
 ("slice" (:*unnamed* ("expression"))) 
 ("string" (:interpolation ("interpolation") :prefix nil :string_content ("string_content") :suffix nil)) 
 ("string_content" (:*unnamed* ("escape_sequence"))) 
 ("subscript" (:subscript ("slice" "expression") :value ("primary_expression"))) 
 ("try_statement" (:*unnamed* ("except_clause" "else_clause" "except_group_clause" "finally_clause") :body ("block"))) 
 ("tuple" (:*unnamed* ("yield" "parenthesized_list_splat" "expression" "list_splat"))) 
 ("tuple_pattern" (:*unnamed* ("pattern"))) 
 ("type" (:*unnamed* ("expression"))) 
 ("typed_default_parameter" (:name ("identifier") :type ("type") :value ("expression"))) 
 ("typed_parameter" (:*unnamed* ("list_splat_pattern" "dictionary_splat_pattern" "identifier") :type ("type"))) 
 ("unary_operator" (:argument ("primary_expression") :operator nil)) 
 ("while_statement" (:alternative ("else_clause") :body ("block") :condition ("expression"))) 
 ("with_clause" (:*unnamed* ("with_item"))) 
 ("with_item" (:value ("expression"))) 
 ("with_statement" (:*unnamed* ("with_clause") :body ("block"))) 
 ("yield" (:*unnamed* ("expression_list" "expression"))) 
))

(defconst combobulate-rules-python-inverted 
 '(("with_statement" ("block" "module" "_compound_statement"))
   ("match_statement" ("block" "module" "_compound_statement"))
   ("function_definition" ("block" "module" "decorated_definition" "_compound_statement"))
   ("try_statement" ("block" "module" "_compound_statement"))
   ("class_definition" ("block" "module" "decorated_definition" "_compound_statement"))
   ("if_statement" ("block" "module" "_compound_statement"))
   ("for_statement" ("block" "module" "_compound_statement"))
   ("decorated_definition" ("block" "module" "_compound_statement"))
   ("while_statement" ("block" "module" "_compound_statement"))
   ("break_statement" ("block" "module" "_simple_statement"))
   ("future_import_statement" ("block" "module" "_simple_statement"))
   ("expression_statement" ("block" "module" "_simple_statement"))
   ("continue_statement" ("block" "module" "_simple_statement"))
   ("global_statement" ("block" "module" "_simple_statement"))
   ("pass_statement" ("block" "module" "_simple_statement"))
   ("assert_statement" ("block" "module" "_simple_statement"))
   ("delete_statement" ("block" "module" "_simple_statement"))
   ("import_statement" ("block" "module" "_simple_statement"))
   ("print_statement" ("block" "module" "_simple_statement"))
   ("return_statement" ("block" "module" "_simple_statement"))
   ("exec_statement" ("block" "module" "_simple_statement"))
   ("raise_statement" ("block" "module" "_simple_statement"))
   ("import_from_statement" ("block" "module" "_simple_statement"))
   ("nonlocal_statement" ("block" "module" "_simple_statement"))
   ("not_operator" ("expression"))
   ("boolean_operator" ("expression"))
   ("as_pattern" ("expression"))
   ("await" ("expression"))
   ("lambda" ("expression"))
   ("comparison_operator" ("expression"))
   ("primary_expression" ("call" "attribute" "binary_operator" "expression" "comparison_operator" "unary_operator" "subscript"))
   ("conditional_expression" ("expression"))
   ("named_expression" ("expression"))
   ("list_splat_pattern" ("parameter" "typed_parameter" "pattern"))
   ("typed_default_parameter" ("parameter"))
   ("typed_parameter" ("parameter"))
   ("dictionary_splat_pattern" ("parameter" "typed_parameter"))
   ("default_parameter" ("parameter"))
   ("tuple_pattern" ("parameter" "pattern"))
   ("positional_separator" ("parameter"))
   ("identifier" ("list_splat_pattern" "typed_default_parameter" "keyword_argument" "typed_parameter" "attribute" "dictionary_splat_pattern" "function_definition" "global_statement" "aliased_import" "case_pattern" "class_definition" "default_parameter" "primary_expression" "parameter" "dotted_name" "nonlocal_statement" "named_expression" "pattern"))
   ("keyword_separator" ("parameter"))
   ("attribute" ("list_splat_pattern" "dictionary_splat_pattern" "case_pattern" "primary_expression" "pattern"))
   ("subscript" ("list_splat_pattern" "dictionary_splat_pattern" "case_pattern" "primary_expression" "pattern"))
   ("list_pattern" ("pattern"))
   ("tuple" ("primary_expression"))
   ("list" ("primary_expression"))
   ("integer" ("primary_expression"))
   ("binary_operator" ("primary_expression"))
   ("parenthesized_expression" ("parenthesized_list_splat" "argument_list" "primary_expression" "parenthesized_expression"))
   ("dictionary_comprehension" ("primary_expression"))
   ("string" ("primary_expression" "exec_statement" "concatenated_string"))
   ("set_comprehension" ("primary_expression"))
   ("false" ("primary_expression"))
   ("dictionary" ("primary_expression"))
   ("ellipsis" ("primary_expression"))
   ("true" ("primary_expression"))
   ("set" ("primary_expression"))
   ("call" ("primary_expression"))
   ("list_comprehension" ("primary_expression"))
   ("float" ("primary_expression"))
   ("unary_operator" ("primary_expression"))
   ("generator_expression" ("call" "primary_expression"))
   ("none" ("primary_expression"))
   ("concatenated_string" ("primary_expression"))
   ("dotted_name" ("relative_import" "future_import_statement" "aliased_import" "import_statement" "import_from_statement"))
   ("keyword_argument" ("argument_list"))
   ("dictionary_splat" ("dictionary" "argument_list"))
   ("expression" ("augmented_assignment" "lambda" "parenthesized_expression" "delete_statement" "expression_list" "for_in_clause" "print_statement" "exec_statement" "for_statement" "conditional_expression" "list_splat" "while_statement" "typed_default_parameter" "chevron" "interpolation" "decorator" "expression_statement" "await" "default_parameter" "if_statement" "argument_list" "with_item" "return_statement" "type" "tuple" "if_clause" "format_expression" "keyword_argument" "list" "except_clause" "not_operator" "yield" "slice" "generator_expression" "set_comprehension" "subscript" "elif_clause" "named_expression" "set" "dictionary_splat" "boolean_operator" "match_statement" "pair" "assert_statement" "as_pattern" "except_group_clause" "list_comprehension" "raise_statement" "assignment"))
   ("list_splat" ("tuple" "parenthesized_list_splat" "list" "parenthesized_expression" "argument_list" "set"))
   ("as_pattern_target" ("as_pattern"))
   ("pattern_list" ("assignment" "for_statement" "augmented_assignment" "for_in_clause"))
   ("pattern" ("list_pattern" "augmented_assignment" "tuple_pattern" "for_in_clause" "pattern_list" "assignment" "for_statement"))
   ("yield" ("tuple" "format_expression" "interpolation" "list" "expression_statement" "augmented_assignment" "parenthesized_expression" "assignment" "set"))
   ("expression_list" ("format_expression" "interpolation" "augmented_assignment" "delete_statement" "yield" "return_statement" "raise_statement" "assignment" "for_statement"))
   ("assignment" ("assignment" "expression_statement" "augmented_assignment"))
   ("augmented_assignment" ("assignment" "expression_statement" "augmented_assignment"))
   ("type" ("assignment" "function_definition" "typed_default_parameter" "typed_parameter"))
   ("argument_list" ("class_definition" "call"))
   ("block" ("with_statement" "except_clause" "function_definition" "try_statement" "finally_clause" "except_group_clause" "class_definition" "if_statement" "else_clause" "while_statement" "for_statement" "elif_clause" "case_clause"))
   ("if_clause" ("list_comprehension" "dictionary_comprehension" "set_comprehension" "generator_expression" "case_clause"))
   ("case_pattern" ("case_clause"))
   ("decorator" ("decorated_definition"))
   ("pair" ("dictionary_comprehension" "dictionary"))
   ("for_in_clause" ("generator_expression" "dictionary_comprehension" "list_comprehension" "set_comprehension"))
   ("else_clause" ("for_statement" "if_statement" "while_statement" "try_statement"))
   ("format_specifier" ("format_expression" "interpolation"))
   ("type_conversion" ("format_expression" "interpolation"))
   ("format_expression" ("format_specifier"))
   ("parameters" ("function_definition"))
   ("aliased_import" ("import_from_statement" "import_statement" "future_import_statement"))
   ("elif_clause" ("if_statement"))
   ("wildcard_import" ("import_from_statement"))
   ("relative_import" ("import_from_statement"))
   ("lambda_parameters" ("lambda"))
   ("parameter" ("parameters" "lambda_parameters"))
   ("parenthesized_list_splat" ("tuple" "list" "set"))
   ("case_clause" ("match_statement"))
   ("chevron" ("print_statement"))
   ("import_prefix" ("relative_import"))
   ("interpolation" ("string"))
   ("string_content" ("string"))
   ("escape_sequence" ("string_content"))
   ("slice" ("subscript"))
   ("except_clause" ("try_statement"))
   ("except_group_clause" ("try_statement"))
   ("finally_clause" ("try_statement"))
   ("with_item" ("with_clause"))
   ("with_clause" ("with_statement"))
  ) 
)
;; END production rules for python





;; START Auto-generated production rules for `c'
(defconst combobulate-rules-c 
 '(("_abstract_declarator" (:*unnamed* ("abstract_function_declarator" "abstract_parenthesized_declarator" "abstract_array_declarator" "abstract_pointer_declarator"))) 
 ("_declarator" (:*unnamed* ("pointer_declarator" "function_declarator" "array_declarator" "attributed_declarator" "identifier" "parenthesized_declarator"))) 
 ("_expression" (:*unnamed* ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string"))) 
 ("_field_declarator" (:*unnamed* ("pointer_declarator" "function_declarator" "array_declarator" "attributed_declarator" "field_identifier" "parenthesized_declarator"))) 
 ("_statement" (:*unnamed* ("do_statement" "break_statement" "compound_statement" "expression_statement" "case_statement" "continue_statement" "goto_statement" "labeled_statement" "if_statement" "while_statement" "return_statement" "attributed_statement" "for_statement" "switch_statement"))) 
 ("_type_declarator" (:*unnamed* ("pointer_declarator" "function_declarator" "array_declarator" "attributed_declarator" "type_identifier" "parenthesized_declarator"))) 
 ("_type_specifier" (:*unnamed* ("enum_specifier" "union_specifier" "type_identifier" "macro_type_specifier" "primitive_type" "sized_type_specifier" "struct_specifier"))) 
 ("abstract_array_declarator" (:*unnamed* ("type_qualifier") :declarator ("abstract_function_declarator" "abstract_parenthesized_declarator" "abstract_array_declarator" "abstract_pointer_declarator") :size ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string"))) 
 ("abstract_function_declarator" (:declarator ("abstract_function_declarator" "abstract_parenthesized_declarator" "abstract_array_declarator" "abstract_pointer_declarator") :parameters ("parameter_list"))) 
 ("abstract_parenthesized_declarator" (:*unnamed* ("abstract_function_declarator" "abstract_parenthesized_declarator" "abstract_array_declarator" "abstract_pointer_declarator"))) 
 ("abstract_pointer_declarator" (:*unnamed* ("type_qualifier") :declarator ("abstract_function_declarator" "abstract_parenthesized_declarator" "abstract_array_declarator" "abstract_pointer_declarator"))) 
 ("argument_list" (:*unnamed* ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "preproc_defined" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string"))) 
 ("array_declarator" (:*unnamed* ("type_qualifier") :declarator ("field_identifier" "pointer_declarator" "attributed_declarator" "parenthesized_declarator" "function_declarator" "array_declarator" "type_identifier" "identifier") :size ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string"))) 
 ("assignment_expression" (:left ("call_expression" "field_expression" "subscript_expression" "pointer_expression" "identifier" "parenthesized_expression") :operator nil :right ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string"))) 
 ("attribute" (:*unnamed* ("argument_list") :name ("identifier") :prefix ("identifier"))) 
 ("attribute_declaration" (:*unnamed* ("attribute"))) 
 ("attribute_specifier" (:*unnamed* ("argument_list"))) 
 ("attributed_declarator" (:*unnamed* ("field_identifier" "pointer_declarator" "attributed_declarator" "attribute_declaration" "parenthesized_declarator" "function_declarator" "array_declarator" "type_identifier" "identifier"))) 
 ("attributed_statement" (:*unnamed* ("do_statement" "break_statement" "compound_statement" "expression_statement" "case_statement" "continue_statement" "goto_statement" "labeled_statement" "attribute_declaration" "if_statement" "while_statement" "return_statement" "attributed_statement" "for_statement" "switch_statement"))) 
 ("binary_expression" (:left ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "preproc_defined" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string") :operator nil :right ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "preproc_defined" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string"))) 
 ("bitfield_clause" (:*unnamed* ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string"))) 
 ("call_expression" (:arguments ("argument_list") :function ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string"))) 
 ("case_statement" (:*unnamed* ("do_statement" "type_definition" "break_statement" "compound_statement" "declaration" "expression_statement" "goto_statement" "continue_statement" "labeled_statement" "if_statement" "while_statement" "return_statement" "attributed_statement" "for_statement" "switch_statement") :value ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string"))) 
 ("cast_expression" (:type ("type_descriptor") :value ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string"))) 
 ("char_literal" (:*unnamed* ("escape_sequence"))) 
 ("comma_expression" (:left ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string") :right ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string"))) 
 ("compound_literal_expression" (:type ("type_descriptor") :value ("initializer_list"))) 
 ("compound_statement" (:*unnamed* ("type_definition" "break_statement" "enum_specifier" "compound_statement" "continue_statement" "function_definition" "preproc_function_def" "preproc_ifdef" "attributed_statement" "for_statement" "type_identifier" "primitive_type" "preproc_call" "while_statement" "do_statement" "preproc_def" "union_specifier" "declaration" "expression_statement" "case_statement" "goto_statement" "labeled_statement" "macro_type_specifier" "preproc_include" "if_statement" "return_statement" "preproc_if" "switch_statement" "sized_type_specifier" "linkage_specification" "struct_specifier"))) 
 ("concatenated_string" (:*unnamed* ("string_literal"))) 
 ("conditional_expression" (:alternative ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string") :condition ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string") :consequence ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string"))) 
 ("declaration" (:*unnamed* ("type_qualifier" "storage_class_specifier" "attribute_specifier" "attribute_declaration" "ms_declspec_modifier") :declarator ("pointer_declarator" "function_declarator" "array_declarator" "attributed_declarator" "identifier" "init_declarator" "parenthesized_declarator") :type ("enum_specifier" "union_specifier" "type_identifier" "macro_type_specifier" "primitive_type" "sized_type_specifier" "struct_specifier"))) 
 ("declaration_list" (:*unnamed* ("type_definition" "break_statement" "enum_specifier" "compound_statement" "continue_statement" "function_definition" "preproc_function_def" "preproc_ifdef" "attributed_statement" "for_statement" "type_identifier" "primitive_type" "preproc_call" "while_statement" "do_statement" "preproc_def" "union_specifier" "declaration" "expression_statement" "case_statement" "goto_statement" "labeled_statement" "macro_type_specifier" "preproc_include" "if_statement" "return_statement" "preproc_if" "switch_statement" "sized_type_specifier" "linkage_specification" "struct_specifier"))) 
 ("do_statement" (:body ("do_statement" "break_statement" "compound_statement" "expression_statement" "case_statement" "continue_statement" "goto_statement" "labeled_statement" "if_statement" "while_statement" "return_statement" "attributed_statement" "for_statement" "switch_statement") :condition ("parenthesized_expression"))) 
 ("enum_specifier" (:body ("enumerator_list") :name ("type_identifier"))) 
 ("enumerator" (:name ("identifier") :value ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string"))) 
 ("enumerator_list" (:*unnamed* ("enumerator"))) 
 ("expression_statement" (:*unnamed* ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string"))) 
 ("field_declaration" (:*unnamed* ("type_qualifier" "storage_class_specifier" "attribute_specifier" "attribute_declaration" "ms_declspec_modifier" "bitfield_clause") :declarator ("pointer_declarator" "function_declarator" "array_declarator" "attributed_declarator" "field_identifier" "parenthesized_declarator") :type ("enum_specifier" "union_specifier" "type_identifier" "macro_type_specifier" "primitive_type" "sized_type_specifier" "struct_specifier"))) 
 ("field_declaration_list" (:*unnamed* ("preproc_def" "preproc_function_def" "preproc_ifdef" "field_declaration" "preproc_if" "preproc_call"))) 
 ("field_designator" (:*unnamed* ("field_identifier"))) 
 ("field_expression" (:argument ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string") :field ("field_identifier") :operator nil)) 
 ("for_statement" (:body ("do_statement" "break_statement" "compound_statement" "expression_statement" "case_statement" "continue_statement" "goto_statement" "labeled_statement" "if_statement" "while_statement" "return_statement" "attributed_statement" "for_statement" "switch_statement") :condition ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string") :initializer ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "declaration" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string") :update ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string"))) 
 ("function_declarator" (:*unnamed* ("attribute_specifier") :declarator ("field_identifier" "pointer_declarator" "attributed_declarator" "parenthesized_declarator" "function_declarator" "array_declarator" "type_identifier" "identifier") :parameters ("parameter_list"))) 
 ("function_definition" (:*unnamed* ("type_qualifier" "ms_call_modifier" "storage_class_specifier" "attribute_specifier" "attribute_declaration" "ms_declspec_modifier") :body ("compound_statement") :declarator ("pointer_declarator" "function_declarator" "array_declarator" "attributed_declarator" "identifier" "parenthesized_declarator") :type ("enum_specifier" "union_specifier" "type_identifier" "macro_type_specifier" "primitive_type" "sized_type_specifier" "struct_specifier"))) 
 ("goto_statement" (:label ("statement_identifier"))) 
 ("if_statement" (:alternative ("do_statement" "break_statement" "compound_statement" "expression_statement" "case_statement" "continue_statement" "goto_statement" "labeled_statement" "if_statement" "while_statement" "return_statement" "attributed_statement" "for_statement" "switch_statement") :condition ("parenthesized_expression") :consequence ("do_statement" "break_statement" "compound_statement" "expression_statement" "case_statement" "continue_statement" "goto_statement" "labeled_statement" "if_statement" "while_statement" "return_statement" "attributed_statement" "for_statement" "switch_statement"))) 
 ("init_declarator" (:declarator ("pointer_declarator" "function_declarator" "array_declarator" "attributed_declarator" "identifier" "parenthesized_declarator") :value ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "initializer_list" "update_expression" "concatenated_string"))) 
 ("initializer_list" (:*unnamed* ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "initializer_pair" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "initializer_list" "update_expression" "concatenated_string"))) 
 ("initializer_pair" (:designator ("field_designator" "subscript_designator") :value ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "initializer_list" "update_expression" "concatenated_string"))) 
 ("labeled_statement" (:*unnamed* ("do_statement" "break_statement" "compound_statement" "expression_statement" "case_statement" "continue_statement" "goto_statement" "labeled_statement" "if_statement" "while_statement" "return_statement" "attributed_statement" "for_statement" "switch_statement") :label ("statement_identifier"))) 
 ("linkage_specification" (:body ("declaration_list" "function_definition" "declaration") :value ("string_literal"))) 
 ("macro_type_specifier" (:name ("identifier") :type ("type_descriptor"))) 
 ("ms_based_modifier" (:*unnamed* ("argument_list"))) 
 ("ms_declspec_modifier" (:*unnamed* ("identifier"))) 
 ("ms_pointer_modifier" (:*unnamed* ("ms_unsigned_ptr_modifier" "ms_restrict_modifier" "ms_unaligned_ptr_modifier" "ms_signed_ptr_modifier"))) 
 ("parameter_declaration" (:*unnamed* ("type_qualifier" "storage_class_specifier" "attribute_specifier" "attribute_declaration" "ms_declspec_modifier") :declarator ("pointer_declarator" "attributed_declarator" "abstract_parenthesized_declarator" "abstract_array_declarator" "parenthesized_declarator" "abstract_function_declarator" "function_declarator" "array_declarator" "abstract_pointer_declarator" "identifier") :type ("enum_specifier" "union_specifier" "type_identifier" "macro_type_specifier" "primitive_type" "sized_type_specifier" "struct_specifier"))) 
 ("parameter_list" (:*unnamed* ("variadic_parameter" "parameter_declaration"))) 
 ("parenthesized_declarator" (:*unnamed* ("field_identifier" "pointer_declarator" "attributed_declarator" "parenthesized_declarator" "function_declarator" "array_declarator" "type_identifier" "identifier"))) 
 ("parenthesized_expression" (:*unnamed* ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "preproc_defined" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string"))) 
 ("pointer_declarator" (:*unnamed* ("ms_based_modifier" "ms_pointer_modifier" "type_qualifier") :declarator ("field_identifier" "pointer_declarator" "attributed_declarator" "parenthesized_declarator" "function_declarator" "array_declarator" "type_identifier" "identifier"))) 
 ("pointer_expression" (:argument ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string") :operator nil)) 
 ("preproc_call" (:argument ("preproc_arg") :directive ("preproc_directive"))) 
 ("preproc_def" (:name ("identifier") :value ("preproc_arg"))) 
 ("preproc_defined" (:*unnamed* ("identifier"))) 
 ("preproc_elif" (:*unnamed* ("type_definition" "continue_statement" "function_definition" "field_declaration" "attributed_statement" "for_statement" "type_identifier" "primitive_type" "preproc_call" "while_statement" "preproc_def" "union_specifier" "declaration" "expression_statement" "goto_statement" "if_statement" "return_statement" "preproc_if" "switch_statement" "linkage_specification" "break_statement" "enum_specifier" "compound_statement" "preproc_function_def" "preproc_ifdef" "do_statement" "case_statement" "labeled_statement" "macro_type_specifier" "preproc_include" "sized_type_specifier" "struct_specifier") :alternative ("preproc_else" "preproc_elif") :condition ("binary_expression" "call_expression" "parenthesized_expression" "preproc_defined" "unary_expression" "number_literal" "char_literal" "identifier"))) 
 ("preproc_else" (:*unnamed* ("type_definition" "continue_statement" "function_definition" "field_declaration" "attributed_statement" "for_statement" "type_identifier" "primitive_type" "preproc_call" "while_statement" "preproc_def" "union_specifier" "declaration" "expression_statement" "goto_statement" "if_statement" "return_statement" "preproc_if" "switch_statement" "linkage_specification" "break_statement" "enum_specifier" "compound_statement" "preproc_function_def" "preproc_ifdef" "do_statement" "case_statement" "labeled_statement" "macro_type_specifier" "preproc_include" "sized_type_specifier" "struct_specifier"))) 
 ("preproc_function_def" (:name ("identifier") :parameters ("preproc_params") :value ("preproc_arg"))) 
 ("preproc_if" (:*unnamed* ("type_definition" "continue_statement" "function_definition" "field_declaration" "attributed_statement" "for_statement" "type_identifier" "primitive_type" "preproc_call" "while_statement" "preproc_def" "union_specifier" "declaration" "expression_statement" "goto_statement" "if_statement" "return_statement" "preproc_if" "switch_statement" "linkage_specification" "break_statement" "enum_specifier" "compound_statement" "preproc_function_def" "preproc_ifdef" "do_statement" "case_statement" "labeled_statement" "macro_type_specifier" "preproc_include" "sized_type_specifier" "struct_specifier") :alternative ("preproc_else" "preproc_elif") :condition ("binary_expression" "call_expression" "parenthesized_expression" "preproc_defined" "unary_expression" "number_literal" "char_literal" "identifier"))) 
 ("preproc_ifdef" (:*unnamed* ("type_definition" "continue_statement" "function_definition" "field_declaration" "attributed_statement" "for_statement" "type_identifier" "primitive_type" "preproc_call" "while_statement" "preproc_def" "union_specifier" "declaration" "expression_statement" "goto_statement" "if_statement" "return_statement" "preproc_if" "switch_statement" "linkage_specification" "break_statement" "enum_specifier" "compound_statement" "preproc_function_def" "preproc_ifdef" "do_statement" "case_statement" "labeled_statement" "macro_type_specifier" "preproc_include" "sized_type_specifier" "struct_specifier") :alternative ("preproc_else" "preproc_elif") :name ("identifier"))) 
 ("preproc_include" (:path ("string_literal" "system_lib_string" "identifier" "call_expression"))) 
 ("preproc_params" (:*unnamed* ("identifier"))) 
 ("return_statement" (:*unnamed* ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string"))) 
 ("sized_type_specifier" (:type ("type_identifier" "primitive_type"))) 
 ("sizeof_expression" (:type ("type_descriptor") :value ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string"))) 
 ("string_literal" (:*unnamed* ("escape_sequence"))) 
 ("struct_specifier" (:*unnamed* ("ms_declspec_modifier") :body ("field_declaration_list") :name ("type_identifier"))) 
 ("subscript_designator" (:*unnamed* ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string"))) 
 ("subscript_expression" (:argument ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string") :index ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string"))) 
 ("switch_statement" (:body ("compound_statement") :condition ("parenthesized_expression"))) 
 ("translation_unit" (:*unnamed* ("type_definition" "break_statement" "enum_specifier" "compound_statement" "continue_statement" "function_definition" "preproc_function_def" "preproc_ifdef" "attributed_statement" "for_statement" "type_identifier" "primitive_type" "preproc_call" "while_statement" "do_statement" "preproc_def" "union_specifier" "declaration" "expression_statement" "case_statement" "goto_statement" "labeled_statement" "macro_type_specifier" "preproc_include" "if_statement" "return_statement" "preproc_if" "switch_statement" "sized_type_specifier" "linkage_specification" "struct_specifier"))) 
 ("type_definition" (:*unnamed* ("type_qualifier") :declarator ("pointer_declarator" "function_declarator" "array_declarator" "attributed_declarator" "type_identifier" "parenthesized_declarator") :type ("enum_specifier" "union_specifier" "type_identifier" "macro_type_specifier" "primitive_type" "sized_type_specifier" "struct_specifier"))) 
 ("type_descriptor" (:*unnamed* ("type_qualifier") :declarator ("abstract_function_declarator" "abstract_parenthesized_declarator" "abstract_array_declarator" "abstract_pointer_declarator") :type ("enum_specifier" "union_specifier" "type_identifier" "macro_type_specifier" "primitive_type" "sized_type_specifier" "struct_specifier"))) 
 ("unary_expression" (:argument ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "preproc_defined" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string") :operator nil)) 
 ("union_specifier" (:*unnamed* ("ms_declspec_modifier") :body ("field_declaration_list") :name ("type_identifier"))) 
 ("update_expression" (:argument ("cast_expression" "binary_expression" "assignment_expression" "call_expression" "sizeof_expression" "parenthesized_expression" "compound_literal_expression" "false" "identifier" "pointer_expression" "conditional_expression" "subscript_expression" "true" "string_literal" "field_expression" "null" "unary_expression" "char_literal" "number_literal" "update_expression" "concatenated_string") :operator nil)) 
 ("while_statement" (:body ("do_statement" "break_statement" "compound_statement" "expression_statement" "case_statement" "continue_statement" "goto_statement" "labeled_statement" "if_statement" "while_statement" "return_statement" "attributed_statement" "for_statement" "switch_statement") :condition ("parenthesized_expression"))) 
))

(defconst combobulate-rules-c-inverted 
 '(("abstract_function_declarator" ("type_descriptor" "parameter_declaration" "abstract_parenthesized_declarator" "abstract_array_declarator" "abstract_function_declarator" "abstract_pointer_declarator" "_abstract_declarator"))
   ("abstract_parenthesized_declarator" ("type_descriptor" "parameter_declaration" "abstract_parenthesized_declarator" "abstract_array_declarator" "abstract_function_declarator" "abstract_pointer_declarator" "_abstract_declarator"))
   ("abstract_array_declarator" ("type_descriptor" "parameter_declaration" "abstract_parenthesized_declarator" "abstract_array_declarator" "abstract_function_declarator" "abstract_pointer_declarator" "_abstract_declarator"))
   ("abstract_pointer_declarator" ("type_descriptor" "parameter_declaration" "abstract_parenthesized_declarator" "abstract_array_declarator" "abstract_function_declarator" "abstract_pointer_declarator" "_abstract_declarator"))
   ("pointer_declarator" ("type_definition" "_declarator" "pointer_declarator" "_type_declarator" "declaration" "attributed_declarator" "parameter_declaration" "function_definition" "init_declarator" "_field_declarator" "parenthesized_declarator" "function_declarator" "array_declarator" "field_declaration"))
   ("function_declarator" ("type_definition" "_declarator" "pointer_declarator" "_type_declarator" "declaration" "attributed_declarator" "parameter_declaration" "function_definition" "init_declarator" "_field_declarator" "parenthesized_declarator" "function_declarator" "array_declarator" "field_declaration"))
   ("array_declarator" ("type_definition" "_declarator" "pointer_declarator" "_type_declarator" "declaration" "attributed_declarator" "parameter_declaration" "function_definition" "init_declarator" "_field_declarator" "parenthesized_declarator" "function_declarator" "array_declarator" "field_declaration"))
   ("attributed_declarator" ("type_definition" "_declarator" "pointer_declarator" "_type_declarator" "declaration" "attributed_declarator" "parameter_declaration" "function_definition" "init_declarator" "_field_declarator" "parenthesized_declarator" "function_declarator" "array_declarator" "field_declaration"))
   ("identifier" ("binary_expression" "assignment_expression" "attribute" "attributed_declarator" "comma_expression" "parameter_declaration" "function_definition" "sizeof_expression" "parenthesized_expression" "preproc_defined" "array_declarator" "for_statement" "pointer_expression" "conditional_expression" "ms_declspec_modifier" "preproc_def" "declaration" "expression_statement" "parenthesized_declarator" "argument_list" "return_statement" "preproc_if" "initializer_list" "update_expression" "cast_expression" "_declarator" "pointer_declarator" "call_expression" "enumerator" "subscript_designator" "preproc_function_def" "preproc_ifdef" "subscript_expression" "initializer_pair" "field_expression" "case_statement" "macro_type_specifier" "init_declarator" "abstract_array_declarator" "preproc_elif" "bitfield_clause" "preproc_include" "function_declarator" "unary_expression" "preproc_params" "_expression"))
   ("parenthesized_declarator" ("type_definition" "_declarator" "pointer_declarator" "_type_declarator" "declaration" "attributed_declarator" "parameter_declaration" "function_definition" "init_declarator" "_field_declarator" "parenthesized_declarator" "function_declarator" "array_declarator" "field_declaration"))
   ("cast_expression" ("binary_expression" "assignment_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "array_declarator" "for_statement" "pointer_expression" "conditional_expression" "expression_statement" "argument_list" "return_statement" "initializer_list" "update_expression" "cast_expression" "call_expression" "enumerator" "subscript_designator" "subscript_expression" "initializer_pair" "field_expression" "case_statement" "init_declarator" "abstract_array_declarator" "bitfield_clause" "unary_expression" "_expression"))
   ("binary_expression" ("binary_expression" "assignment_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "array_declarator" "for_statement" "pointer_expression" "conditional_expression" "expression_statement" "argument_list" "return_statement" "preproc_if" "initializer_list" "update_expression" "cast_expression" "call_expression" "enumerator" "subscript_designator" "subscript_expression" "initializer_pair" "field_expression" "case_statement" "init_declarator" "abstract_array_declarator" "preproc_elif" "bitfield_clause" "unary_expression" "_expression"))
   ("assignment_expression" ("binary_expression" "assignment_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "array_declarator" "for_statement" "pointer_expression" "conditional_expression" "expression_statement" "argument_list" "return_statement" "initializer_list" "update_expression" "cast_expression" "call_expression" "enumerator" "subscript_designator" "subscript_expression" "initializer_pair" "field_expression" "case_statement" "init_declarator" "abstract_array_declarator" "bitfield_clause" "unary_expression" "_expression"))
   ("call_expression" ("binary_expression" "assignment_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "array_declarator" "for_statement" "pointer_expression" "conditional_expression" "expression_statement" "argument_list" "return_statement" "preproc_if" "initializer_list" "update_expression" "cast_expression" "call_expression" "enumerator" "subscript_designator" "subscript_expression" "initializer_pair" "field_expression" "case_statement" "init_declarator" "abstract_array_declarator" "preproc_elif" "bitfield_clause" "preproc_include" "unary_expression" "_expression"))
   ("sizeof_expression" ("binary_expression" "assignment_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "array_declarator" "for_statement" "pointer_expression" "conditional_expression" "expression_statement" "argument_list" "return_statement" "initializer_list" "update_expression" "cast_expression" "call_expression" "enumerator" "subscript_designator" "subscript_expression" "initializer_pair" "field_expression" "case_statement" "init_declarator" "abstract_array_declarator" "bitfield_clause" "unary_expression" "_expression"))
   ("parenthesized_expression" ("binary_expression" "assignment_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "array_declarator" "for_statement" "pointer_expression" "conditional_expression" "while_statement" "expression_statement" "if_statement" "argument_list" "return_statement" "preproc_if" "switch_statement" "initializer_list" "update_expression" "cast_expression" "call_expression" "enumerator" "subscript_designator" "subscript_expression" "do_statement" "initializer_pair" "field_expression" "case_statement" "init_declarator" "abstract_array_declarator" "preproc_elif" "bitfield_clause" "unary_expression" "_expression"))
   ("compound_literal_expression" ("binary_expression" "assignment_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "array_declarator" "for_statement" "pointer_expression" "conditional_expression" "expression_statement" "argument_list" "return_statement" "initializer_list" "update_expression" "cast_expression" "call_expression" "enumerator" "subscript_designator" "subscript_expression" "initializer_pair" "field_expression" "case_statement" "init_declarator" "abstract_array_declarator" "bitfield_clause" "unary_expression" "_expression"))
   ("false" ("binary_expression" "assignment_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "array_declarator" "for_statement" "pointer_expression" "conditional_expression" "expression_statement" "argument_list" "return_statement" "initializer_list" "update_expression" "cast_expression" "call_expression" "enumerator" "subscript_designator" "subscript_expression" "initializer_pair" "field_expression" "case_statement" "init_declarator" "abstract_array_declarator" "bitfield_clause" "unary_expression" "_expression"))
   ("pointer_expression" ("binary_expression" "assignment_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "array_declarator" "for_statement" "pointer_expression" "conditional_expression" "expression_statement" "argument_list" "return_statement" "initializer_list" "update_expression" "cast_expression" "call_expression" "enumerator" "subscript_designator" "subscript_expression" "initializer_pair" "field_expression" "case_statement" "init_declarator" "abstract_array_declarator" "bitfield_clause" "unary_expression" "_expression"))
   ("conditional_expression" ("binary_expression" "assignment_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "array_declarator" "for_statement" "pointer_expression" "conditional_expression" "expression_statement" "argument_list" "return_statement" "initializer_list" "update_expression" "cast_expression" "call_expression" "enumerator" "subscript_designator" "subscript_expression" "initializer_pair" "field_expression" "case_statement" "init_declarator" "abstract_array_declarator" "bitfield_clause" "unary_expression" "_expression"))
   ("subscript_expression" ("binary_expression" "assignment_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "array_declarator" "for_statement" "pointer_expression" "conditional_expression" "expression_statement" "argument_list" "return_statement" "initializer_list" "update_expression" "cast_expression" "call_expression" "enumerator" "subscript_designator" "subscript_expression" "initializer_pair" "field_expression" "case_statement" "init_declarator" "abstract_array_declarator" "bitfield_clause" "unary_expression" "_expression"))
   ("true" ("binary_expression" "assignment_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "array_declarator" "for_statement" "pointer_expression" "conditional_expression" "expression_statement" "argument_list" "return_statement" "initializer_list" "update_expression" "cast_expression" "call_expression" "enumerator" "subscript_designator" "subscript_expression" "initializer_pair" "field_expression" "case_statement" "init_declarator" "abstract_array_declarator" "bitfield_clause" "unary_expression" "_expression"))
   ("string_literal" ("binary_expression" "assignment_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "array_declarator" "for_statement" "pointer_expression" "conditional_expression" "expression_statement" "argument_list" "return_statement" "initializer_list" "linkage_specification" "concatenated_string" "cast_expression" "update_expression" "call_expression" "enumerator" "subscript_designator" "subscript_expression" "initializer_pair" "field_expression" "case_statement" "init_declarator" "abstract_array_declarator" "bitfield_clause" "preproc_include" "unary_expression" "_expression"))
   ("field_expression" ("binary_expression" "assignment_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "array_declarator" "for_statement" "pointer_expression" "conditional_expression" "expression_statement" "argument_list" "return_statement" "initializer_list" "update_expression" "cast_expression" "call_expression" "enumerator" "subscript_designator" "subscript_expression" "initializer_pair" "field_expression" "case_statement" "init_declarator" "abstract_array_declarator" "bitfield_clause" "unary_expression" "_expression"))
   ("null" ("binary_expression" "assignment_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "array_declarator" "for_statement" "pointer_expression" "conditional_expression" "expression_statement" "argument_list" "return_statement" "initializer_list" "update_expression" "cast_expression" "call_expression" "enumerator" "subscript_designator" "subscript_expression" "initializer_pair" "field_expression" "case_statement" "init_declarator" "abstract_array_declarator" "bitfield_clause" "unary_expression" "_expression"))
   ("unary_expression" ("binary_expression" "assignment_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "array_declarator" "for_statement" "pointer_expression" "conditional_expression" "expression_statement" "argument_list" "return_statement" "preproc_if" "initializer_list" "update_expression" "cast_expression" "call_expression" "enumerator" "subscript_designator" "subscript_expression" "initializer_pair" "field_expression" "case_statement" "init_declarator" "abstract_array_declarator" "preproc_elif" "bitfield_clause" "unary_expression" "_expression"))
   ("char_literal" ("binary_expression" "assignment_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "array_declarator" "for_statement" "pointer_expression" "conditional_expression" "expression_statement" "argument_list" "return_statement" "preproc_if" "initializer_list" "update_expression" "cast_expression" "call_expression" "enumerator" "subscript_designator" "subscript_expression" "initializer_pair" "field_expression" "case_statement" "init_declarator" "abstract_array_declarator" "preproc_elif" "bitfield_clause" "unary_expression" "_expression"))
   ("number_literal" ("binary_expression" "assignment_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "array_declarator" "for_statement" "pointer_expression" "conditional_expression" "expression_statement" "argument_list" "return_statement" "preproc_if" "initializer_list" "update_expression" "cast_expression" "call_expression" "enumerator" "subscript_designator" "subscript_expression" "initializer_pair" "field_expression" "case_statement" "init_declarator" "abstract_array_declarator" "preproc_elif" "bitfield_clause" "unary_expression" "_expression"))
   ("update_expression" ("binary_expression" "assignment_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "array_declarator" "for_statement" "pointer_expression" "conditional_expression" "expression_statement" "argument_list" "return_statement" "initializer_list" "update_expression" "cast_expression" "call_expression" "enumerator" "subscript_designator" "subscript_expression" "initializer_pair" "field_expression" "case_statement" "init_declarator" "abstract_array_declarator" "bitfield_clause" "unary_expression" "_expression"))
   ("concatenated_string" ("binary_expression" "assignment_expression" "comma_expression" "sizeof_expression" "parenthesized_expression" "array_declarator" "for_statement" "pointer_expression" "conditional_expression" "expression_statement" "argument_list" "return_statement" "initializer_list" "update_expression" "cast_expression" "call_expression" "enumerator" "subscript_designator" "subscript_expression" "initializer_pair" "field_expression" "case_statement" "init_declarator" "abstract_array_declarator" "bitfield_clause" "unary_expression" "_expression"))
   ("field_identifier" ("pointer_declarator" "attributed_declarator" "field_expression" "_field_declarator" "parenthesized_declarator" "field_designator" "function_declarator" "array_declarator" "field_declaration"))
   ("do_statement" ("do_statement" "preproc_else" "compound_statement" "case_statement" "_statement" "labeled_statement" "preproc_elif" "declaration_list" "if_statement" "preproc_ifdef" "preproc_if" "attributed_statement" "for_statement" "translation_unit" "while_statement"))
   ("break_statement" ("do_statement" "preproc_else" "compound_statement" "case_statement" "_statement" "labeled_statement" "preproc_elif" "declaration_list" "if_statement" "preproc_ifdef" "preproc_if" "attributed_statement" "for_statement" "translation_unit" "while_statement"))
   ("compound_statement" ("do_statement" "preproc_else" "compound_statement" "case_statement" "_statement" "function_definition" "labeled_statement" "preproc_elif" "declaration_list" "if_statement" "while_statement" "preproc_ifdef" "preproc_if" "attributed_statement" "for_statement" "translation_unit" "switch_statement"))
   ("expression_statement" ("do_statement" "preproc_else" "compound_statement" "case_statement" "_statement" "labeled_statement" "preproc_elif" "declaration_list" "if_statement" "preproc_ifdef" "preproc_if" "attributed_statement" "for_statement" "translation_unit" "while_statement"))
   ("case_statement" ("do_statement" "preproc_else" "compound_statement" "labeled_statement" "_statement" "preproc_elif" "declaration_list" "if_statement" "preproc_ifdef" "preproc_if" "attributed_statement" "for_statement" "translation_unit" "while_statement"))
   ("continue_statement" ("do_statement" "preproc_else" "compound_statement" "case_statement" "_statement" "labeled_statement" "preproc_elif" "declaration_list" "if_statement" "preproc_ifdef" "preproc_if" "attributed_statement" "for_statement" "translation_unit" "while_statement"))
   ("goto_statement" ("do_statement" "preproc_else" "compound_statement" "case_statement" "_statement" "labeled_statement" "preproc_elif" "declaration_list" "if_statement" "preproc_ifdef" "preproc_if" "attributed_statement" "for_statement" "translation_unit" "while_statement"))
   ("labeled_statement" ("do_statement" "preproc_else" "compound_statement" "case_statement" "_statement" "labeled_statement" "preproc_elif" "declaration_list" "if_statement" "preproc_ifdef" "preproc_if" "attributed_statement" "for_statement" "translation_unit" "while_statement"))
   ("if_statement" ("do_statement" "preproc_else" "compound_statement" "case_statement" "_statement" "labeled_statement" "preproc_elif" "declaration_list" "if_statement" "preproc_ifdef" "preproc_if" "attributed_statement" "for_statement" "translation_unit" "while_statement"))
   ("while_statement" ("do_statement" "preproc_else" "compound_statement" "case_statement" "_statement" "labeled_statement" "preproc_elif" "declaration_list" "if_statement" "preproc_ifdef" "preproc_if" "attributed_statement" "for_statement" "translation_unit" "while_statement"))
   ("return_statement" ("do_statement" "preproc_else" "compound_statement" "case_statement" "_statement" "labeled_statement" "preproc_elif" "declaration_list" "if_statement" "preproc_ifdef" "preproc_if" "attributed_statement" "for_statement" "translation_unit" "while_statement"))
   ("attributed_statement" ("do_statement" "preproc_else" "compound_statement" "case_statement" "_statement" "labeled_statement" "preproc_elif" "declaration_list" "if_statement" "preproc_ifdef" "preproc_if" "attributed_statement" "for_statement" "translation_unit" "while_statement"))
   ("for_statement" ("do_statement" "preproc_else" "compound_statement" "case_statement" "_statement" "labeled_statement" "preproc_elif" "declaration_list" "if_statement" "preproc_ifdef" "preproc_if" "attributed_statement" "for_statement" "translation_unit" "while_statement"))
   ("switch_statement" ("do_statement" "preproc_else" "compound_statement" "case_statement" "_statement" "labeled_statement" "preproc_elif" "declaration_list" "if_statement" "preproc_ifdef" "preproc_if" "attributed_statement" "for_statement" "translation_unit" "while_statement"))
   ("type_identifier" ("type_definition" "preproc_else" "parameter_declaration" "attributed_declarator" "function_definition" "array_declarator" "field_declaration" "union_specifier" "type_descriptor" "declaration" "parenthesized_declarator" "preproc_if" "_type_specifier" "pointer_declarator" "enum_specifier" "compound_statement" "preproc_ifdef" "_type_declarator" "preproc_elif" "declaration_list" "function_declarator" "sized_type_specifier" "translation_unit" "struct_specifier"))
   ("enum_specifier" ("type_definition" "preproc_else" "compound_statement" "type_descriptor" "declaration" "parameter_declaration" "function_definition" "preproc_elif" "declaration_list" "preproc_ifdef" "field_declaration" "preproc_if" "_type_specifier" "translation_unit"))
   ("union_specifier" ("type_definition" "preproc_else" "compound_statement" "type_descriptor" "declaration" "parameter_declaration" "function_definition" "preproc_elif" "declaration_list" "preproc_ifdef" "field_declaration" "preproc_if" "_type_specifier" "translation_unit"))
   ("macro_type_specifier" ("type_definition" "preproc_else" "compound_statement" "type_descriptor" "declaration" "parameter_declaration" "function_definition" "preproc_elif" "declaration_list" "preproc_ifdef" "field_declaration" "preproc_if" "_type_specifier" "translation_unit"))
   ("primitive_type" ("type_definition" "preproc_else" "compound_statement" "type_descriptor" "declaration" "parameter_declaration" "function_definition" "preproc_elif" "declaration_list" "preproc_ifdef" "field_declaration" "preproc_if" "_type_specifier" "sized_type_specifier" "translation_unit"))
   ("sized_type_specifier" ("type_definition" "preproc_else" "compound_statement" "type_descriptor" "declaration" "parameter_declaration" "function_definition" "preproc_elif" "declaration_list" "preproc_ifdef" "field_declaration" "preproc_if" "_type_specifier" "translation_unit"))
   ("struct_specifier" ("type_definition" "preproc_else" "compound_statement" "type_descriptor" "declaration" "parameter_declaration" "function_definition" "preproc_elif" "declaration_list" "preproc_ifdef" "field_declaration" "preproc_if" "_type_specifier" "translation_unit"))
   ("type_qualifier" ("type_definition" "pointer_declarator" "type_descriptor" "declaration" "parameter_declaration" "function_definition" "abstract_array_declarator" "array_declarator" "field_declaration" "abstract_pointer_declarator"))
   ("parameter_list" ("abstract_function_declarator" "function_declarator"))
   ("preproc_defined" ("binary_expression" "preproc_elif" "parenthesized_expression" "argument_list" "unary_expression" "preproc_if"))
   ("argument_list" ("ms_based_modifier" "attribute_specifier" "call_expression" "attribute"))
   ("attribute" ("attribute_declaration"))
   ("attribute_declaration" ("declaration" "attributed_declarator" "parameter_declaration" "function_definition" "field_declaration" "attributed_statement"))
   ("type_definition" ("preproc_else" "compound_statement" "case_statement" "preproc_elif" "declaration_list" "preproc_ifdef" "preproc_if" "translation_unit"))
   ("declaration" ("preproc_else" "compound_statement" "case_statement" "preproc_elif" "declaration_list" "preproc_ifdef" "preproc_if" "for_statement" "translation_unit" "linkage_specification"))
   ("type_descriptor" ("cast_expression" "compound_literal_expression" "macro_type_specifier" "sizeof_expression"))
   ("escape_sequence" ("string_literal" "char_literal"))
   ("comma_expression" ("comma_expression" "expression_statement" "parenthesized_expression" "return_statement" "for_statement"))
   ("initializer_list" ("compound_literal_expression" "initializer_pair" "init_declarator" "initializer_list"))
   ("function_definition" ("preproc_else" "compound_statement" "preproc_elif" "declaration_list" "preproc_ifdef" "preproc_if" "translation_unit" "linkage_specification"))
   ("preproc_function_def" ("field_declaration_list" "preproc_else" "compound_statement" "preproc_elif" "declaration_list" "preproc_ifdef" "preproc_if" "translation_unit"))
   ("preproc_ifdef" ("field_declaration_list" "preproc_else" "compound_statement" "preproc_elif" "declaration_list" "preproc_ifdef" "preproc_if" "translation_unit"))
   ("preproc_call" ("field_declaration_list" "preproc_else" "compound_statement" "preproc_elif" "declaration_list" "preproc_ifdef" "preproc_if" "translation_unit"))
   ("preproc_def" ("field_declaration_list" "preproc_else" "compound_statement" "preproc_elif" "declaration_list" "preproc_ifdef" "preproc_if" "translation_unit"))
   ("preproc_include" ("preproc_else" "compound_statement" "preproc_elif" "declaration_list" "preproc_ifdef" "preproc_if" "translation_unit"))
   ("preproc_if" ("field_declaration_list" "preproc_else" "compound_statement" "preproc_elif" "declaration_list" "preproc_ifdef" "preproc_if" "translation_unit"))
   ("linkage_specification" ("preproc_else" "compound_statement" "preproc_elif" "declaration_list" "preproc_ifdef" "preproc_if" "translation_unit"))
   ("storage_class_specifier" ("parameter_declaration" "function_definition" "field_declaration" "declaration"))
   ("attribute_specifier" ("parameter_declaration" "declaration" "function_definition" "function_declarator" "field_declaration"))
   ("ms_declspec_modifier" ("union_specifier" "parameter_declaration" "declaration" "function_definition" "field_declaration" "struct_specifier"))
   ("init_declarator" ("declaration"))
   ("enumerator_list" ("enum_specifier"))
   ("enumerator" ("enumerator_list"))
   ("bitfield_clause" ("field_declaration"))
   ("field_declaration" ("field_declaration_list" "preproc_else" "preproc_elif" "preproc_ifdef" "preproc_if"))
   ("ms_call_modifier" ("function_definition"))
   ("statement_identifier" ("goto_statement" "labeled_statement"))
   ("initializer_pair" ("initializer_list"))
   ("field_designator" ("initializer_pair"))
   ("subscript_designator" ("initializer_pair"))
   ("declaration_list" ("linkage_specification"))
   ("ms_unsigned_ptr_modifier" ("ms_pointer_modifier"))
   ("ms_restrict_modifier" ("ms_pointer_modifier"))
   ("ms_unaligned_ptr_modifier" ("ms_pointer_modifier"))
   ("ms_signed_ptr_modifier" ("ms_pointer_modifier"))
   ("variadic_parameter" ("parameter_list"))
   ("parameter_declaration" ("parameter_list"))
   ("ms_based_modifier" ("pointer_declarator"))
   ("ms_pointer_modifier" ("pointer_declarator"))
   ("preproc_arg" ("preproc_def" "preproc_function_def" "preproc_call"))
   ("preproc_directive" ("preproc_call"))
   ("preproc_else" ("preproc_ifdef" "preproc_elif" "preproc_if"))
   ("preproc_elif" ("preproc_ifdef" "preproc_elif" "preproc_if"))
   ("preproc_params" ("preproc_function_def"))
   ("system_lib_string" ("preproc_include"))
   ("field_declaration_list" ("union_specifier" "struct_specifier"))
  ) 
)
;; END production rules for c





;; START Auto-generated production rules for `html'
(defconst combobulate-rules-html 
 '(("attribute" (:*unnamed* ("attribute_name" "attribute_value" "quoted_attribute_value"))) 
 ("element" (:*unnamed* ("element" "script_element" "self_closing_tag" "style_element" "doctype" "end_tag" "erroneous_end_tag" "text" "start_tag"))) 
 ("end_tag" (:*unnamed* ("tag_name"))) 
 ("erroneous_end_tag" (:*unnamed* ("erroneous_end_tag_name"))) 
 ("fragment" (:*unnamed* ("erroneous_end_tag" "element" "script_element" "text" "style_element" "doctype"))) 
 ("quoted_attribute_value" (:*unnamed* ("attribute_value"))) 
 ("script_element" (:*unnamed* ("end_tag" "start_tag" "raw_text"))) 
 ("self_closing_tag" (:*unnamed* ("tag_name" "attribute"))) 
 ("start_tag" (:*unnamed* ("tag_name" "attribute"))) 
 ("style_element" (:*unnamed* ("end_tag" "start_tag" "raw_text"))) 
))

(defconst combobulate-rules-html-inverted 
 '(("attribute_name" ("attribute"))
   ("attribute_value" ("quoted_attribute_value" "attribute"))
   ("quoted_attribute_value" ("attribute"))
   ("element" ("element" "fragment"))
   ("script_element" ("element" "fragment"))
   ("self_closing_tag" ("element"))
   ("style_element" ("element" "fragment"))
   ("doctype" ("element" "fragment"))
   ("end_tag" ("element" "script_element" "style_element"))
   ("erroneous_end_tag" ("element" "fragment"))
   ("text" ("element" "fragment"))
   ("start_tag" ("element" "script_element" "style_element"))
   ("tag_name" ("end_tag" "self_closing_tag" "start_tag"))
   ("erroneous_end_tag_name" ("erroneous_end_tag"))
   ("raw_text" ("script_element" "style_element"))
   ("attribute" ("self_closing_tag" "start_tag"))
  ) 
)
;; END production rules for html





;; START Auto-generated production rules for `toml'
(defconst combobulate-rules-toml 
 '(("array" (:*unnamed* ("boolean" "inline_table" "array" "integer" "local_date" "local_date_time" "local_time" "float" "offset_date_time" "string"))) 
 ("document" (:*unnamed* ("table" "pair" "table_array_element"))) 
 ("dotted_key" (:*unnamed* ("bare_key" "quoted_key" "dotted_key"))) 
 ("inline_table" (:*unnamed* ("pair"))) 
 ("pair" (:*unnamed* ("boolean" "inline_table" "array" "integer" "local_date" "local_date_time" "local_time" "float" "offset_date_time" "quoted_key" "string" "dotted_key" "bare_key"))) 
 ("quoted_key" (:*unnamed* ("escape_sequence"))) 
 ("string" (:*unnamed* ("escape_sequence"))) 
 ("table" (:*unnamed* ("bare_key" "quoted_key" "pair" "dotted_key"))) 
 ("table_array_element" (:*unnamed* ("bare_key" "quoted_key" "pair" "dotted_key"))) 
))

(defconst combobulate-rules-toml-inverted 
 '(("boolean" ("array" "pair"))
   ("inline_table" ("array" "pair"))
   ("array" ("array" "pair"))
   ("integer" ("array" "pair"))
   ("local_date" ("array" "pair"))
   ("local_date_time" ("array" "pair"))
   ("local_time" ("array" "pair"))
   ("float" ("array" "pair"))
   ("offset_date_time" ("array" "pair"))
   ("string" ("array" "pair"))
   ("table" ("document"))
   ("pair" ("table" "document" "table_array_element" "inline_table"))
   ("table_array_element" ("document"))
   ("bare_key" ("table" "pair" "dotted_key" "table_array_element"))
   ("quoted_key" ("table" "pair" "dotted_key" "table_array_element"))
   ("dotted_key" ("table" "pair" "dotted_key" "table_array_element"))
   ("escape_sequence" ("string" "quoted_key"))
  ) 
)
;; END production rules for toml





;; START Auto-generated production rules for `json'
(defconst combobulate-rules-json 
 '(("_value" (:*unnamed* ("string" "false" "number" "array" "null" "true" "object"))) 
 ("array" (:*unnamed* ("string" "false" "number" "array" "null" "true" "object"))) 
 ("document" (:*unnamed* ("string" "false" "number" "array" "null" "true" "object"))) 
 ("object" (:*unnamed* ("pair"))) 
 ("pair" (:key ("string" "number") :value ("string" "false" "number" "array" "null" "true" "object"))) 
 ("string" (:*unnamed* ("string_content"))) 
 ("string_content" (:*unnamed* ("escape_sequence"))) 
))

(defconst combobulate-rules-json-inverted 
 '(("string" ("array" "_value" "document" "pair"))
   ("false" ("array" "_value" "document" "pair"))
   ("number" ("array" "_value" "document" "pair"))
   ("array" ("array" "_value" "document" "pair"))
   ("null" ("array" "_value" "document" "pair"))
   ("true" ("array" "_value" "document" "pair"))
   ("object" ("array" "_value" "document" "pair"))
   ("pair" ("object"))
   ("string_content" ("string"))
   ("escape_sequence" ("string_content"))
  ) 
)
;; END production rules for json





(provide 'combobulate-rules)
